{  ----------------- SubRip 1.17 source -------------------
   This MultiLang unit was originally written by Pawel, author of DVD SubRipper.
   Brain have used and completed this unit with his permission.

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit MultiLang;

interface

uses Forms, UniCodeIniFiles, TntClasses, Classes, SysUtils, Menus, StdCtrls, ComCtrls, ExtCtrls,
  CheckLst, Spin, TntForms,  TntDialogs, TntMenus, TntComCtrls, TntStdCtrls,
  TntExtCtrls, TntCheckLst, TntButtons;

procedure WriteToFile(f: TTntForm; const s: WideString);
procedure LoadFromFile(f: TTntForm; const s: WideString);
procedure SaveStrings(TmpStrings: TTntStrings; const StSection, StIniFile: WideString);
procedure ReadStrings(TmpStrings: TTntStrings; const StSection, StIniFile: WideString);

implementation

procedure SaveComponent(Ini: TMemUniCodeIniFile; a: TComponent);
var
  i, k: Integer;
  tmp: TComponent;
  //----------
  procedure SaveCapHint(const CapHintName, CapHintText: WideString);
  begin
    Ini.WriteWideString(a.Name, tmp.Name + '.' + CapHintName, CapHintText);
  end;
  //----------
  procedure SaveMenu(a: TMenuItem; name, path: WideString); //const or var string not possible
  var
    i, ile: Integer;
    menu: TTntMenuItem;
  begin
    ile := a.Count;
    if ile = 0 then Exit;
    if path <> '' then path := path + '.';
    for i := 0 to ile - 1 do
    begin
      menu := TTntMenuItem(a.Items[i]);
      if (menu.Tag <> 666) and (menu.Caption <> '-') then
        Ini.WriteWideString(name, path + menu.Name, menu.Caption);
      SaveMenu(menu, name, path + menu.Name);
    end;
  end;
  //----------
begin
  if Length(a.Name) = 0 then Exit;
  tmp := a;
  if (tmp as TTntForm).Tag <> 666 then SaveCapHint('Caption', (tmp as TTntForm).Caption); //Form Name
  if a.ComponentCount = 0 then Exit;
  for i := 0 to a.ComponentCount - 1 do
  begin
    tmp := a.Components[i];

    //do not save following Components Captions/Hints
    if (tmp as TComponent).Tag = 666 then Continue;

    //Ini.WriteString(a.Name, a.Name + '.' + tmp.Name, tmp.ClassName);
    if tmp.ClassNameIs('TTntMainMenu') then SaveMenu((tmp as TTntMainMenu).Items, a.Name + '.' + tmp.Name, '');
    if tmp.ClassNameIs('TTntPopupMenu') then SaveMenu((tmp as TTntPopupMenu).Items, a.Name + '.' + tmp.Name, '');
    if tmp.ClassNameIs('TTntLabel') then begin
      SaveCapHint('Caption', (tmp as TTntLabel).Caption);
      if (tmp as TTntLabel).Hint <> '' then SaveCapHint('Hint', (tmp as TTntLabel).Hint);
    end;
    if tmp.ClassNameIs('TTntEdit') then begin
      SaveCapHint('Text', (tmp as TTntEdit).text);
      if (tmp as TTntEdit).Hint <> '' then SaveCapHint('Hint', (tmp as TTntEdit).Hint);
    end;
    if tmp.ClassNameIs('TTntButton') then begin
      SaveCapHint('Caption', (tmp as TTntButton).Caption);
      if (tmp as TTntButton).Hint <> '' then SaveCapHint('Hint', (tmp as TTntButton).Hint);
    end;
    if tmp.ClassNameIs('TTntBitBtn') then begin
      SaveCapHint('Caption', (tmp as TTntBitBtn).Caption);
      if (tmp as TTntBitBtn).Hint <> '' then SaveCapHint('Hint', (tmp as TTntBitBtn).Hint);
    end;
    if tmp.ClassNameIs('TTntRadioButton') then begin
      SaveCapHint('Caption', (tmp as TTntRadioButton).Caption);
      if (tmp as TTntRadioButton).Hint <> '' then SaveCapHint('Hint', (tmp as TTntRadioButton).Hint);
    end;
    if tmp.ClassNameIs('TTntRadioGroup') then begin
      SaveCapHint('Caption', (tmp as TTntRadioGroup).Caption);
      for k := 0 to ((tmp as TTntRadioGroup).Items.Count - 1) do
        SaveCapHint('Items' + IntToStr(k), (tmp as TTntRadioGroup).Items[k]);
      if (tmp as TTntRadioGroup).Hint <> '' then SaveCapHint('Hint', (tmp as TTntRadioGroup).Hint);
    end;
    if tmp.ClassNameIs('TTntCheckBox') then begin
      SaveCapHint('Caption', (tmp as TTntCheckBox).Caption);
      if (tmp as TTntCheckBox).Hint <> '' then SaveCapHint('Hint', (tmp as TTntCheckBox).Hint);
    end;
    if tmp.ClassNameIs('TTntCheckListBox') then
      if (tmp as TTntCheckListBox).Hint <> '' then SaveCapHint('Hint', (tmp as TTntCheckListBox).Hint);
    if tmp.ClassNameIs('TTntGroupBox') then begin
      SaveCapHint('Caption', (tmp as TTntGroupBox).Caption);
      if (tmp as TTntGroupBox).Hint <> '' then SaveCapHint('Hint', (tmp as TTntGroupBox).Hint);
    end;
    if tmp.ClassNameIs('TTntTabSheet') then begin
      SaveCapHint('Caption', (tmp as TTntTabSheet).Caption);
      if (tmp as TTntTabSheet).Hint <> '' then SaveCapHint('Hint', (tmp as TTntTabSheet).Hint);
    end;
    if tmp.ClassNameIs('TTntUpDown') then
      if (tmp as TTntUpDown).Hint <> '' then SaveCapHint('Hint', (tmp as TTntUpDown).Hint);
    if tmp.ClassNameIs('TTntPanel') then
    begin
      if (tmp as TTntPanel).Caption <> '' then SaveCapHint('Caption', (tmp as TTntPanel).Caption);
      if (tmp as TTntPanel).Hint <> '' then SaveCapHint('Hint', (tmp as TTntPanel).Hint);
    end;
    if tmp.ClassNameIs('TTntComboBox') then
      if (tmp as TTntComboBox).Hint <> '' then SaveCapHint('Hint', (tmp as TTntComboBox).Hint);
    if tmp.ClassNameIs('TTntShape') then
      if (tmp as TTntShape).Hint <> '' then SaveCapHint('Hint', (tmp as TTntShape).Hint);
    if tmp.ClassNameIs('TSpinEdit') then
    begin
      if (tmp as TSpinEdit).Hint <> '' then SaveCapHint('Hint', (tmp as TSpinEdit).Hint);
    end;
  end;
end;

procedure ReadComponent(Ini: TMemUniCodeIniFile; a: TComponent; IsCurrent: Boolean);
var
  i, k: Integer;
  tmp: TComponent;
  exists, oldpb: Boolean;
  ok: WideString;
  //----------
  function ReadCapHint(const CapHintName: WideString; var new: WideString): Boolean;
  begin
    Result := Ini.ValueExists(a.Name, tmp.Name + '.' + CapHintName);
    if Result then new := Ini.ReadWideString(a.Name, tmp.Name + '.' + CapHintName, '');
  end;
  //----------
  procedure ReadMenu(a: TMenuItem; name, path: WideString); //const or var string not possible
  var
    i, ile: Integer;
    menu: TTntmenuItem;
  begin
    ile := a.Count;
    if ile = 0 then Exit;
    if path <> '' then path := path + '.';
    for i := 0 to ile - 1 do
    begin
      menu := TTntMenuItem(a.Items[i]);
      if Ini.ValueExists(name, path + menu.Name) then
        menu.Caption := Ini.ReadWideString(name, path + menu.Name, '');
      ReadMenu(menu, name, path + menu.Name);
    end;
  end;
  //----------
begin
  if Pos('current.lng', Ini.FileName) > 0 then IsCurrent := True
  else IsCurrent := False;
  if Length(a.Name) = 0 then Exit;
  tmp := a;
  if ReadCapHint('Caption', ok) then (tmp as TTntForm).Caption := ok;
  if a.ComponentCount = 0 then Exit;
  for i := 0 to a.ComponentCount - 1 do
  begin
    tmp := a.Components[i];
    if tmp.ClassNameIs('TTntMainMenu') then
      ReadMenu((tmp as TTntMainMenu).Items, a.Name + '.' + tmp.Name, '');
    if tmp.ClassNameIs('TTntPopupMenu') then ReadMenu((tmp as TTntPopupMenu).Items, a.Name + '.' + tmp.Name, '');
    if tmp.ClassNameIs('TTntLabel') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntLabel).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntLabel).Hint := ok;
        (tmp as TTntLabel).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntLabel).Hint := '';
    end;
    if tmp.ClassNameIs('TTntEdit') then begin
      if ReadCapHint('Text', ok) then (tmp as TTntEdit).text := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntEdit).Hint := ok;
        (tmp as TTntEdit).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntEdit).Hint := '';
    end;
    if tmp.ClassNameIs('TTntButton') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntButton).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntButton).Hint := ok;
        (tmp as TTntButton).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntButton).Hint := '';
    end;
    if tmp.ClassNameIs('TTntBitBtn') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntBitBtn).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntBitBtn).Hint := ok;
        (tmp as TTntBitBtn).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntBitBtn).Hint := '';
    end;
    if tmp.ClassNameIs('TTntRadioButton') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntRadioButton).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntRadioButton).Hint := ok;
        (tmp as TTntRadioButton).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntRadioButton).Hint := '';
    end;
    if tmp.ClassNameIs('TTntRadioGroup') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntRadioGroup).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntRadioGroup).Hint := ok;
        (tmp as TTntRadioGroup).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntRadioGroup).Hint := '';
      for k := 0 to ((tmp as TTntRadioGroup).Items.Count - 1) do
      begin
        exists := ReadCapHint('Items' + IntToStr(k), ok);
        if exists then (tmp as TTntRadioGroup).Items[k] := ok;
      end;
    end;
    if tmp.ClassNameIs('TTntCheckBox') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntCheckBox).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntCheckBox).Hint := ok;
        (tmp as TTntCheckBox).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntCheckBox).Hint := '';
    end;
    if tmp.ClassNameIs('TTntCheckListBox') then begin
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntCheckListBox).Hint := ok;
        (tmp as TTntCheckListBox).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntCheckListBox).Hint := '';
    end;
    if tmp.ClassNameIs('TTntGroupBox') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntGroupBox).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntGroupBox).Hint := ok;
        (tmp as TTntGroupBox).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntGroupBox).Hint := '';
    end;
    if tmp.ClassNameIs('TTntTabSheet') then begin
      if ReadCapHint('Caption', ok) then (tmp as TTntTabSheet).Caption := ok;
      if ReadCapHint('Hint', ok) then begin
        (tmp as TTntTabSheet).Hint := ok;
        (tmp as TTntTabSheet).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntTabSheet).Hint := '';
    end;
    if (tmp.ClassNameIs('TTntUpDown')) then
      if (ReadCapHint('Hint', ok)) then
      begin
        (tmp as TTntUpDown).Hint := ok;
        (tmp as TTntUpDown).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntUpDown).Hint := '';
    if tmp.ClassNameIs('TTntPanel') then
    begin
      oldpb:=(tmp as TTntPanel).ParentBackground;//workaround for Delphi 7 bug
      (tmp as TTntPanel).ParentBackground:=true;
      (tmp as TTntPanel).ParentBackground:=false;
      (tmp as TTntPanel).ParentBackground:=oldpb;
      if ReadCapHint('Caption', ok) then (tmp as TTntPanel).Caption := ok;
      if ReadCapHint('Hint', ok) then
      begin
        (tmp as TTntPanel).Hint := ok;
        (tmp as TTntPanel).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntPanel).Hint := '';
    end;
    if (tmp.ClassNameIs('TTntComboBox')) then
      if (ReadCapHint('Hint', ok)) then
      begin
        (tmp as TTntComboBox).Hint := ok;
        (tmp as TTntComboBox).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntComboBox).Hint := '';
    if (tmp.ClassNameIs('TTntShape')) then
      if (ReadCapHint('Hint', ok)) then
      begin
        (tmp as TTntShape).Hint := ok;
        (tmp as TTntShape).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TTntShape).Hint := '';
    if (tmp.ClassNameIs('TSpinEdit')) then
      if (ReadCapHint('Hint', ok)) then
      begin
        (tmp as TSpinEdit).Hint := ok;
        (tmp as TSpinEdit).ShowHint := True;
      end
      else
        if IsCurrent then (tmp as TSpinEdit).Hint := '';
  end;
end;

//------------------------------------------------------------------------------

procedure SaveStrings(TmpStrings: TTntStrings; const StSection, StIniFile: WideString);
var
  I1: Integer;
  Ini: TMemUniCodeIniFile;
begin
  Ini := TMemUniCodeIniFile.Create(StIniFile);
  try
    ///TEMP - general change
    //TmpStrings[13]:= 'Subtitle timecodes are overlapping:';
    //TmpStrings[17]:= 'Cannot write to file';
    ///
    for I1 := 0 to TmpStrings.Count - 1 do
      Ini.WriteWideString(StSection, IntToStr(I1), TmpStrings[I1]);
    Ini.UpdateFile;
    Ini.Free;
  finally
  end;
end;

//------------------------------------------------------------------------------

procedure ReadStrings(TmpStrings: TTntStrings; const StSection, StIniFile: WideString);
var
  I1: Integer;
  Ini: TMemUniCodeIniFile;
  St1: WideString;
begin
  Ini := TMemUniCodeIniFile.Create(StIniFile);
  try
    //TmpStrings.Clear;
    I1 := 0;
    repeat
      St1 := Ini.ReadWideString(StSection, IntToStr(I1), '');
      if St1 <> '' then
        if TmpStrings.Count > I1 then
          TmpStrings[I1] := St1
        else
          TmpStrings.Add(St1);
      Inc(I1);
    until St1 = '';
    Ini.Free;
  finally
  end;
end;
//------------------------------------------------------------------------------

procedure WriteToFile(f: TTntForm; const s: WideString);
var Ini: TMemUniCodeIniFile;
begin
  Ini := TMemUniCodeIniFile.Create(s);
  try
    SaveComponent(Ini, f);
    Ini.UpdateFile;
    Ini.Free;
  finally
  end;
end;
//------------------------------------------------------------------------------

procedure LoadFromFile(f: TTntForm; const s: WideString);
var Ini: TMemUniCodeIniFile;
begin
  Ini := TMemUniCodeIniFile.Create(s);
  try
    if Pos('current.lng', s) > 0 then
      ReadComponent(Ini, f, True) //blank hints from current translation are set to blank string
    else
      ReadComponent(Ini, f, False); //(new?) hints from previous-read translation are preserved
  finally
    Ini.Free;
  end;
end;

end.
