unit Integer_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TInteger_u = class(TCustomEdit)
  private
    { Private declarations }
    FValmin: Integer;
    FValmax: Integer;
    FValeur: Integer;
    FErrorMsg: Boolean;
    procedure SetValeur(W0: Integer);
    procedure SetValMax(W0: Integer);
    procedure SetValMin(W0: Integer);
    procedure OnExitFocus(var Msg: TMessage); message Wm_KillFocus;
    function verifie: Boolean;
    function GetValeur: Integer;
    function GetValMax: Integer;
    function GetValMin: Integer;
  protected
    { Protected declarations }
    procedure KeyPress(var key: char); override;
  public
    { Public declarations }
    constructor Create(Aowner: Tcomponent); override;
  published
    { Published-dclarations }
    property ErrorMsg: boolean read FErrorMsg write FErrorMsg;
    property valeur: Integer read GetValeur write SetValeur;
    property ValMin: Integer read GetValMin write SetValMin;
    property ValMax: Integer read GetValMax write SetValMax;
    property ShowHint;
    property OnChange;
    property OnClick;
    property OnDBLClick;
    property OnEnter;
    property OnExit;
    property OnKeyPress;
  end;

procedure Register;

implementation

constructor TInteger_u.create(AOwner: Tcomponent);
begin
  inherited Create(AOwner);
  SetValMin(-2147483647);
  SetValMax(2147483647);
  Fvaleur := 0;
  MaxLength := 11;
  ShowHint := True;
  ErrorMsg := True;
  Text := IntToStr(Fvaleur);
end;

function TInteger_u.verifie;
var
  mini, maxi: string;
begin
  result := True;
  mini := IntToStr(valmin);
  maxi := IntToStr(valmax);
  if (Text = '') or (valeur < valmin) then
  begin
    if ErrorMsg then
      MessageDlg('< ' + mini + ' ; ' + maxi + ' >', MtWarning, [MbOk], 0);
    valeur := Valmin;
    result := False;
  end;
  if valeur > valmax then
  begin
    if ErrorMsg then
      MessageDlg('< ' + mini + ' ; ' + maxi + ' >', MtWarning, [MbOk], 0);
    valeur := Valmax;
    result := False;
  end;
end;

procedure TInteger_u.OnExitFocus(var Msg: Tmessage);
begin
  inherited;
  {if not} verifie {then SetFocus}; //SetFocus caused AV after ENTER (form close)
end;

procedure TInteger_u.KeyPress(var key: char);
begin
  if ((key > '9') or (key < '0')) and (Key <> '-') and (key <> #8) and (key <> #13) then key := #0;
  inherited KeyPress(key);
end;

function TInteger_u.GetValMax: Integer;
begin
  result := FValMax;
end;

procedure TInteger_u.SetValMax(W0: Integer);
begin
  FValMax := W0;
  if FValMax < FValMin then FvalMax := FvalMin;
  if FValeur > FValMax then FValMax := FValeur;
  Hint := IntToStr(FValMin) + '  -  ' + IntToStr(FValMax);
  if length(IntToStr(FValMin)) > length(IntToStr(FValMax)) then MaxLength := length(IntToStr(FValMin))
  else MaxLength := length(IntToStr(FValMax));
end;

function TInteger_u.GetValMin: Integer;
begin
  result := FValMin;
end;

procedure TInteger_u.SetValMin(W0: Integer);
begin
  FValMin := W0;
  if FValMin > FValMax then FvalMin := FvalMax;
  if FValeur < FValMin then FValMin := FValeur;
  Hint := IntToStr(FValMin) + '  -  ' + IntToStr(FValMax);
  if Length(IntToStr(FValMin)) > length(IntToStr(FValMax)) then MaxLength := length(IntToStr(FValMin))
  else MaxLength := length(IntToStr(FValMax));
end;

function TInteger_u.GetValeur: Integer;
var
  hj: integer;
  w1: integer;
begin
  val(text, w1, hj);
  if hj = 0 then FValeur := W1
  else FValeur := Valmin;
  result := Fvaleur;
end;

procedure TInteger_u.SetValeur(W0: Integer);
begin
  FValeur := W0;
  if FValeur > FValMax then FValeur := FValMax;
  if FValeur < FValMin then Fvaleur := FvalMin;
  Text := IntToStr(FValeur);
end;

procedure Register;
begin
  RegisterComponents('BrainC', [TInteger_u]);
end;

end.
