unit Word_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TWord_u = class(TCustomEdit)
  private
    { Private declarations }
    FValmin: Word;
    FValmax: Word;
    FValeur: Word;
    FErrorMsg: Boolean;
    procedure SetValeur(W0: word);
    procedure SetValMax(W0: word);
    procedure SetValMin(W0: word);
    procedure OnExitFocus(var Msg: TMessage); message Wm_KillFocus;
    function verifie: Boolean;
    function GetValeur: word;
    function GetValMax: word;
    function GetValMin: word;
  protected
    { Protected declarations }
    procedure KeyPress(var key: char); override;
  public
    { Public declarations }
    constructor Create(Aowner: TComponent); override;
  published
    { Published-dclarations }
    property ErrorMsg: boolean read FErrorMsg write FErrorMsg;
    property valeur: word read GetValeur write SetValeur;
    property ValMin: word read GetValMin write SetValMin;
    property ValMax: word read GetValMax write SetValMax;
    property ShowHint;
    property OnChange;
    property OnClick;
    property OnDBLClick;
    property OnEnter;
    property OnExit;
    property OnKeyPress;
  end;

procedure Register;

implementation

constructor Tword_u.Create(AOwner: Tcomponent);
begin
  inherited Create(AOwner);
  SetValMin(0);
  SetValMax(65535);
  Fvaleur := 0;
  MaxLength := 5;
  ShowHint := True;
  ErrorMsg := True;
  Text := IntToStr(Fvaleur);
end;

function TWord_u.verifie;
var
  mini, maxi: string;
begin
  result := True;
  mini := IntToStr(valmin);
  maxi := IntToStr(valmax);
  if (Text = '') or (valeur < valmin) then
  begin
    if ErrorMsg then
      MessageDlg('< ' + mini + ' ; ' + maxi + ' >', MtWarning, [MbOk], 0);
    valeur := Valmin;
    result := False;
  end;
  if valeur > valmax then
  begin
    if ErrorMsg then
      MessageDlg('< ' + mini + ' ; ' + maxi + ' >', MtWarning, [MbOk], 0);
    valeur := Valmax;
    result := False;
  end;
end;

procedure Tword_u.OnExitFocus(var Msg: TMessage);
begin
  inherited;
  {if not} verifie {then SetFocus}; //SetFocus caused AV after ENTER (form close)
end;

procedure TWord_U.KeyPress(var key: char);
begin
  if ((key > '9') or (key < '0')) and (key <> #8) and (key <> #13) then key := #0;
  inherited KeyPress(key);
end;

function TWord_u.GetValMax: word;
begin
  result := FValMax;
end;

procedure Tword_u.SetValMax(W0: word);
begin
  FValMax := W0;
  if FValMax < FValMin then FvalMax := FvalMin;
  if FValeur > FValMax then FValMax := FValeur;
  Hint := IntToStr(FValMin) + '  -  ' + IntToStr(FValMax);
  MaxLength := length(IntToStr(FValMax));
end;

function TWord_u.GetValMin: word;
begin
  Result := FValMin;
end;

procedure Tword_u.SetValMin(W0: word);
begin
  FValMin := W0;
  if FValMin > FValMax then FvalMin := FvalMax;
  if FValeur < FValMin then FValMin := FValeur;
  Hint := IntToStr(FValMin) + '  -  ' + IntToStr(FValMax);
end;

function Tword_u.GetValeur: word;
var
  hj: integer;
  w1: word;
begin
  val(text, w1, hj);
  if hj = 0 then FValeur := W1
  else FValeur := Valmin;
  result := Fvaleur;
end;

procedure Tword_u.SetValeur(W0: word);
begin
  FValeur := W0;
  if FValeur > FValMax then FValeur := FValMax;
  if FValeur < FValMin then Fvaleur := FvalMin;
  Text := IntToStr(FValeur);
end;

procedure Register;
begin
  RegisterComponents('BrainC', [TWord_u]);
end;

end.
