unit UCommon;

interface

uses
  Windows, SysUtils, Classes, Graphics, Forms, Unit01, Dialogs, TntDialogs;

// declare own bitmap file record, specifically for 256 colour bitmaps
type
  T256Palette = array[0..255] of TRGBQuad;
  P256Bitmap = ^T256Bitmap;
  T256Bitmap = packed record
    b256File: TBitmapFileHeader;
    b256Info: TBitmapInfoHeader;
    b256Pal: T256Palette;
    b256Data: record end;
  end;

procedure DooItDizWey(const TmpBmp: TBitmap; const StFileName: Widestring);

implementation

//GetDIBits seems not to be the ideal way for RLE compressing

//-- calls to video for windows dll --------------------------------------------

type
  PICInfo = ^TICInfo;
  TICInfo = packed record
    dwSize, // SizeOf (TICInfo)
      fccType, // compressor type eg vidc
      fccHandler, // compressor subtype eg rle
      dwFlags, // lo word is type specific
      dwVersion, // version of driver
      dwVersionICM: DWORD; // version of the ICM
    szName: array[0..15] of WCHAR; // short name
    szDescription: array[0..127] of WCHAR; // long name
    szDriver: array[0..127] of WCHAR; // driver that contains the compressor
  end;
  TICHandle = THandle;

const
  ICMODE_COMPRESS = 1;
  ICTYPE_VIDEO = ord('v') +
    ord('i') shl 8 +
    ord('d') shl 16 +
    ord('c') shl 24;

function ICLocate(fccType, fccHandler: DWORD; lpbiIn, lpbmOut: PBitmapInfoHeader; wFlags: word): TICHandle;
  stdcall; external 'msvfw32.dll' name 'ICLocate';

function ICGetInfo(Handle: TICHandle; var ICInfo: TICInfo; cb: DWORD): LRESULT;
  stdcall; external 'msvfw32.dll' name 'ICGetInfo';

function ICImageCompress(Handle: TICHandle; uiFlags: UINT; lpbiIn: PBitmapInfo;
  lpBits: pointer; lpbiOut: PBitmapInfo; lQuality: integer; plSize: PInteger): HBitmap;
  stdcall; external 'msvfw32.dll' name 'ICImageCompress';

function ICClose(Handle: TICHandle): LRESULT;
  stdcall; external 'msvfw32.dll' name 'ICClose';

//------------------------------------------------------------------------------

procedure DooItDizWey(const TmpBmp: TBitmap; const StFileName: Widestring);
  //----------
  //used RLE2BMP code from http://ipos.p.lodz.pl/files/
  //Copyright by Romuald Zylla (zylla@ck-sg.p.lodz.pl)
  procedure Cmpr4;
  var
    AA, BB: array[0..$0FFF] of Byte; {  4 KB }
    b0: Byte;
    sbmp, srle: Word;
    icb, ice, irb, ire, i, ii, j, jj, scanl, size, nsize,
      bfOffs, biWidth, biHeight, biCompress, biSizeImage: Integer;
    bfSize: Cardinal;
    fin: TStream;
    fio: TFileStream;
  begin
    fin := TMemorystream.Create;
    fio := TFileStream.Create(StFileName, fmCreate or fmShareExclusive);
    try
      TmpBmp.SaveToStream(fin);
      fin.Seek($A, soBeginning);
      fin.Read(bfOffs, 4);
      fin.Seek($4, soCurrent);
      fin.Read(biWidth, 4);
      fin.Read(biHeight, 4);
      fin.Position := 0;
      size := fin.Size;
      fio.Position := 0;

      { wyrwnanie szerokoci do wielokrotnoci 4 bajtw }
      sbmp := ((biWidth * 4 + 31) shr 3) and $FFFC;
      srle := ((biWidth * 4 + 7) shr 3);

      { kopiowanie nagwka wraz z palet }
      fin.Read(AA, bfOffs);
      fio.Write(AA, bfOffs);
      jj := bfOffs; nsize := bfOffs; scanl := 0;
      FillChar(AA, SizeOf(AA), 0);

      { w petli                         }
      repeat
        fin.Read(AA, sbmp);
        {     skompresuj linie pixeli     }
        AA[sbmp] := AA[sbmp - 1] xor $FF;
        AA[sbmp + 1] := AA[sbmp - 1];
        j := 0; ice := 0; icb := 0; b0 := AA[0];
        i := 1;
        repeat
          if AA[i] = b0 then
          begin irb := i - 1; ice := irb;
            repeat Inc(i)
            until AA[i] <> b0;
            if (i - irb >= 4) or
              ((i - irb >= 2) and (ice - icb < 2)) then
            begin
              ire := i;
              while ice > icb do
                case ice - icb of
                  0: { nic nie rb };
                  1: begin
                      BB[j] := 2; BB[j + 1] := AA[icb];
                      Inc(j, 2); icb := ice;
                    end;
                else begin { zapisz cytat }
                    ii := ice - icb;
                    if ii > 127 then ii := 127;
                    BB[j] := 0; BB[j + 1] := ii * 2;
                    Move(AA[icb], BB[j + 2], ii);
                    Inc(j, (ii + 3) and $FE);
                    Inc(icb, ii);
                  end
                end; { case ice-icb }
              while ire > irb do
              begin { zapisz repetycje }
                ii := ire - irb;
                if ii > 127 then ii := 127;
                BB[j] := ii * 2;
                BB[j + 1] := AA[irb];
                Inc(j, 2);
                Inc(irb, ii);
              end;
              icb := ire;
            end; { i-isb >=4 }
          end;
          b0 := AA[i]; Inc(i)
        until i > srle;
        if i >= srle then ice := srle;
        while ice > icb do
          case ice - icb of
            0: { nic nie rb };
            1: begin
                BB[j] := 2; BB[j + 1] := AA[icb];
                Inc(j, 2); icb := ice;
              end;
          else begin ii := ice - icb;
              if ii > 127 then ii := 127;
              BB[j] := 0; BB[j + 1] := ii * 2;
              Move(AA[icb], BB[j + 2], ii);
              Inc(j, (ii + 3) and $FE);
              Inc(icb, ii);
            end
          end; { of case ice-icb }
        BB[j] := 0; BB[j + 1] := 0; Inc(j, 2);
        {     zapisz na dysk te linie     }
        Inc(nsize, j); Inc(scanl);
        fio.Write(BB, j);
        Inc(jj, sbmp);
        { koniec petli                    }
      until (jj >= size) or (scanl >= biHeight);

      BB[0] := 1;
      fio.Seek(-1, soEnd); fio.Write(BB[0], 1);
      { oblicz nowe wartoci pl :      }
      {  bfSize biCompress biSizeImage  }
      bfSize := nsize;
      biCompress := BI_RLE4;
      biSizeImage := nsize - bfOffs;
      { zapisz zmodyfikowany nagwek   }
      fio.Seek(2, soBeginning); fio.Write(bfSize, 4);
      fio.Seek(30, soBeginning); fio.Write(biCompress, 4);
      fio.Seek(34, soBeginning); fio.Write(biSizeImage, 4);
    finally
      fin.Free; fio.Free;
    end;
  end;
  //----------
  //used "256 COLOUR BITMAP COMPRESSOR Version 1.00" code (rleexpt.zip from Torry)
  //Copyright by Grahame Marsh, 1 October 1997 (gsmarsh@aol.com)
  procedure Cmpr8;
  var
    fin: TMemoryStream;
    InSize, // copy of filesize
      InColours: integer; // number of colours
    Handle: THandle;
    CompressHandle: Integer;
    ICInfo: TICInfo;
    OutBitmap, InBitmap: P256Bitmap;
    CompressedStuff, OutData, InDataCopy: Pointer;
    OutSize: Cardinal;
    OutColours: Integer;
  begin
    fin := TMemoryStream.Create;
    try
      TmpBmp.SaveToStream(fin);
      InSize := fin.Size;
      GetMem(InBitmap, InSize);
      fin.Position := 0;
      fin.Read(InBitmap^, InSize);

      with InBitmap^ do
        // determine number of entries in palette
        if b256Info.biClrUsed = 0 then
          InColours := 256
        else
          InColours := b256Info.biClrUsed;
    finally
      fin.Free;
    end;

    // make an output bitmap file
    GetMem(OutBitmap, SizeOf(T256Bitmap));
    try
      // make a copy of the input file as we will play with the data
      InDataCopy := pointer(integer(InBitmap) + SizeOf(TBitmapFileHeader) +
        SizeOf(TBitmapInfoHeader) + InColours * SizeOf(TRGBQuad));

      // crunch the palette
      with InBitmap^ do
        OutColours := InColours;

      // now copy the input file to fill in most of the output bitmap values
      Move(InBitmap^, OutBitmap^, SizeOf(T256Bitmap));
      // set the compression required
      OutBitmap^.b256Info.biCompression := BI_RLE8;

      // find a compressor
      CompressHandle := ICLocate(ICTYPE_VIDEO, 0, @InBitmap^.b256Info,
        @OutBitmap.b256Info, ICMODE_COMPRESS);
      try
        FillChar(ICInfo, SizeOf(TICInfo), 0);
        ICInfo.dwSize := SizeOf(TICInfo);
        // get info on the compressor
        ICGetInfo(CompressHandle, ICInfo, SizeOf(TICInfo));
        OutSize := 0; // best compression
        // now compress the image
        Handle := ICImageCompress(CompressHandle, 0, @InBitmap^.b256Info,
          InDataCopy, @OutBitmap^.b256Info, 10000, @OutSize);
      finally
        ICClose(CompressHandle)
      end;

      if Handle <> 0 then
      begin
        // get the compressed data
        CompressedStuff := GlobalLock(Handle);
        try
          // modify the filesize and offset in case palette has shrunk
          with OutBitmap^.b256File do
          begin
            bfOffBits := SizeOf(TBitmapFileHeader) + SizeOf(TBitmapInfoHeader) +
              OutColours * SizeOf(TRGBQuad);
            bfSize := bfOffBits + OutSize
          end;
          // locate the data
          OutData := pointer(integer(CompressedStuff) +
            SizeOf(TBitmapInfoHeader) + InColours * SizeOf(TRGBQuad));

          // modify the bitmap info header
          with OutBitmap^.b256Info do
          begin
            biSizeImage := OutSize;
            biClrUsed := OutColours;
            biClrImportant := 0
          end;

          // save the bitmap to disc
          with TFileStream.Create(StFileName, fmCreate) do
          try
            Write(OutBitmap^, SizeOf(TBitmapFileHeader) + SizeOf(TBitmapInfoHeader));
            Write(InBitmap^.b256Pal, OutColours * SizeOf(TRGBQuad));
            Write(OutData^, OutSize)
          finally
            Free
          end;
          // now tidy up
        finally
          GlobalUnlock(Handle)
        end
      end
      else
//        MessageBox(Application.Handle, 'Bitmap could not be compressed', PChar(MsgStr[72]), MB_OK or MB_ICONERROR);
      WideMessageDlg('Bitmap could not be compressed', mtError, [mbOk],0);
      FreeMem(InBitmap, InSize);
    finally
      FreeMem(OutBitmap, SizeOf(T256Bitmap))
    end;
  end;
  //----------
begin
  if TmpBmp.PixelFormat = pf4bit then Cmpr4
  else Cmpr8; //pf8bit
end;

end.

