{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit UConfig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Menus, UniCodeIniFiles, Unit01, MultiLang, Registry,
  TntSysUtils, TntClasses;

var
  AppzDir: Widestring;
  LanguageFileName: Widestring;

procedure LoadConfig;
procedure SaveConfigGeneral;
procedure SaveConfigOCR;
procedure SaveBMPProfile(const TmpFileName: Widestring);
procedure LoadBMPProfile(const TmpFileName: Widestring);
procedure ScanLanguageFiles;
procedure LoadLanguageFile(StFileName: Widestring);
procedure SetOcrDefaultValues; //Regle les valeurs par defaut pour l'ocr
procedure SetDefaultMsgStr;

const
  DefBMPOutColor: TArray4TColor = ($00000000, $00FFFFFF, $00FF0000, $00808080); //Default custom Colors used for BMP Out
  DefIAuthorColor: TArray4TColor = ($00000000, $00FFFFFF, $00000000, $00808080); //Default Colors used for BMP Out

  DefContrast: TArray4ColorIndex = (0, 15, 15, 15);
  ChMatrixFolder = 'ChMatrix\';

implementation

uses Unit02, Unit03, Unit04, Unit05, Unit06, Unit07, Unit10, Unit11, Unit12,
  Unit13, Unit14, Unit15, Unit16, Unit17, Unit18, Unit19, Unit20, Unit21, Unit22, Unit23,
  Math, TntMenus;

//------------------------------------------------------------------------------

procedure ScanLanguageFiles;
var
  Rec: TSearchRecW;
  NewItem: TTntMenuItem;
  StArr: TTntStringList;
  I1: Integer;
begin
  StArr := TTntStringList.Create;
  try
    if WideFindFirst(AppzDir + 'Lang\*.lng', faAnyfile, Rec) = 0 then
      StArr.Add(Copy(Rec.Name, 1, Length(Rec.Name) - 4));
    while WideFindNext(Rec) = 0 do
      StArr.Add(Copy(Rec.Name, 1, Length(Rec.Name) - 4));
    WideFindClose(Rec);

    StArr.Sort;
    for I1 := 0 to StArr.Count - 1 do
    begin
      NewItem := TTntMenuItem.Create(Form1.GUILanguage1);
      NewItem.Caption := StArr[I1];
      NewItem.Name := 'Language' + IntToStr(I1 + 1);
      NewItem.Checked := StArr[I1] = LanguageFileName;
      NewItem.OnClick := Form1.LanguageClick;

      Form1.GUILanguage1.Add(NewItem);
    end;
  finally
    StArr.Free;
  end;
end;

//------------------------------------------------------------------------------

procedure LoadConfig;
const
  DefSSAColor: TArray4TColor = ($0080FFFF, $0080FFFF, $0080FFFF, $00000000);
var
  Fich: TMemUniCodeIniFile;
  B1: Byte;
  Tag: Byte; //for priority setting
  Reg: TRegistry;
  LngCode: Word;
  cp:Widestring;
begin
  fich := TMemUniCodeIniFile.Create(AppzDir + IniConfigFileName);
  try
    //************* General Setting **************
    Form1.OpenDialogCharMatrix.InitialDir := fich.ReadWideString('CONFIG', 'OpenDialogCharMatrix', AppzDir + ChMatrixFolder);
    Form1.SaveDialogCharMatrix.InitialDir := fich.ReadWideString('CONFIG', 'SaveDialogCharMatrix', AppzDir + ChMatrixFolder);
    Form1.SaveDialogBmpSup.InitialDir := fich.ReadWideString('CONFIG', 'SaveDialogBmpSup', AppzDir);

    Form6.OpenDialogVob.InitialDir := fich.ReadWideString('CONFIG', 'OpenDialogVob', AppzDir);

    Form2.RememberCheckBox.Checked := fich.ReadBool('CONFIG', 'RememberStyles', True);

    Form3.OpenDialogSubRipText.InitialDir := fich.ReadWideString('CONFIG', 'OpenDialogSubRipText', AppzDir);
    Form3.SaveDialogText.InitialDir := fich.ReadWideString('CONFIG', 'SaveDialogText', AppzDir);

    Form17.OpenAvi.InitialDir := fich.ReadWideString('CONFIG', 'OpenAvi', AppzDir);

    LanguageFileName := fich.ReadWideString('CONFIG', 'LanguageFileName', '1stRun');
    if LanguageFileName = '1stRun' then
    begin
      Reg := TRegistry.Create;
      try
        Reg.RootKey := HKEY_CURRENT_USER;
        if Reg.OpenKeyReadOnly('\Software\SubRip') then //NSIS2
        begin
          LngCode := StrToIntDef(Reg.ReadString('Installer Language'), 0);
          case LngCode of
            1036: LanguageFileName := 'Francais';
            1031: LanguageFileName := 'Deutsch';
            1034: LanguageFileName := 'Spanish (Castellano)';
            1027: LanguageFileName := 'Catalan';
            1046: LanguageFileName := 'Portuguese (Brazilian)';
            1040: LanguageFileName := 'Italiano';
            1043: LanguageFileName := 'Nederlands';
            1030: LanguageFileName := 'Dansk';
            1045: LanguageFileName := 'Polski';
            1029: LanguageFileName := 'Czech';
            1051: LanguageFileName := 'Slovak';
            1038: LanguageFileName := 'Hungarian';
            1050: LanguageFileName := 'Croatian 1';
            1026: LanguageFileName := 'Bulgarian';
            1032: LanguageFileName := 'Greek';
            1055: LanguageFileName := 'Turkish';
            2052: LanguageFileName := 'Simplified Chinese';
          else LanguageFileName := '';
          end;
        end;
      finally
        Reg.Free;
      end;
    end;

    Form3.CheckBoxScrollDown.Checked := fich.ReadBool('CONFIG', 'AutoScrollDown', True);
    Form3.CheckBoxFormat.Checked := fich.ReadBool('CONFIG', 'FancyFormat', True);
    Form6.RadioGroupAction.ItemIndex := fich.ReadInteger('CONFIG', 'ActionMode', 0);
    Form6.CheckBoxAvoidTimeRestart.Checked := fich.ReadBool('CONFIG', 'AvoidTimeRestart', False);

    Form6.CheckBoxShowAll.Checked := fich.ReadBool('CONFIG', 'ShowAllLangStreams', False);
    Form6.SelectAllCheckBox.Checked := fich.ReadBool('CONFIG', 'SelectAllVOBs', True);

    Form3.Height := Min(fich.ReadInteger('CONFIG', 'SubtWndHeight', Form3.Height), Form1.BevelScreen.Height);

    //************* Global Options **************
    Form16.WakeChBox.Checked := fich.ReadBool('GOPTIONS', 'WakeMeUp', True);
    Form16.ForcedChBox.Checked := fich.ReadBool('GOPTIONS', 'ForcedSubs', False);
    Form16.ChBoxR2L.Checked := fich.ReadBool('GOPTIONS', 'Right2Left', False);
    Form16.rbFill.Checked := fich.ReadBool('GOPTIONS', 'FillBestGuess', False);
    Form16.cbAddToCharMatrix.Checked := fich.ReadBool('GOPTIONS', 'AddBestGuessToCharMatrix', false);
    Form16.seFill.Value := fich.ReadInteger('GOPTIONS', 'FillBestGuessDelay', 10);
    Form16.eFillNone.Text := fich.ReadWideString('GOPTIONS', 'FillNoBestGuess', '*');
    Form16.eBefore.Text := fich.ReadWideString('GOPTIONS', 'FillBeforeBestGuess', '[');
    Form16.eAfter.Text := fich.ReadWideString('GOPTIONS', 'FillAfterBestGuess', ']');
    Form16.rbClick(Form16);
    cp:=fich.ReadWideString('GOPTIONS', 'SubWindowFontName', 'Arial Unicode MS');
    if Screen.Fonts.IndexOf(cp)<0 then
    begin
      if Screen.Fonts.IndexOf('Tahoma')>=0 then cp:='Tahoma'
      else if Screen.Fonts.IndexOf('Arial')>=0 then cp:='Arial';
    end;
    Form3.cbFontName.Text := cp;
    Form3.seFontSize.Value:=fich.ReadInteger('GOPTIONS', 'SubWindowFontSize', 8);
    Form1.Process.AppCharset := Form10.GetUsedCharSet;
    cp:=fich.ReadWideString('GOPTIONS', 'CodePage', '1252:ANSI - Latin I');
    Form3.cbCodePage.ItemIndex := Form3.cbCodePage.Items.IndexOf(cp);
    Form3.cbCodePageChange(Form3.cbCodePage);
    Form16.SpinEditMinTime.Value := fich.ReadInteger('GOPTIONS', 'MinSubDuration', 200);
    Form16.CheckBoxBuildMap.Checked := fich.ReadBool('GOPTIONS', 'BuildMap', True);
    Form16.CheckBoxUseFileOffsets.Checked := fich.ReadBool('GOPTIONS', 'UseFileOffsets', True);
    Form16.SpinEditMinTMP.Value := fich.ReadInteger('GOPTIONS', 'MinTMP', 500);
    Form16.SpinEditMaxTMP.Value := fich.ReadInteger('GOPTIONS', 'MaxTMP', 2500);

    //************* Priority Setting **************
    Tag := fich.ReadInteger('CONFIG', 'Priority', 1);
    case Tag of
      0:
        begin
          SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
          Form1.IDLEPRIORITYCLASS1.Checked := True;
        end;
      1:
        begin
          SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
          Form1.NORMALPRIORITYCLASS1.Checked := True;
        end;
      2:
        begin
          SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
          Form1.HIGHPRIORITYCLASS1.Checked := True;
        end;
      3:
        begin
          SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
          Form1.REALTIMEPRIORITYCLASS1.Checked := True;
        end;
    end;

    //************* Preview Setting **************
    Form1.PreviewCFG.AtTruePos := fich.ReadBool('PREVIEW CFG', 'AtTruePos', True);
    Form1.PreviewCFG.TransparentBkGrd := fich.ReadBool('PREVIEW CFG', 'TransparentBkGrd', False);
    Form1.PreviewCFG.Zoom := fich.ReadInteger('PREVIEW CFG', 'Zoom', 1000);
    Form1.PreviewCFG.AutoZoom := fich.ReadBool('PREVIEW CFG', 'AutoZoom', False);
    Form1.PreviewCFG.BorderColor := fich.ReadInteger('PREVIEW CFG', 'BorderColor', $006D6F8B);
    Form1.PreviewCFG.InnerColor := fich.ReadInteger('PREVIEW CFG', 'InnerColor', $00C7BABB);
    Form1.PreviewCFG.BackMode := fich.ReadInteger('PREVIEW CFG', 'BackMode', 0);
    Form1.PreviewCFG.AspectRatioMode := fich.ReadInteger('PREVIEW CFG', 'AspectRatioMode', 0);
    Form1.PreviewCFG.FreeAspectRatio := fich.ReadInteger('PREVIEW CFG', 'FreeAspectRatio', 30);
    Form1.PreviewCFG.BackImageName := fich.ReadWideString('PREVIEW CFG', 'BackImageName', '');

    //************* OCR Setting **************
    with Form1 do
    begin
      OCR.MinLineHeight := fich.ReadInteger('OCR SETTING', 'MinLineHeight', OCR.MinLineHeight);
      OCR.MaxLineHeight := fich.ReadInteger('OCR SETTING', 'MaxLineHeight', OCR.MaxLineHeight);
      OCR.MinInterLine := fich.ReadInteger('OCR SETTING', 'MinInterLine', OCR.MinInterLine);

      OCR.MinCharWidth := fich.ReadInteger('OCR SETTING', 'MinCharWidth', OCR.MinCharWidth);
      OCR.MinCharHeight := fich.ReadInteger('OCR SETTING', 'MinCharHeight', OCR.MinCharHeight);
      OCR.SpaceWidth := fich.ReadInteger('OCR SETTING', 'SpaceWidth', OCR.SpaceWidth);
      //OCR.ItaSpaceWidth  := fich.ReadInteger ('OCR SETTING','ItaSpaceWidth'   , OCR.ItaSpaceWidth);
      //OCR.DetectItaWidth := fich.ReadInteger ('OCR SETTING','DetectItaWidth'  , OCR.DetectItaWidth);

      OCR.CheckDetachedChar := fich.ReadBool('OCR SETTING', 'CheckDetachedChar', OCR.CheckDetachedChar);

      OCR.Sensibility := fich.ReadInteger('OCR SETTING', 'Sensibility', OCR.Sensibility);
      OCR.MaxCharDiffWidth := fich.ReadInteger('OCR SETTING', 'MaxCharDiffWidth', OCR.MaxCharDiffWidth);
      OCR.MaxCharDiffHeight := fich.ReadInteger('OCR SETTING', 'MaxCharDiffHeight', OCR.MaxCharDiffHeight);
      OCR.MaxCharDiffTop := fich.ReadInteger('OCR SETTING', 'MaxCharDiffTop', OCR.MaxCharDiffTop);
    end;

    //************* BMP Out TC & Resolution Setting **************
    Form6.CheckBoxPictTiming.Checked := fich.ReadBool('BMP OUT TC & RES', 'Enabled', True);
    Form13.OutPut.DropFrame := fich.ReadBool('BMP OUT TC & RES', 'DropFrame', True);

    //************* Text Output Setting **************
    with Form13 do begin
      //active output format page
      Form3.TxtFile.OutputFormat := fich.ReadInteger('CONFIG', 'ActivePage', OFSubRip);
      //SubRip
      OutPut.SubRip.Extended := fich.ReadBool('SUBRIP OUTPUT', 'Extended', False);
      OutPut.SubRip.ClrTags := fich.ReadBool('SUBRIP OUTPUT', 'ClrTags', False);
      //MDVD
      MDVDComboBox.Text := fich.ReadWideString('MDVD', 'Framerate', '23.976');
      ComboBoxMpl.Text := MDVDComboBox.Text;
      ComboBoxMacSUB.Text := MDVDComboBox.Text;
      ComboBoxPhoenix.Text := MDVDComboBox.Text;
      Form3.ComboBoxFPS.Text := MDVDComboBox.Text;
      DXG400CheckBox.Checked := fich.ReadBool('MDVD', 'DXG400FPSInfo', True);
      //TMPlayer
      OutPut.TMPlayer.TMPlType := fich.ReadInteger('TMPLAYER OUTPUT', 'TMPlType', 1);
      //SubV2
      Output.SubV2.PresStyles := fich.ReadBool('SUBVIEWER2 OUTPUT', 'PreserveStyles', False);
      //----------
      //changed by mrSHADOW (mrshadow@howto.pl)
      Output.SubV2.SelFont := Form13.StrToFont(fich.ReadWideString('SUBVIEWER2 OUTPUT', 'SelFont', 'Arial,18,0,Bold'));
      //----------
      //STL
      for B1 := 0 to 3 do
        OutPut.STL.Color[B1] := fich.ReadInteger('STL OUTPUT', 'Color_' + IntToStr(B1), DefIAuthorColor[3 - B1]);
      for B1 := 0 to 3 do
        OutPut.STL.Contrast[B1] := fich.ReadInteger('STL OUTPUT', 'Contrast_' + IntToStr(B1), DefContrast[3 - B1]);
      Output.STL.HAlign := fich.ReadInteger('STL OUTPUT', 'HAlign', 1);
      Output.STL.HOffset := fich.ReadInteger('STL OUTPUT', 'HOffset', 0);
      Output.STL.VAlign := fich.ReadInteger('STL OUTPUT', 'VAlign', 2);
      Output.STL.VOffset := fich.ReadInteger('STL OUTPUT', 'VOffset', 2);
      //----------
      //changed by mrSHADOW (mrshadow@howto.pl)
      Output.STL.SelFont := Form13.StrToFont(fich.ReadWideString('STL OUTPUT', 'SelFont', 'Arial,36,0,Bold'));
      //----------
      //SSA
      for B1 := 0 to 3 do
        OutPut.SSA.Color[B1] := fich.ReadInteger('SSA OUTPUT', 'Color_' + IntToStr(B1), DefSSAColor[B1]);
      OutPut.SSA.VMargin := fich.ReadInteger('SSA OUTPUT', 'VMargin', 30);
      OutPut.SSA.BMargin := fich.ReadInteger('SSA OUTPUT', 'BMargin', 25);
      OutPut.SSA.Border := fich.ReadInteger('SSA OUTPUT', 'Border', 2);
      OutPut.SSA.Shadow := fich.ReadInteger('SSA OUTPUT', 'Shadow', 2);
      //----------
      //changed by mrSHADOW (mrshadow@howto.pl)
      Output.SSA.SelFont := Form13.StrToFont(fich.ReadWideString('SSA OUTPUT', 'SelFont', 'Arial,28,0'));
      //----------
      //IAuthor
      OutPut.IAuthor.MinimumInterval := fich.ReadInteger('IAUTHOR OUTPUT', 'MinimumInterval', 10);
      //Maestro
      OutPut.DVDMaestro.Extended := fich.ReadBool('DVDMAESTRO OUTPUT', 'Extended', True);
    end;
    //************* Text Input Setting **************
    Form3.InputType := fich.ReadInteger('INPUT', 'InPutType', 7);
    //************* OCR Correction Setting **********
    Form10.CheckBoxCorrectTwiceAp.Checked :=
      fich.ReadBool('OCRCORRECTION', 'TwiceAp', True);
    Form10.CheckBoxCorrectIl.Checked :=
      fich.ReadBool('OCRCORRECTION', 'Il', True);
    Form10.RadioGroupCorrectIlLanguage.ItemIndex :=
      fich.ReadInteger('OCRCORRECTION', 'Il_Index', 0);
    Form10.CheckBoxCorrectPunctuation.Checked :=
      fich.ReadBool('OCRCORRECTION', 'Punctuation', True);
    Form10.CheckBoxCorrectOrthography.Checked :=
      fich.ReadBool('OCRCORRECTION', 'Orthography', False);
    Form10.ComboBoxLangOrtho.Items.Add
      (fich.ReadWideString('OCRCORRECTION', 'OrthographyDic', ''));
    Form10.ComboBoxLangOrtho.ItemIndex := 0;
    Form10.CheckBoxCorrectCapitalLetters.Checked :=
      fich.ReadBool('OCRCORRECTION', 'CapitalLetters', True);
    Form10.CheckBoxCase.Checked :=
      fich.ReadBool('OCRCORRECTION', 'LowerCaseB4', False);
    Form10.CheckBoxRemoveSpaceBtNumbers.Checked :=
      fich.ReadBool('OCRCORRECTION', 'RemoveSpaceBtNumbers', True);
  finally
    Fich.Free;
  end;
end;

//------------------------------------------------------------------------------

procedure SaveConfigGeneral;
var
  fich: TMemUniCodeIniFile;
  B1: Byte;
begin
  fich := TMemUniCodeIniFile.Create(AppzDir + IniConfigFileName);
  try
    with Form1 do begin
      //************* General Setting **************
      fich.WriteWideString('CONFIG', 'OpenDialogCharMatrix', Form1.OpenDialogCharMatrix.InitialDir);
      fich.WriteWideString('CONFIG', 'SaveDialogCharMatrix', Form1.SaveDialogCharMatrix.InitialDir);
      fich.WriteWideString('CONFIG', 'SaveDialogBmpSup', Form1.SaveDialogBmpSup.InitialDir);

      fich.WriteWideString('CONFIG', 'OpenDialogVob', Form6.OpenDialogVob.InitialDir);

      fich.WriteBool('CONFIG', 'RememberStyles', Form2.RememberCheckBox.Checked);

      fich.WriteWideString('CONFIG', 'OpenDialogSubRipText', Form3.OpenDialogSubRipText.InitialDir);
      fich.WriteWideString('CONFIG', 'SaveDialogText', Form3.SaveDialogText.InitialDir);

      fich.WriteWideString('CONFIG', 'OpenAvi', Form17.OpenAvi.InitialDir);

      fich.WriteWideString('CONFIG', 'LanguageFileName', LanguageFileName);
      fich.WriteBool('CONFIG', 'AutoScrollDown', Form3.CheckBoxScrollDown.Checked);
      fich.WriteBool('CONFIG', 'FancyFormat', Form3.CheckBoxFormat.Checked);

      fich.WriteInteger('CONFIG', 'ActionMode', Form6.RadioGroupAction.ItemIndex);
      fich.WriteBool('CONFIG', 'AvoidTimeRestart', Form6.CheckBoxAvoidTimeRestart.Checked);

      fich.WriteBool('CONFIG', 'ShowAllLangStreams', Form6.CheckBoxShowAll.Checked);
      fich.WriteBool('CONFIG', 'SelectAllVOBs', Form6.SelectAllCheckBox.Checked);

      //************* Priority Setting **************
      if Form1.IDLEPRIORITYCLASS1.Checked
        then fich.WriteInteger('CONFIG', 'Priority', 0)
      else
        if Form1.NORMALPRIORITYCLASS1.Checked
          then fich.WriteInteger('CONFIG', 'Priority', 1)
        else
          if Form1.HIGHPRIORITYCLASS1.Checked
            then fich.WriteInteger('CONFIG', 'Priority', 2)
          else
            if Form1.REALTIMEPRIORITYCLASS1.Checked
              then fich.WriteInteger('CONFIG', 'Priority', 3);

      fich.WriteInteger('CONFIG', 'SubtWndHeight', Form3.Height);

      //************* Global Options **************
      fich.WriteBool('GOPTIONS', 'WakeMeUp', Form16.WakeChBox.Checked);
      fich.WriteBool('GOPTIONS', 'ForcedSubs', Form16.ForcedChBox.Checked);
      fich.WriteBool('GOPTIONS', 'Right2Left', Form16.ChBoxR2L.Checked);
      fich.WriteBool('GOPTIONS', 'FillBestGuess', Form16.rbFill.Checked);
      fich.WriteBool('GOPTIONS', 'AddBestGuessToCharMatrix', Form16.cbAddToCharMatrix.Checked);
      fich.WriteInteger('GOPTIONS', 'FillBestGuessDelay', Form16.seFill.Value);
      fich.WriteWideString('GOPTIONS', 'FillNoBestGuess', Form16.eFillNone.Text);
      fich.WriteWideString('GOPTIONS', 'FillBeforeBestGuess', Form16.eBefore.Text);
      fich.WriteWideString('GOPTIONS', 'FillAfterBestGuess', Form16.eAfter.Text);
//      fich.WriteWideString('GOPTIONS', 'CharSet', Form3.ComboboxCharSet.Text);
      fich.WriteInteger('GOPTIONS', 'MinSubDuration', Form16.SpinEditMinTime.Value);
      fich.WriteBool('GOPTIONS', 'BuildMap', Form16.CheckBoxBuildMap.Checked);
      fich.WriteBool('GOPTIONS', 'UseFileOffsets', Form16.CheckBoxUseFileOffsets.Checked);
      fich.WriteInteger('GOPTIONS', 'MinTMP', Form16.SpinEditMinTMP.Value);
      fich.WriteInteger('GOPTIONS', 'MaxTMP', Form16.SpinEditMaxTMP.Value);
//      fich.WriteWideString('GOPTIONS', 'CodePage', Form3.cbCodePage.Text);
      fich.WriteWideString('GOPTIONS', 'SubWindowFontName', Form3.ListBoxSubtitle.Font.Name);
      fich.WriteInteger('GOPTIONS', 'SubWindowFontSize', Form3.ListBoxSubtitle.Font.Size);

      //************* Preview Setting **************
      fich.WriteBool('PREVIEW CFG', 'AtTruePos', PreviewCFG.AtTruePos);
      fich.WriteBool('PREVIEW CFG', 'TransparentBkGrd', PreviewCFG.TransparentBkGrd);
      fich.WriteInteger('PREVIEW CFG', 'Zoom', PreviewCFG.Zoom);
      fich.WriteBool('PREVIEW CFG', 'AutoZoom', PreviewCFG.AutoZoom);
      fich.WriteInteger('PREVIEW CFG', 'BorderColor', PreviewCFG.BorderColor);
      fich.WriteInteger('PREVIEW CFG', 'InnerColor', PreviewCFG.InnerColor);
      fich.WriteInteger('PREVIEW CFG', 'BackMode', PreviewCFG.BackMode);
      fich.WriteInteger('PREVIEW CFG', 'AspectRatioMode', PreviewCFG.AspectRatioMode);
      fich.WriteInteger('PREVIEW CFG', 'FreeAspectRatio', PreviewCFG.FreeAspectRatio);
      fich.WriteWideString('PREVIEW CFG', 'BackImageName', PreviewCFG.BackImageName);
      //************* BMP Out TC & Resolution Setting **************
      fich.WriteBool('BMP OUT TC & RES', 'Enabled', Form6.CheckBoxPictTiming.Checked);
      fich.WriteBool('BMP OUT TC & RES', 'DropFrame', Form13.OutPut.DropFrame);
    end;
    //************* Text OutPut Setting **************
    with Form13 do begin
      //active output format page
      fich.WriteInteger('CONFIG', 'ActivePage', Form3.TxtFile.OutputFormat);
      //SubRip
      fich.WriteBool('SUBRIP OUTPUT', 'Extended', OutPut.SubRip.Extended);
      fich.WriteBool('SUBRIP OUTPUT', 'ClrTags', OutPut.SubRip.ClrTags);
      //MDVD
      fich.WriteWideString('MDVD', 'Framerate', MDVDComboBox.Text);
      fich.WriteBool('MDVD', 'DXG400FPSInfo', DXG400CheckBox.Checked);
      //TMPlayer
      fich.WriteInteger('TMPLAYER OUTPUT', 'TMPlType', OutPut.TMPlayer.TMPlType);
      //SubV2
      fich.WriteBool('SUBVIEWER2 OUTPUT', 'PreserveStyles', Output.SubV2.PresStyles);
      fich.WriteWideString('SUBVIEWER2 OUTPUT', 'SelFont', FontToStr(Output.SubV2.SelFont));
      //STL
      for B1 := 0 to 3 do
        fich.WriteInteger('STL OUTPUT', 'Color_' + IntToStr(B1), OutPut.STL.Color[B1]);
      for B1 := 0 to 3 do
        fich.WriteInteger('STL OUTPUT', 'Contrast_' + IntToStr(B1), OutPut.STL.Contrast[B1]);
      fich.WriteInteger('STL OUTPUT', 'HAlign', Output.STL.HAlign);
      fich.WriteInteger('STL OUTPUT', 'HOffset', Output.STL.HOffset);
      fich.WriteInteger('STL OUTPUT', 'VAlign', Output.STL.VAlign);
      fich.WriteInteger('STL OUTPUT', 'VOffset', Output.STL.VOffset);
      fich.WriteWideString('STL OUTPUT', 'SelFont', FontToStr(Output.STL.SelFont));
      //SSA
      for B1 := 0 to 3 do
        fich.WriteInteger('SSA OUTPUT', 'Color_' + IntToStr(B1), OutPut.SSA.Color[B1]);
      fich.WriteInteger('SSA OUTPUT', 'VMargin', OutPut.SSA.VMargin);
      fich.WriteInteger('SSA OUTPUT', 'BMargin', OutPut.SSA.BMargin);
      fich.WriteInteger('SSA OUTPUT', 'Border', OutPut.SSA.Border);
      fich.WriteInteger('SSA OUTPUT', 'Shadow', OutPut.SSA.Shadow);
      fich.WriteWideString('SSA OUTPUT', 'SelFont', FontToStr(Output.SSA.SelFont));
      //IAuthor
      fich.WriteInteger('IAUTHOR OUTPUT', 'MinimumInterval', OutPut.IAuthor.MinimumInterval);
      //Maestro
      fich.WriteBool('DVDMAESTRO OUTPUT', 'Extended', OutPut.DVDMaestro.Extended);
    end;

    //************* Text InPut Setting **************
    //active
    fich.WriteInteger('INPUT', 'InPutType', Form3.InputType);

    //************* OCR Correction Setting **********
    fich.WriteBool('OCRCORRECTION', 'TwiceAp', Form10.CheckBoxCorrectTwiceAp.Checked);
    fich.WriteBool('OCRCORRECTION', 'Il', Form10.CheckBoxCorrectIl.Checked);
    fich.WriteInteger('OCRCORRECTION', 'Il_Index', Form10.RadioGroupCorrectIlLanguage.ItemIndex);
    fich.WriteBool('OCRCORRECTION', 'Punctuation', Form10.CheckBoxCorrectPunctuation.Checked);
    fich.WriteBool('OCRCORRECTION', 'Orthography', Form10.CheckBoxCorrectOrthography.Checked);
    fich.WriteWideString('OCRCORRECTION', 'OrthographyDic', Form10.ComboBoxLangOrtho.Text);
    fich.WriteBool('OCRCORRECTION', 'CapitalLetters', Form10.CheckBoxCorrectCapitalLetters.Checked);
    fich.WriteBool('OCRCORRECTION', 'LowerCaseB4', Form10.CheckBoxCase.Checked);
    fich.WriteBool('OCRCORRECTION', 'RemoveSpaceBtNumbers', Form10.CheckBoxRemoveSpaceBtNumbers.Checked);
  finally
    Fich.UpdateFile;
    Fich.Free;
  end;
end;

//------------------------------------------------------------------------------

procedure SaveBMPProfile(const TmpFileName: Widestring);
var
  fich: TMemUniCodeIniFile;
  I, B1: Byte;
  SectName: Widestring;
begin
  fich := TMemUniCodeIniFile.Create(TmpFileName);
  try
    for I := 0 to Form18.RadioGroupPresetPaletteIndex.Items.Count - 1 do
      with Form1.BMPOutPreset[I] do
      begin
        SectName := 'BMPOUT ' + IntToStr(I);
        //************* BMP Out Cropping Setting **************
        fich.WriteBool(SectName, 'Cropping_Enabled', CropBMP.Enabled);
        fich.WriteInteger(SectName, 'Cropping_MinX', CropBMP.MinX);
        fich.WriteInteger(SectName, 'Cropping_MinY', CropBMP.MinY);
        fich.WriteInteger(SectName, 'Cropping_DivX', CropBMP.DivX);
        fich.WriteInteger(SectName, 'Cropping_DivY', CropBMP.DivY);
        fich.WriteInteger(SectName, 'Cropping_XPosMode', CropBMP.XPosMode);
        fich.WriteInteger(SectName, 'Cropping_YPosMode', CropBMP.YPosMode);
        fich.WriteInteger(SectName, 'Cropping_PosShift.X', CropBMP.PosShift.X);
        fich.WriteInteger(SectName, 'Cropping_PosShift.Y', CropBMP.PosShift.Y);
        fich.WriteInteger(SectName, 'Cropping_DivL', CropBMP.DivL);
        fich.WriteInteger(SectName, 'Cropping_DivT', CropBMP.DivT);
        //************* BMP Out Color Setting **************
        fich.WriteBool(SectName, 'Colors_Custom', Color.Custom);
        for B1 := 0 to 3 do
          fich.WriteInteger(SectName, 'Colors_CustColor_' + IntToStr(B1), Color.CustColors[B1]);
        for B1 := 0 to 3 do
          fich.WriteInteger(SectName, 'Colors_CustContrast_' + IntToStr(B1), Color.CustContrast[B1]);
        if I in [1, 3, 4] then //Philips' 1.5/2.0 (8/4), SST, Mae
        begin
          if Color.BitPerPixel = pf8bit then B1 := 8 else B1 := 4;
          fich.WriteInteger(SectName, 'Colors_BitPerPixel', B1);
        end;
        fich.WriteBool(SectName, 'Colors_Compress', Color.Compress);
        //************* BMP Out Position Setting **************
        fich.WriteBool(SectName, 'Positioning_Enabled', Position.Enabled);
        fich.WriteInteger(SectName, 'Positioning_XPosMode', Position.XPosMode);
        fich.WriteInteger(SectName, 'Positioning_SetTo.X', Position.SetTo.X);
        fich.WriteInteger(SectName, 'Positioning_PosShift.X', Position.PosShift.X);
        fich.WriteInteger(SectName, 'Positioning_YPosMode', Position.YPosMode);
        fich.WriteInteger(SectName, 'Positioning_SetTo.Y', Position.SetTo.Y);
        fich.WriteInteger(SectName, 'Positioning_PosShift.Y', Position.PosShift.Y);
      end;
  finally
    Fich.UpdateFile;
    Fich.Free;
  end;
end;

//------------------------------------------------------------------------------

procedure LoadBMPProfile(const TmpFileName: Widestring);
var
  fich: TMemUniCodeIniFile;
  I, B1: Byte;
  SectName: Widestring;
begin
  fich := TMemUniCodeIniFile.Create(TmpFileName);
  try
    for I := 0 to Form18.RadioGroupPresetPaletteIndex.Items.Count - 1 do
      with Form1.BMPOutPreset[I] do
      begin
        SectName := 'BMPOUT ' + IntToStr(I);
        //************* BMP Out Cropping Setting **************
        CropBMP.Enabled := fich.ReadBool(SectName, 'Cropping_Enabled', True);
        if I in [2, 3, 5] then //Sonic DVD, SST, Impression
        begin
          CropBMP.MinX := fich.ReadInteger(SectName, 'Cropping_MinX', 720);
          CropBMP.MinY := fich.ReadInteger(SectName, 'Cropping_MinY', Trunc(Form18.SpinEditMinY.MaxValue) - 2);
        end
        else
        begin
          CropBMP.MinX := fich.ReadInteger(SectName, 'Cropping_MinX', 16);
          CropBMP.MinY := fich.ReadInteger(SectName, 'Cropping_MinY', 50);
        end;
        CropBMP.DivX := fich.ReadInteger(SectName, 'Cropping_DivX', 8);
        CropBMP.DivY := fich.ReadInteger(SectName, 'Cropping_DivY', 2);
        CropBMP.XPosMode := fich.ReadInteger(SectName, 'Cropping_XPosMode', 1); //center
        CropBMP.YPosMode := fich.ReadInteger(SectName, 'Cropping_YPosMode', 1); //center
        CropBMP.PosShift.X := fich.ReadInteger(SectName, 'Cropping_PosShift.X', 0);
        CropBMP.PosShift.Y := fich.ReadInteger(SectName, 'Cropping_PosShift.Y', 0);
        if I = 4 then //Mae
        begin
          CropBMP.DivL := fich.ReadInteger(SectName, 'Cropping_DivL', 8);
          CropBMP.DivT := fich.ReadInteger(SectName, 'Cropping_DivT', 2);
        end
        else
        begin
          CropBMP.DivL := fich.ReadInteger(SectName, 'Cropping_DivL', 1);
          CropBMP.DivT := fich.ReadInteger(SectName, 'Cropping_DivT', 1);
        end;
        //************* BMP Out Color Setting **************
        Color.Custom := fich.ReadBool(SectName, 'Colors_Custom', False);
        for B1 := 0 to 3 do
        begin
          case I of
            0: Color.CustColors[B1] := fich.ReadInteger(SectName, 'Colors_CustColor_' + IntToStr(B1), DefIAuthorColor[B1]);
          else Color.CustColors[B1] := fich.ReadInteger(SectName, 'Colors_CustColor_' + IntToStr(B1), DefBMPOutColor[B1]);
          end;
          Color.CustContrast[B1] := fich.ReadInteger(SectName, 'Colors_CustContrast_' + IntToStr(B1), DefContrast[B1]);
        end;
        if I in [1, 3, 4] then //Philips, SST, Mae
        begin
          B1 := fich.ReadInteger(SectName, 'Colors_BitPerPixel', 4);
          if B1 = 8 then Form1.BMPOutPreset[I].Color.BitPerPixel := pf8bit
          else Form1.BMPOutPreset[I].Color.BitPerPixel := pf4bit;
        end;
        Color.Compress := fich.ReadBool(SectName, 'Colors_Compress', False);
        //************* BMP Out Position Setting **************
        Position.Enabled := fich.ReadBool(SectName, 'Positioning_Enabled', False);
        Position.YPosMode := fich.ReadInteger(SectName, 'Positioning_YPosMode', 0);
        Position.XPosMode := fich.ReadInteger(SectName, 'Positioning_XPosMode', 0);
        Position.SetTo.X := fich.ReadInteger(SectName, 'Positioning_SetTo.X', 0);
        Position.PosShift.X := fich.ReadInteger(SectName, 'Positioning_PosShift.X', 0);
        Position.SetTo.Y := fich.ReadInteger(SectName, 'Positioning_SetTo.Y', 0);
        Position.PosShift.Y := fich.ReadInteger(SectName, 'Positioning_PosShift.Y', 0);
      end;
    //************* BMP Out Color Setting - BitsPerPixel **************
    Form1.BMPOutPreset[0].Color.BitPerPixel := pf4bit; //I-Author
    Form1.BMPOutPreset[2].Color.BitPerPixel := pf8bit; //Sonic DVD
    Form1.BMPOutPreset[5].Color.BitPerPixel := pf8bit; //Impre
  finally
    Form1.BMPOut := Form1.BMPOutPreset[Form18.RadioGroupPresetPaletteIndex.ItemIndex];
    Fich.Free;
  end;
end;

//------------------------------------------------------------------------------

procedure SaveConfigOCR;
var
  fich: TMemUniCodeIniFile;
begin
  fich := TMemUniCodeIniFile.Create(AppzDir + IniConfigFileName);
  try
    with Form1 do begin
      //************* OCR Setting **************
      fich.WriteInteger('OCR SETTING', 'MinLineHeight', OCR.MinLineHeight);
      fich.WriteInteger('OCR SETTING', 'MaxLineHeight', OCR.MaxLineHeight);
      fich.WriteInteger('OCR SETTING', 'MinInterLine', OCR.MinInterLine);

      fich.WriteInteger('OCR SETTING', 'MinCharWidth', OCR.MinCharWidth);
      fich.WriteInteger('OCR SETTING', 'MinCharHeight', OCR.MinCharHeight);
      fich.WriteInteger('OCR SETTING', 'SpaceWidth', OCR.SpaceWidth);
      //fich.WriteInteger ('OCR SETTING','ItaSpaceWidth', OCR.ItaSpaceWidth);
      //fich.WriteInteger ('OCR SETTING','DetectItaWidth', OCR.DetectItaWidth);

      fich.WriteBool('OCR SETTING', 'CheckDetachedChar', OCR.CheckDetachedChar);

      fich.WriteInteger('OCR SETTING', 'Sensibility', OCR.Sensibility);
      fich.WriteInteger('OCR SETTING', 'MaxCharDiffWidth', OCR.MaxCharDiffWidth);
      fich.WriteInteger('OCR SETTING', 'MaxCharDiffHeight', OCR.MaxCharDiffHeight);
      fich.WriteInteger('OCR SETTING', 'MaxCharDiffTop', OCR.MaxCharDiffTop);
    end;
  finally;
    fich.UpdateFile;
    fich.Free;
  end;

end;

//------------------------------------------------------------------------------

procedure LoadLanguageFile(StFileName: Widestring); //const or var string not possible
var
  F35Cap: WideString;
begin
  //Form3 caption: because of filename
  F35Cap := Form3.Caption;

  StFileName := AppzDir + 'lang\' + StFileName + '.lng';
  MultiLang.LoadFromFile(Form1, StFileName);
  MultiLang.LoadFromFile(Form2, StFileName);
  MultiLang.LoadFromFile(Form3, StFileName);

  //Form3 caption:
  if Pos(' | ', F35Cap) > 1 then
  begin
    while Pos(' | ', F35Cap) > 1 do
      Delete(F35Cap, 1, Pos(' | ', F35Cap) - 1);
    Form3.Caption := Form3.Caption + F35Cap;
  end;
  //Form5 caption: because of filename
  F35Cap := Form5.Caption;

  MultiLang.LoadFromFile(Form4, StFileName);
  MultiLang.LoadFromFile(Form5, StFileName);

  if Pos(' | ', F35Cap) > 1 then
  begin
    while Pos(' | ', F35Cap) > 1 do
      Delete(F35Cap, 1, Pos(' | ', F35Cap) - 1);
    Form5.Caption := Form5.Caption + F35Cap;
  end;

  MultiLang.LoadFromFile(Form6, StFileName);
  //MultiLang.LoadFromFile(Form9, StFileName);
  MultiLang.LoadFromFile(Form10, StFileName);
  MultiLang.LoadFromFile(Form11, StFileName);
  //MultiLang.LoadFromFile(Form12, StFileName);
  MultiLang.LoadFromFile(Form13, StFileName);
  MultiLang.LoadFromFile(Form14, StFileName);
  MultiLang.LoadFromFile(Form15, StFileName);
  MultiLang.LoadFromFile(Form16, StFileName);
  MultiLang.LoadFromFile(Form17, StFileName);
  MultiLang.LoadFromFile(Form18, StFileName);
  MultiLang.LoadFromFile(Form20, StFileName);
  MultiLang.LoadFromFile(Form21, StFileName);
  MultiLang.LoadFromFile(Form22, StFileName);
  MultiLang.LoadFromFile(Form23, StFileName);
  ReadStrings(MsgStr, 'Messages', StFileName);

  //override
  Form1.Caption := 'SubRip ' + VersionStr;
  //override2
  if Form1.Process.Paused and Form1.ButtonPause.Enabled then
    Form1.ButtonPause.Caption := MsgStr[58]
  else Form1.ButtonPause.Caption := MsgStr[57];
  //fill version
  Form13.EditSubviewerSource.Text :=
    Tnt_WideStringReplace(Form13.EditSubviewerSource.Text, '${VERSION}', VersionStr, []);
  Form13.EditSubviewer2Source.Text :=
    Tnt_WideStringReplace(Form13.EditSubviewer2Source.Text, '${VERSION}', VersionStr, []);
  Form13.EditDVDSubtitleInfo.Text :=
    Tnt_WideStringReplace(Form13.EditDVDSubtitleInfo.Text, '${VERSION}', VersionStr, []);

  //two (or more) times appearance - once needid in Lang file
  Form5.BoldCheckBox.Caption := Form2.BoldCheckBox.Caption;
  Form5.ItalicCheckBox.Caption := Form2.ItalicCheckBox.Caption;
  Form5.UnderlineCheckBox.Caption := Form2.UnderlineCheckBox.Caption;
  Form6.TntBitButtonOutputFormat.Hint := Form3.TntBitButtonOutputFormat.Hint;
  Form12.Caption := WideStripHotKey(Form1.About1.Caption);
  if Pos('...', Form12.Caption) = 0 then Form12.Caption := Form12.Caption + '...';

  Form4.BitBtnOk.Caption := Form2.BitBtn1.Caption; //&OK
  Form5.BitBtn1.Caption := Form2.BitBtn1.Caption; //&OK
  //Form9.ButtonOk.Caption := Form2.BitBtn1.Caption; //&OK
  Form17.BitBtn1.Caption := Form2.BitBtn1.Caption; //&OK
  Form18.BitBtn1.Caption := Form2.BitBtn1.Caption; //&OK

  Form6.BitBtnCancel.Caption := Form4.BitBtnCancel.Caption; //Cancel
  Form10.BitBtn2.Caption := Form4.BitBtnCancel.Caption; //Cancel
  Form13.BitBtn1.Caption := Form4.BitBtnCancel.Caption; //Cancel
  Form14.BitBtn1.Caption := Form4.BitBtnCancel.Caption; //Cancel
  Form19.BitBtnCancel.Caption := Form4.BitBtnCancel.Caption; //Cancel

  Form5.ListViewMatrix.Columns[1].Caption :=
    Tnt_WideStringReplace(Form5.Label7.Caption, ':', '', []); //Characters:
  Form5.ListViewMatrix.Columns[2].Caption := Form5.BoldCheckBox.Caption[1]; //B
  Form5.ListViewMatrix.Columns[3].Caption := Form5.ItalicCheckBox.Caption[1]; //I
  Form5.ListViewMatrix.Columns[4].Caption := Form5.UnderlineCheckBox.Caption[1]; //U

  //FrameRate
  Form13.Label40.Caption := Form13.Label39.Caption;
  Form13.Label42.Caption := Form13.Label39.Caption;
  Form13.LabelMplFR.Caption := Form13.Label39.Caption;
  Form13.LabelMacSUBFR.Caption := Form13.Label39.Caption;
  Form13.LabelPhoenixFR.Caption := Form13.Label39.Caption;
  Form13.MaeFRLabel.Caption := Form13.Label39.Caption;
  Form13.SSTFRLabel.Caption := Form13.Label39.Caption;
  Form13.LabelSTLFR.Caption := Form13.Label39.Caption;
  Form13.LabelImpreFR.Caption := Form13.Label39.Caption;
  Form13.LabelFABFR.Caption := Form13.Label39.Caption;
  Form13.LabelMacDVDFR.Caption := Form13.Label39.Caption;
  //!! Be careful: if you choose NTSC and movie is PAL, some Subtitles may not appear !!
  Form13.ComboBoxSTLFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  Form13.ComboBoxSonicFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  Form13.ComboBoxMaeFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  Form13.ComboBoxSSTFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  Form13.ComboBoxImpreFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  Form13.ComboBoxFABFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  Form13.ComboBoxMacDVDFrameRate.Hint := Form13.ComboBoxPhilipsFrameRate.Hint;
  //DropFrame
  Form13.CheckBoxSonicDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  Form13.CheckBoxMaeDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  Form13.CheckBoxSSTDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  Form13.CheckBoxSTLDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  Form13.CheckBoxImpreDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  Form13.CheckBoxFABDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  Form13.CheckBoxMacDVDDropFrame.Caption := Form13.CheckBoxPhilipsDropFrame.Caption;
  //fps info
  Form13.LabelMplFRHint.Caption := Form13.Label45.Caption;
  Form13.LabelMacSUBFRHint.Caption := Form13.Label45.Caption;
  Form13.LabelPhoenixFRHint.Caption := Form13.Label45.Caption;
  Form13.MaeOffsetLabel.Caption := Form13.Label2.Caption;
  Form13.CheckBoxMaeExtended.Caption := Form13.CheckBoxSrtExtended.Caption;
  //H/V alignment
  Form13.GroupBoxSTLHor.Caption := Form18.RadioGroupHAlignment.Caption;
  Form13.GroupBoxSTLVer.Caption := Form18.RadioGroupVAlignment.Caption;
  Form13.RadioButtonHLeft.Caption := Form18.RadioGroupHAlignment.Items[0];
  Form13.RadioButtonHCenter.Caption := Form18.RadioGroupHAlignment.Items[1];
  Form13.RadioButtonHRight.Caption := Form18.RadioGroupHAlignment.Items[2];
  Form13.RadioButtonVTop.Caption := Form18.RadioGroupVAlignment.Items[0];
  Form13.RadioButtonVCenter.Caption := Form18.RadioGroupVAlignment.Items[1];
  Form13.RadioButtonVBottom.Caption := Form18.RadioGroupVAlignment.Items[2];
  Form13.LabelVOffset.Caption := Form13.LabelHOffset.Caption;
  //TreeView Main Items
  Form13.FormatsTreeView.Items[0].Text := MsgStr[69];
  Form13.FormatsTreeView.Items[HMTextFormat + 1].Text := MsgStr[70];
  //Font
  Form15.ButtonCharFont.Caption := Form13.ButtonSTLFont.Caption;
  Form13.ButtonSSAFont.Caption := Form13.ButtonSTLFont.Caption;
  Form13.ButtonSV2Font.Caption := Form13.ButtonSTLFont.Caption;
  //Change Font
  Form15.ButtonCharFont.Hint := Form13.ButtonSTLFont.Hint;
  Form13.ButtonSSAFont.Hint := Form13.ButtonSTLFont.Hint;
  Form13.ButtonSV2Font.Hint := Form13.ButtonSTLFont.Hint;
  Form15.ButtonCharmap.Caption := Form2.ButtonCharmap.Caption;
  Form15.ButtonCharmap.Hint := Form2.ButtonCharmap.Hint;
  Form15.ButtonPause.Caption := Form2.ButtonPause.Caption;
  Form15.ButtonPause.Hint := Form2.ButtonPause.Hint;
  //Color
  Form13.LabelSSAColor.Caption := Form13.LabelColor.Caption;

  Form15.ButtonChangeColor.Caption := Form2.ButtonChangeColor.Caption;
  Form15.ButtonSkipSubPict.Caption := Form2.ButtonSkipSubPict.Caption;
  Form16.Caption := WideStripHotKey(Form1.GlobalOptions1.Caption);
  Form16.BitBtnOk.Caption := Form2.BitBtn1.Caption;

  Form18.RadioButtonOriginalTopPos.Caption := Form18.RadioButtonOriginalLeftPos.Caption;
  Form18.RadioButtonCenterTopPos.Caption := Form18.RadioButtonCenterLeftPos.Caption;
  Form18.RadioButtonSetTopPos.Caption := Form18.RadioButtonSetLeftPos.Caption;
  Form18.Label16.Caption := Form18.Label17.Caption;
  //Color #1 - #4
  Form18.LabelClr1.Caption := Form13.LabelColor.Caption + ' #1';
  Form18.LabelClr2.Caption := Form13.LabelColor.Caption + ' #2';
  Form18.LabelClr3.Caption := Form13.LabelColor.Caption + ' #3';
  Form18.LabelClr4.Caption := Form13.LabelColor.Caption + ' #4';

  Form20.Caption := WideStripHotKey(Form1.CheckNewVersion1.Caption);

  //fill text to the OpenDialog
  Form1.OpenDialogCharMatrix.Title := WideStripHotKey(Form1.OpenCharacterMatrix1.Caption);
end;

//------------------------------------------------------------------------------

procedure SetOcrDefaultValues;
begin
  with Form1 do
  begin
    Ocr.MinLineHeight := 8;
    Ocr.MaxLineHeight := 45;
    Ocr.MinInterLine := 2;

    Ocr.MinCharWidth := 2;
    Ocr.MaxCharWidth := 25; //not Used For The moment
    Ocr.MinCharHeight := 2;
    Ocr.MaxCharHeight := 45; //not Used For The moment
    Ocr.SpaceWidth := 7; //Normal Characters space width
    //Ocr.ItaSpaceWidth := 5;    //Italic Characters space width
    //OCR.DetectItaWidth:= -1;
    Ocr.CheckDetachedChar := True;

    Ocr.Sensibility := 980; //920; //890;
    Ocr.MaxCharDiffWidth := 2;
    Ocr.MaxCharDiffHeight := 2;
    Ocr.MaxCharDiffTop := 6;
  end;
end;

//------------------------------------------------------------------------------

procedure SetDefaultMsgStr;
begin
  MsgStr.Clear;
  //MsgStr[x] in forms
  {00} MsgStr.Add('Maximum Number of Characters reached:');
  {01} MsgStr.Add('You have to use a different char. matrix for each DVD.');
  {02} MsgStr.Add('The Character Matrix is Empty!');
  {03} MsgStr.Add('File');
  {04} MsgStr.Add('already exists! Replace?');
  {05} MsgStr.Add('This is NOT valid Char Matrix File!');
  {06} MsgStr.Add('Character Matrix');
  {07} MsgStr.Add('has been modified.');
  {08} MsgStr.Add('Do you want to save it?');
  {09} MsgStr.Add('Text NOT saved!');
  {10} MsgStr.Add('Do you really want to quit?');
  {11} MsgStr.Add('Closed Captions detected');
  {12} MsgStr.Add('subtitle streams found.');
  {13} MsgStr.Add('Subtitle timecodes are overlapping:');
  {14} MsgStr.Add('Do you really want to open another file?');
  {15} MsgStr.Add('Error in file at Subtitle Nr.');
  {16} MsgStr.Add('Ignore and Continue?');
  {17} MsgStr.Add('Cannot write to file');
  {18} MsgStr.Add('Do you really want to clear all text?');
  {19} MsgStr.Add('Delete character "');
  {20} MsgStr.Add('skipped - too small / short)');
  {21} MsgStr.Add('Subtitles text file isn''t empty.');
  {22} MsgStr.Add('Add to the end of file?');
  {23} MsgStr.Add('Split Output File function is enabled.');
  {24} MsgStr.Add('The new Subtitles might NOT appear until you disable it!');
  {25} MsgStr.Add('No VOB/SUB selected!');
  {26} MsgStr.Add('Bad Packet Header at LBA:');
  {27} MsgStr.Add('Do you want to continue?');
  {28} MsgStr.Add('Can''t open file');
  {29} MsgStr.Add(', it might be encrypted.');
  {30} MsgStr.Add('You can try to decrypt it with vStrip, SmartRipper or DVD Decrypter.');
  {31} MsgStr.Add('Time Code');
  {32} MsgStr.Add('will be reduced to 00:00:00,000.');
  {33} MsgStr.Add('Do you want to continue? (No undo!)');
  {34} MsgStr.Add('You can''t make a minus time Stretch with a time');
  {35} MsgStr.Add('that is larger than the total file time!');
  {36} MsgStr.Add('It''s not a good idea to convert between graphical and text based outputs.');
  {37} MsgStr.Add('The Stop time is smaller than the Start time!');
  {38} MsgStr.Add('Save BMPs: Enter beginning of File Name.');
  {39} MsgStr.Add('Save SUPs: Enter beginning of File Name.');
  {40} MsgStr.Add('Save as BMP (Subpicture Nr.'); //unused
  {41} MsgStr.Add('Save as SUP (Subpicture Nr.'); //unused
  {42} MsgStr.Add('), enter filename.'); //unused
  {43} MsgStr.Add('Save current BMP');
  {44} MsgStr.Add('Save current BMP Settings as a Profile file');
  {45} MsgStr.Add('Load BMP Settings from a Profile file');
  {46} MsgStr.Add('Load a Background Image');
  {47} MsgStr.Add('Not enough memory to add this character to the Matrix!');
  {48} MsgStr.Add('Not enough memory to load this character Matrix!');
  {49} MsgStr.Add('Size of the Matrix in Bytes:');
  {50} MsgStr.Add('File');
  {51} MsgStr.Add('contain character');
  {52} MsgStr.Add('it seem to match with the current one.');
  {53} MsgStr.Add('Do you want to open this Char Matrix File?');
  {54} MsgStr.Add('Can''t find any (other) matching Char Matrix File.');
  {55} MsgStr.Add('Be sure to place all matrix files in');
  {56} MsgStr.Add('You should try it again on the next character, if still not found then you must create new Matrix.');
  {57} MsgStr.Add('&Pause  I I');
  {58} MsgStr.Add('&Continue  >');
  {59} MsgStr.Add('Symbol index:');
  {60} MsgStr.Add('Unrecognized file format.');
  {61} MsgStr.Add('Error in AVI file.');
  {62} MsgStr.Add('The time read from AVI file is greater than time read from subtitle file.');
  {63} MsgStr.Add('Subtitle file splitted and saved as:');
  {64} MsgStr.Add('Server is down or');
  {65} MsgStr.Add('you are not connected to Intenet.');
  {66} MsgStr.Add('You have actual version.');
  {67} MsgStr.Add('A new version of SubRip is available for download!');
  {68} MsgStr.Add('Do you want to visit the SubRip page?');
  {69} MsgStr.Add('Text Formats');
  {70} MsgStr.Add('Graphical Formats');
  {71} MsgStr.Add('Warning');
  {72} MsgStr.Add('Error');
  {73} MsgStr.Add('Information');
  {74} MsgStr.Add('Confirm');
  {75} MsgStr.Add('Processing skipped subtitle item'); //F15 Caption1
  {76} MsgStr.Add('Font color selection'); //F15 Caption2
  {77} MsgStr.Add('You have to check 1 or 2 colors!');
//avi stuff
  {78} MsgStr.Add('Error opening video file.');
  {79} MsgStr.Add('Cannot detect frame rate');
  {80} MsgStr.Add('Input frame rate value');
  {81} MsgStr.Add('Subtitles should appear white, outlines red, filled zones gray, green, blue and magenta');
  {82} MsgStr.Add('full');
  {83} MsgStr.Add('accumulate');
  {84} MsgStr.Add('compare');
  {85} MsgStr.Add('none');
  {86} MsgStr.Add('Could not open video file using AviSynth.');
//UniCode stuff
  {87} MsgStr.Add('Subtitle contains non-standard characters.');
  {88} MsgStr.Add('Save as UniCode instead of ANSI?');
  {89} MsgStr.Add('UniCode file names not supported by AviSynth. Please rename your video file.');
  {90} MsgStr.Add('No suitable compressor could be found to give RGB32 images.');
  {91} MsgStr.Add('If the video does not appear in the video window, recompress.');
  {92} MsgStr.Add('Small');
  {93} MsgStr.Add('Caps');
  {94} MsgStr.Add('Punct');
  {95} MsgStr.Add('Fill character matrix'); //F15 Caption3
  {96} MsgStr.Add('Timings are negative, you may need to add a delay');
  {97} MsgStr.Add('Right-click and drag to define cropping rectangle');
  {98} MsgStr.Add('Click inside a letter to set text color');
  {99} MsgStr.Add('Click on an outline to set outline color more precisely');
end;

end.
