{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit UGraph; //Graphic process (BMP Cropping, Color mapping, Positioning, Resizing...)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Math;

function AdjustBMP(const OrigCoord: TRect): TRect;

implementation

uses Unit01, Unit03, Unit06, Unit08, Unit11;

//------------------------------------------------------------------------------

function AdjustBMP(const OrigCoord: TRect): TRect;
var
  YCoo: Integer;
  I, IY: Integer;
  PBA: PByteArray;
  TranspCnt: Byte;
  NewBmp: TBitmap;
  BgDetected: Boolean;
  //----------
  //Return the new pict coordinates maintaining the same position despite the cropping
  function CropPicture(const OrigCoord: TRect; WMinX, WMinY: Word;
    BDivX, BDivY, BXPos, BYPos, BDivL, BDivT: Byte; const TmpPosShift: TPoint): TRect;
  var
    WNewX, WNewY, dummy: Word;
    ITop, ILeft: Integer;
    //----------
    procedure AdjustWidth(PlusX: Word);
    begin
      WNewX := Max(Form1.SubBmp.Width + PlusX, WMinX);
      if WNewX mod BDivX <> 0 then WNewX := (WNewX div BDivX + 1) * BDivX; //make WNewX multiple of DivX
      WNewX := Min(WNewX, 720); //Max Width
    end;
    //----------
    procedure AdjustHeight(PlusY: Word);
    begin
      WNewY := Max(Form1.SubBmp.Height + PlusY, WMinY);
      //silent workaround for last 2 bottom lines, that are deleted by DVDMaestro if there's not empty place
      if (Form1.BMPOutLast = 4) and (WNewY < Form1.SubBmp.Height + 4) and (WNewY <= YCoo - 6) then
      Inc(WNewY, 4);
      if WNewY mod BDivY <> 0 then WNewY := (WNewY div BDivY + 1) * BDivY; //make WNewY multiple of DivY
      WNewY := Min(WNewY, YCoo); //Max Height
    end;
    //----------
    procedure AdjustCoordLeft;
    begin
      //calculate the new TV Screen relative coordinate
      Result.Left := OrigCoord.Left - ILeft;
      if Result.Left < 0 then
      begin
        Inc(ILeft, Result.Left);
        Result.Left := 0; //Avoid going out of area
      end;
      if Result.Left + WNewX > 720 then
      begin
        Inc(ILeft, Result.Left - (720 - WNewX));
        Result.Left := 720 - WNewX; //Avoid going out of area
      end;
    end;
    //----------
    procedure AdjustCoordTop;
    begin
      //calculate the new TV Screen relative coordinate
      Result.Top := OrigCoord.Top - ITop;
      if Result.Top < 0 then
      begin
        Inc(ITop, Result.Top);
        Result.Top := 0; //Avoid going out of area
      end;
      if Result.Top + WNewY > YCoo then
      begin
        Inc(ITop, Result.Top - (YCoo - WNewY));
        Result.Top := YCoo - WNewY; //Avoid going out of area
      end;
    end;
    //----------
  begin
    AdjustWidth(0); AdjustHeight(0);

    //Set to the selected position
    case BXPos of
      1: ILeft := (WNewX - Form1.SubBmp.Width) div 2;
      2: ILeft := WNewX - Form1.SubBmp.Width;
      else ILeft := 0;
    end;
    case BYPos of
      1: ITop := (WNewY - Form1.SubBmp.Height) div 2;
      2: ITop := WNewY - Form1.SubBmp.Height;
      else ITop := 0;
    end;

    //apply the position shifting if there's any
    Dec(ILeft, TmpPosShift.X);
    if ILeft < 0 then ILeft := 0 else
      if ILeft > WNewX - Form1.SubBmp.Width then ILeft := WNewX - Form1.SubBmp.Width;
    Dec(ITop, TmpPosShift.Y);
    if ITop < 0 then ITop := 0 else
      if ITop > WNewY - Form1.SubBmp.Height then ITop := WNewY - Form1.SubBmp.Height;

    AdjustCoordLeft; AdjustCoordTop;

    //extend size to comply with position rules
    dummy := Result.Left mod BDivL;
    if dummy <> 0 then
    begin
      if ILeft + dummy > BDivL then Dec(ILeft, BDivL - dummy) //prevents too wider pic
      else Inc(ILeft, dummy);
      AdjustWidth(ILeft);
      AdjustCoordLeft;
    end;
    dummy := Result.Top mod BDivT;
    if dummy <> 0 then
    begin
      if ITop + dummy > BDivT then Dec(ITop, BDivT - dummy) //prevents too higher pic
      else Inc(ITop, dummy);
      AdjustHeight(ITop);
      AdjustCoordTop;
    end;
    Result.Right := Result.Left + WNewX - 1;
    Result.Bottom := Result.Top + WNewY - 1;

    //NewBmp.Palette := Form1.SubBmp.Palette; - doesn't work on XP (4bit BMP palette assign)
    NewBmp.Assign(Form1.SubBmp); //ToDo: not powerful, but works in XP

    NewBmp.Width := WNewX;
    NewBmp.Height := WNewY;
    NewBmp.Canvas.Brush.Color := Form1.SubPicture.BgClr;
    NewBmp.Canvas.Pen.Color := Form1.SubPicture.BgClr;
    NewBmp.Canvas.Pen.Width := 0;
    NewBmp.Canvas.Rectangle(0, 0, WNewX, WNewY);

    BitBlt(NewBmp.Canvas.Handle, ILeft, ITop, NewBmp.Width,
      NewBmp.Height, Form1.SubBmp.Canvas.Handle, 0, 0, srcCopy);
  end;
  //----------
  procedure Bitmap2Bitmap;
  var
    PBA1, PBA2: PByteArray;
    WX, WY, Wmult: Word;
  begin
    if (NewBmp.Width <= 0) or (NewBmp.Height <= 0) then Exit;
    Form1.OutBmp.Width := NewBmp.Width;
    Form1.OutBmp.Height := NewBmp.Height;

    if (Form1.BMPOutLast in [3, 4]) or Form1.BMPOut.Color.Custom then
    begin
      //8 --> 4 bits pixels conversion
      if Form1.BMPOut.Color.BitPerPixel = pf4bit then
        for WY := 0 to NewBmp.Height - 1 do
        begin
          PBA1 := NewBmp.ScanLine[WY];
          PBA2 := Form1.OutBmp.ScanLine[WY];
          for WX := 0 to NewBmp.Width - 1 do
          begin
            Wmult := WX div 2;
            if Odd(WX) then
              PBA2[Wmult] := PBA2[Wmult] or PBA1[WX]
            else
              PBA2[Wmult] := PBA1[WX] shl 4;
          end;
        end
      //8 bits
      else if Form1.BMPOut.Color.BitPerPixel = pf8bit then
        for WY := 0 to NewBmp.Height - 1 do
        begin
          PBA1 := NewBmp.ScanLine[WY];
          PBA2 := Form1.OutBmp.ScanLine[WY];
          Move(PBA1[0], PBA2[0], NewBmp.Width); //faster then PBA2[WX] := PBA1[WX] in loop
        end
    end
    else
    begin
      //8 --> 4 bits pixels conversion
      if Form1.BMPOut.Color.BitPerPixel = pf4bit then
        for WY := 0 to NewBmp.Height - 1 do
        begin
          PBA1 := NewBmp.ScanLine[WY];
          PBA2 := Form1.OutBmp.ScanLine[WY];
          for WX := 0 to NewBmp.Width - 1 do
          begin
            Wmult := WX div 2;
            if Odd(WX) then
              PBA2[Wmult] := PBA2[Wmult] or Form1.SubPicture.SubColor[PBA1[WX]]
            else
              PBA2[Wmult] := Form1.SubPicture.SubColor[PBA1[WX]] shl 4;
          end;
        end
      //8 bits
      else if Form1.BMPOut.Color.BitPerPixel = pf8bit then
        for WY := 0 to NewBmp.Height - 1 do
        begin
          PBA1 := NewBmp.ScanLine[WY];
          PBA2 := Form1.OutBmp.ScanLine[WY];
          for WX := 0 to NewBmp.Width - 1 do
            PBA2[WX] := Form1.SubPicture.SubColor[PBA1[WX]];
        end
    end
  end;
  //----------
begin
  if Form1.Process.VideoSize.Y = 0 then YCoo := 576 else YCoo := Form1.Process.VideoSize.Y;
  Result := OrigCoord; //Result equal to Original coord by default

  //what's the real b-color?
  if Form1.SubPicture.ClrChanged or Form1.SubPicture.CtrChanged then
  begin
    TranspCnt := 0;
    for I := 0 to 3 do
      if Form1.SubPicture.SubContrast[I] = 0 then
      begin
        Inc(TranspCnt);
        Form1.SubPicture.BgIdx := I;
      end;

    BgDetected := False;
    if TranspCnt > 1 then
    begin
      for I := 0 to 3 do
        if Form1.SubPicture.SubContrast[I] = 0 then
        begin
          PBA := Form1.SubBmp.ScanLine[0];
          if (PBA[0] = I) or (PBA[Form1.SubBmp.Width - 1] = I) then
          begin
            Form1.SubPicture.BgIdx := I;
            BgDetected := True; Break;
          end;
          PBA := Form1.SubBmp.ScanLine[Form1.SubBmp.Height - 1];
          if (PBA[0] = I) or (PBA[Form1.SubBmp.Width - 1] = I) then
          begin
            Form1.SubPicture.BgIdx := I;
            BgDetected := True; Break;
          end;
        end;
    end    
    else BgDetected := True;

    //last hope
    if not BgDetected then
      for IY := 0 to Form1.SubBmp.Height - 1 do
      begin
        if BgDetected then Break;
        PBA := Form1.SubBmp.ScanLine[IY];
        for I := 0 to Form1.SubBmp.Width - 1 do
          if Form1.SubPicture.SubContrast[PBA[I]] = 0 then
          begin
            Form1.SubPicture.BgIdx := PBA[I];
            BgDetected := True; Break;
          end;
      end;

    case Form1.SubPicture.BgIdx of
      0: Form1.SubPicture.BgClr := clBlack;
      1: Form1.SubPicture.BgClr := clWhite;
      2: Form1.SubPicture.BgClr := clRed;
      3: Form1.SubPicture.BgClr := clBlue;
    end;
  end;
  //Form1.CutValidRect(Form1.SubBmp, Form1.SubPicture.BgIdx, True); //remove background borders from previous call
  NewBmp := TBitmap.Create;
  try
    NewBmp.HandleType := bmDIB;
    NewBmp.PixelFormat := Form1.SubBmp.PixelFormat;

    with Form1.BMPOut do
    begin
      //Cropping
      if CropBMP.Enabled then
        Result := CropPicture(OrigCoord, CropBMP.MinX, CropBMP.MinY,
          CropBMP.DivX, CropBMP.DivY, CropBMP.XPosMode, CropBMP.YPosMode,
          CropBMP.DivL, CropBMP.DivT, CropBMP.PosShift)
      else
        NewBmp.Assign(Form1.SubBmp);

      //Color Mapping - redraw BMP with chosen colors
      Bitmap2Bitmap;

      //Positioning
      if Position.Enabled then
      begin
        case Position.XPosMode of
          //0: ; //Keep original pos
          1: Result.Left := (720 - Form1.OutBmp.Width) div 2;
          2: Result.Left := 720 - Form1.OutBmp.Width;
          3: Result.Left := Position.SetTo.X;
        end;
        case Position.YPosMode of
          //0: ; //Keep original pos
          1: Result.Top := (YCoo - Form1.OutBmp.Height) div 2;
          2: Result.Top := YCoo - Form1.OutBmp.Height;
          3: Result.Top := Position.SetTo.Y;
        end;
        Result.Left := Result.Left + Position.PosShift.X;
        Result.Top := Result.Top + Position.PosShift.Y;

        //Avoid going out of area
        if Result.Left < 0 then Result.Left := 0;
        if Result.Left + Form1.OutBmp.Width > 720 then
          Result.Left := 720 - Form1.OutBmp.Width;
        if Result.Top < 0 then Result.Top := 0;
        if Result.Top + Form1.OutBmp.Height > YCoo then
          Result.Top := YCoo - Form1.OutBmp.Height;

        Result.Right := Result.Left + Form1.OutBmp.Width - 1;
        Result.Bottom := Result.Top + Form1.OutBmp.Height - 1;
      end;
    end;
  finally
    NewBmp.Free;
  end;
end;

//------------------------------------------------------------------------------
//-----------------------------------LIFE-END-----------------------------------
//------------------------------------------------------------------------------

end.
