{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit03;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Buttons, ComCtrls, TntDialogs, Dialogs, TntComCtrls,
  TntStdCtrls, TntButtons, TntExtCtrls, TntForms, TntSysUtils, Menus,
  TntMenus, UniCodeIniFiles, Unit01, TntClasses, TntClipbrd, ShellAPI, TntGraphics,
  Spin,StrUtils;

type
  TForm3 = class(TTntForm)
    ListBoxSubtitle: TTntListBox;
    Panel1: TTntPanel;
    Label1: TTntLabel;
    LabelNbSubTitle: TTntLabel;
    SaveDialogText: TTntSaveDialog;
    MainMenu1: TTntMainMenu;
    File1: TTntMenuItem;
    OpenSubRipFormat1: TTntMenuItem;
    Saveas1: TTntMenuItem;
    SetOutputFormat1: TTntMenuItem;
    Clear1: TTntMenuItem;
    SpealingCorrection1: TTntMenuItem;
    PostOCRCorrection1: TTntMenuItem;
    OutputFormat1: TTntMenuItem;
    TimeCorrection1: TTntMenuItem;
    UpDown1: TTntUpDown;
    TntBitButtonSpellingCorrection: TTntBitBtn;
    OpenDialogSubRipText: TTntOpenDialog;
    TntBitButtonTimeCorrection: TTntBitBtn;
    TntBitButtonOutputFormat: TTntBitBtn;
    TntBitButtonSaveAs: TTntBitBtn;
    TntBitButtonClearSub: TTntBitBtn;
    TntBitButtonSplitText: TTntBitBtn;
    Splitoutputfile1: TTntMenuItem;
    LabelSkip: TTntLabel;
    ComboBoxFPS: TTntComboBox;
    bbConversion: TTntBitBtn;
    pConversion: TTntPanel;
    LabelFont: TTntLabel;
    LabelCodePage: TTntLabel;
    cbCodePage: TTntComboBox;
    SubFormat: TTntLabel;
    bbDone: TTntBitBtn;
    CheckBoxScrollDown: TTntCheckBox;
    bbSave: TTntBitBtn;
    CheckBoxFormat: TTntCheckBox;
    img: TImage;
    cbFontName: TTntComboBox;
    LabelSize: TTntLabel;
    seFontSize: TSpinEdit;
    FontDialog: TFontDialog;
    procedure bbConversionClick(Sender: TObject);
    procedure CheckBoxFormatClick(Sender: TObject);
    procedure ListBoxSubtitleDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure SetOutputFormat1Click(Sender: TObject);
    procedure PostOCRCorrection1Click(Sender: TObject);
    procedure TimeCorrection1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure Splitoutputfile1Click(Sender: TObject);
    procedure ComboBoxFPSChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbCodePageChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure bbDoneClick(Sender: TObject);
    procedure SaveAsClick(Sender: TObject);
    procedure OpenSubRipFormat1Click(Sender: TObject);
    procedure bbSaveClick(Sender: TObject);
    procedure cbFontNameChange(Sender: TObject);
    procedure seFontSizeChange(Sender: TObject);
    procedure TntFormHide(Sender: TObject);
  private
    { Private declarations }
    FNewWndProc, FOldWndProc: Pointer;
    needUniCode:boolean;
    WideSubs:TTntStringList;
    procedure ControlWndProc(var Msg: TMessage);
    procedure DropFiles(DropHandle: HDROP);
    procedure AddLine(line:WideString);//!!!unicode
    procedure WideReadLn(var Fic: TextFile; var ws: WideString);
    procedure WideWriteLn(var Fic: TextFile; ws: WideString);
    procedure SaveAs(Sender: TObject);
    procedure OpenSubtitle(breset: boolean);
  public
    { Public declarations }
    InputType: Byte;
    TxtFile: record
      Modified: Boolean;
      FileName: Widestring;
      OutputFormat: Byte;
      Split: Boolean;
      SplitStart: TTimeCodeMs;
      SplitStop: TTimeCodeMs;
      SplitIndex: Word; //Index of Sub B4 1st Sub of splitted files
      Loaded: Boolean; //assign Custom Clr/Ctr to loaded txt file
    end;
    function CanShowSub(var TmpSub: TSub; var TmpStartTC, TmpStopTC: TTimeCodeMs): Boolean;
    function CorrectSplitTime(var TmpSub: TSub; var TmpStartTC, TmpStopTC: TTimeCodeMs): TSub;
    function StripStyle(const St: Widestring): Widestring;
    procedure AddSubTitle(WNumSub: Word; BScrollDown: Boolean);
    procedure DelLastSubTitle;
    procedure AddAllSubTitles;
    procedure SetFileName(StF: Widestring);
    function ForceMinInterMs(TmpTcMs1, TmpTcMs2: TTimeCodeMs; LMinInter: Integer): TTimeCodeMs; //Verify that a minimum of LMinInter interval
    function CanWriteToFile(const FileName: WideString): Boolean;
    function FontCharSet: WideString;
  end;

var
  Form3: TForm3;

  //Added by LRN (LordRuslanNightmare@gmail.com)
  TTXTLastStop : TTimeCodeMs;


implementation

uses Unit07, Unit10, Unit13, Unit14, Unit02, Unit17, Unit16, Unit06, Unit21;

{$R *.DFM}

type
  TNewTextMetricEx = packed record
    NewTextMetric: TNewTextMetric;
    FontSignature: TFontSignature
  end;

  TCharSetRec = packed record
    Name: string;
    ID: byte;//charset
    CP: word;//default codepage
  end;

const
  NumCharSets = 19;

  CharSets: array[0..NumCharSets - 1] of TCharSetRec = (
    (Name: 'ANSI'; ID: ANSI_CHARSET; CP: 1252),
    (Name: 'DEFAULT'; ID: DEFAULT_CHARSET; CP: 1252),
    (Name: 'SYMBOL'; ID: SYMBOL_CHARSET; CP: 1252),//42; //CP_SYMBOL
    (Name: 'SHIFTJIS'; ID: SHIFTJIS_CHARSET; CP: 932),
    (Name: 'HANGEUL'; ID: HANGEUL_CHARSET; CP: 949),
    (Name: 'GB2312'; ID: GB2312_CHARSET; CP: 20936),
    (Name: 'CHINESEBIG5'; ID: CHINESEBIG5_CHARSET; CP: 10002),
    (Name: 'OEM'; ID: OEM_CHARSET; CP: 858),
    (Name: 'JOHAB'; ID: JOHAB_CHARSET; CP: 1361),
    (Name: 'HEBREW'; ID: HEBREW_CHARSET; CP: 1255),
    (Name: 'ARABIC'; ID: ARABIC_CHARSET; CP: 1256),
    (Name: 'GREEK'; ID: GREEK_CHARSET; CP: 1253),
    (Name: 'TURKISH'; ID: TURKISH_CHARSET; CP: 1254),
    (Name: 'VIETNAMESE'; ID: VIETNAMESE_CHARSET; CP: 1258),
    (Name: 'THAI'; ID: THAI_CHARSET; CP: 874),
    (Name: 'EASTEUROPE'; ID: EASTEUROPE_CHARSET; CP: 1250),
    (Name: 'RUSSIAN'; ID: RUSSIAN_CHARSET; CP: 1251),
    (Name: 'MAC'; ID: MAC_CHARSET; CP: 10000),
    (Name: 'BALTIC'; ID: BALTIC_CHARSET; CP: 1257)
    );

//------------------------------------------------------------------------------

procedure TForm3.AddLine(line: WideString);
var
  i,c:integer;
begin
  for i:=1 to Length(line) do
  begin
    c:=ord(line[i]);
    if (c<32)or(c>127) then
    begin
      needUniCode:=true;
      SubFormat.Caption:='UNICODE';
      SubFormat.Font.Color:=clRed;
      break;
    end;
  end;
  ListBoxSubtitle.Items.Add(line);
  WideSubs.Add(line);
end;


procedure TForm3.WideReadLn(var Fic: TextFile; var ws: WideString);
var
  s: AnsiString;
  wch: WideChar;
  i:integer;
begin
  readln(Fic,s);
  if Length(s)>2 then//!!!unicode
    if s[1] = chr($FF)then
      if s[2] = chr($FE) then
        begin
          needUniCode:=true;
          SubFormat.Caption:='UNICODE';
          SubFormat.Font.Color:=clRed;
          s:=Copy(s,3,Length(s)-2);
        end;
  if Length(s)>1 then
    if s[1]=chr(0) then s:=Copy(s,2,Length(s)-1);// first char was zero, skip
  if needUniCode then
  begin
    ws:='';
    i:=1;
    while i<=Length(s) do
    begin
      wch:=WideChar(ord(s[i])+256*ord(s[i+1]));
      ws:=ws+wch;
      i:=i+2;
    end;
  end
  else ws:=StringToWideString(s);//converts using current codepage
  if ws=#0 then ws:='';
end;

procedure TForm3.WideWriteLn(var Fic: TextFile; ws: WideString);
var
  s: AnsiString;
  wch: WideChar;
  i:integer;
begin
  if needUniCode then
  begin
    for i:=1 to Length(ws) do
    begin
      wch:=ws[i];
      s:=chr(ord(wch)mod 256)+chr(ord(wch)div 256);
      write(Fic,s);
    end;
    s:=chr(ord($0d))+chr(ord(0));
    write(Fic,s);
    s:=chr(ord($0a))+chr(ord(0));
    write(Fic,s);
  end
  else
  begin
    s:=WideStringToString(ws);//tries to convert using current codepage
    writeln(Fic,s);
  end;
end;

procedure TForm3.DelLastSubTitle;
var
  B1, BNbLineToDel: Byte;
begin
  //Brain's info:
  //This procedure simply deletes the last Subtitle entry from ListBoxSubtitle
  //(in Form3). So it need to know how many line(s) there is to delete
  //including timing, blank line... (dependent of the number of line in the
  //last subtitle entry, or not if all line are put on the same)
  //When is it used? -> On certain badly authored DVDs subtitles there is no
  //stop time in some subtitles (00:00:00,000) so when SubRip detect this, it
  //put the start time of the next subtitle as stop time for the precedent.
  //Doing that it have to delete the last subtile entry (allready added) from
  //the Form3 and rewrite it with the new stop time.
  if ListBoxSubtitle.Items.Count < 1 then Exit;
  BNbLineToDel := 1; //default
  case TxtFile.OutputFormat of
    OFSubRip, OFIAuthor: BNbLineToDel := Form1.SubTitles.Sub[Form1.SubTitles.NbSub].NbLine + 3;
    //OFMDVD: ; //1 line delete = default
    //OFSubStationAlpha: ; //1 line delete = default
    OFTMPlayer: if Form13.OutPut.TMPlayer.TMPlType = 5 then BNbLineToDel := 2;
    //OFMpl: ; //1 line delete = default
    //OFMpl2: ; //1 line delete = default
    //OFDks: ; //1 line delete = default
    OFDVDSubtitle, OFFAB: BNbLineToDel := Form1.SubTitles.Sub[Form1.SubTitles.NbSub].NbLine + 2;
    OFSubSubViewer: BNbLineToDel := 2;
    OFSubSubViewer2: BNbLineToDel := 3;
    //OFSTL: ; //1 line delete = default
    OFPhilips:
      if not Form1.BMPOutPreset[1].Color.Custom then
      begin
        if (Form1.BMPOutPreset[1].Color.BitPerPixel = pf4bit) and
          ((Form1.SubTitles.NbSub = 1) or
          (Form1.SubTitles.Sub[Form1.SubTitles.NbSub].Clr <> Form1.SubTitles.Sub[Form1.SubTitles.NbSub - 1].Clr)) then
          Inc(BNbLineToDel);
        if (Form1.SubTitles.NbSub = 1) or
          (Form1.SubTitles.Sub[Form1.SubTitles.NbSub].Ctr <> Form1.SubTitles.Sub[Form1.SubTitles.NbSub - 1].Ctr) then
          Inc(BNbLineToDel);
      end;
    OFSonic: BNbLineToDel := Form1.SubTitles.Sub[Form1.SubTitles.NbSub].NbLine + 1;
    OFDVDMaestro:
    begin
      if Form13.OutPut.DVDMaestro.Extended then BNbLineToDel := 2; //1 by no_extended
      if not Form1.BMPOutPreset[4].Color.Custom then
      begin
        if (Form1.SubTitles.NbSub = 1) or
          (Form1.SubTitles.Sub[Form1.SubTitles.NbSub].Clr <> Form1.SubTitles.Sub[Form1.SubTitles.NbSub - 1].Clr) then
          Inc(BNbLineToDel);
        if (Form1.SubTitles.NbSub = 1) or
          (Form1.SubTitles.Sub[Form1.SubTitles.NbSub].Ctr <> Form1.SubTitles.Sub[Form1.SubTitles.NbSub - 1].Ctr) then
          Inc(BNbLineToDel);
      end;
    end;
    OFSST:
      if not Form1.BMPOutPreset[3].Color.Custom then
      begin
        if (Form1.SubTitles.NbSub = 1) or
          (Form1.SubTitles.Sub[Form1.SubTitles.NbSub].Clr <> Form1.SubTitles.Sub[Form1.SubTitles.NbSub - 1].Clr) then
          Inc(BNbLineToDel);
        if (Form1.SubTitles.NbSub = 1) or
          (Form1.SubTitles.Sub[Form1.SubTitles.NbSub].Ctr <> Form1.SubTitles.Sub[Form1.SubTitles.NbSub - 1].Ctr) then
          Inc(BNbLineToDel);
      end;
    //OFImpre: ; //1 line delete = default
    //OFMacSUB: ; //1 line delete = default
    //OFViPlay: ; //1 line delete = default
    //OFZeroG: ; //1 line delete = default
    //OFTurboTitler: ; //1 line delete = default
    //OFPowerDivX: ; //1 line delete = default
    //OFPhoenix: ; //1 line delete = default
    //OFMacDVDStudio: ; //1 line delete = default
  end;
  for B1 := 1 to BNbLineToDel do
  begin
    ListBoxSubtitle.Items.Delete(ListBoxSubtitle.Items.Count - 1);
    WideSubs.Delete(WideSubs.Count - 1);
  end;
end;

//------------------------------------------------------------------------------

function TForm3.CanShowSub(var TmpSub: TSub; var TmpStartTC, TmpStopTC: TTimeCodeMs): Boolean;
var
  CStartSub, CStopSub, CStartSplit, CStopSplit: Cardinal;
begin
  CStartSub := Unit07.TCMsToMSec(TmpSub.StartTC);
  CStopSub := Unit07.TCMsToMSec(TmpSub.StopTC);
  if CStopSub < CStartSub then
    CStopSub := CStartSub; //shit workaround e.g. for shitty "CStopSub = 0" case
  CStartSplit := Unit07.TCMsToMSec(TmpStartTC);
  CStopSplit := Unit07.TCMsToMSec(TmpStopTC);
  Result := (CStopSub > CStartSplit) and (CStartSub < CStopSplit);
end;

//------------------------------------------------------------------------------

function TForm3.CorrectSplitTime(var TmpSub: TSub; var TmpStartTC, TmpStopTC: TTimeCodeMs): TSub;
var
  CStartSub, CStopSub, CStartSplit, CStopSplit: Cardinal;
begin
  Result := TmpSub;
  CStartSub := Unit07.TCMsToMSec(Result.StartTC);
  CStopSub := Unit07.TCMsToMSec(Result.StopTC);
  CStartSplit := Unit07.TCMsToMSec(TmpStartTC);
  CStopSplit := Unit07.TCMsToMSec(TmpStopTC);
  if CStopSub > CStopSplit then
  begin
    Result.StopTC := TmpStopTC; //Avoid the last subtitle of the split to oversize the split
    CStopSub := Unit07.TCMsToMSec(Result.StopTC);
  end;
  if CStartSplit > 0 then //Correct the time (relatively to the startsplit)
  begin
    if CStartSub < CStartSplit then
      Result.StartTC := MSecToTCMs(0) //for first subtitle of 2nd, 3rd, ... part when subtitles overlapping parts
    else
      Result.StartTC := MSecToTCMs(CStartSub - CStartSplit);
    if CStopSub < CStartSplit then
      Result.StopTC := MSecToTCMs(0) //shit workaround e.g. for shitty "CStopSub = 0" case
    else
      Result.StopTC := MSecToTCMs(CStopSub - CStartSplit);
  end;
end;

//------------------------------------------------------------------------------

function TForm3.ForceMinInterMs(TmpTcMs1, TmpTcMs2: TTimeCodeMs; LMinInter: Integer): TTimeCodeMs; //Verify that a minimum of LMinInter interval
var //exist between two TCMs, if not the TmpTcMs1 is
  LMsec1: Integer; //decreased consequently.
  LInter: Integer;
begin
  LMsec1 := TCMsToMsec(TmpTcMs1);
  LInter := TCMsToMsec(TmpTcMs2) - LMsec1;
  if (LInter >= 0) and (LInter < LMinInter) then
    Dec(LMsec1, (LMinInter - LInter));
  Result := MSecToTCMs(LMsec1);
end;

//------------------------------------------------------------------------------

function TForm3.StripStyle(const St: Widestring): Widestring;
begin
  Result := Tnt_WideStringReplace(St, '<b>', '', [rfReplaceAll, rfIgnoreCase]);
  Result := Tnt_WideStringReplace(Result, '<i>', '', [rfReplaceAll, rfIgnoreCase]);
  Result := Tnt_WideStringReplace(Result, '<u>', '', [rfReplaceAll, rfIgnoreCase]);
  Result := Tnt_WideStringReplace(Result, '</b>', '', [rfReplaceAll, rfIgnoreCase]);
  Result := Tnt_WideStringReplace(Result, '</i>', '', [rfReplaceAll, rfIgnoreCase]);
  Result := Tnt_WideStringReplace(Result, '</u>', '', [rfReplaceAll, rfIgnoreCase]);
end;

//------------------------------------------------------------------------------

procedure TForm3.AddSubTitle(WNumSub: Word; BScrollDown: Boolean);
var
  TmpSub: TSub;
  CanShow: Boolean;

//-----------------
{   Function SecToStrTime ( CNbSec : Cardinal ) : WideString;
      Var
         Bh,Bm,Bs    : Byte;
         St1,St2,St3 : WideString[2];
      begin
         Bh := CNbSec Div 3600;
         Bm := (CNbSec Mod 3600) Div 60;
         Bs := CNbSec - (Bh * 3600) - (Bm * 60);
         If Bh > 9 Then St1 := IntToStr(Bh) Else St1 := '0' + IntToStr(Bh);
         If Bm > 9 Then St2 := IntToStr(Bm) Else St2 := '0' + IntToStr(Bm);
         If Bs > 9 Then St3 := IntToStr(Bs) Else St3 := '0' + IntToStr(Bs);
         Result := St1+':'+St2+':'+St3;
      End; }
  //-----------------
  function RoundTC(TmpTc: TTimeCodeMs): TTimeCodeMs;
  begin
    if TmpTc.Ms > 500 then //Arrondi  la sec sup si ms > 500
    begin
      Result := NulTimeCodeMs;
      Result.Sec := 1;
      TmpTc := Unit07.AddTcMs(TmpTc, Result); //Ajoute 1s
    end;
    Result := TmpTc;
    Result.Ms := 0;
  end;
  //-----------------
  function TCmsToTC(TmpTcodeMs: TTimeCodeMs; TmpFrameRate: Word; TmpDropFrame: Boolean): TTimeCode;
  begin
    Result.Hour := TmpTcodeMs.Hour;
    Result.Min := TmpTcodeMs.Min;
    Result.Sec := TmpTcodeMs.Sec;
    Result.Frame := 0; //before summation
    Result := Unit07.AddTCFrames(Result, Trunc(0.5 + TmpTcodeMs.Ms * TmpFrameRate / 100000)); //because of frame count = 25 (30)
    //Result.Frame := ((TmpTcodeMs.Ms div 10) * TmpFrameRate) div 10000; -- old

    //For NTSC Dropframe timecodes, the following timecodes do not exist:
    //Frame 0 and 1 of each minute, except for 0, 10, 20, 30, 40 and 50 minutes.
    if TmpDropFrame then
      if (Result.Sec = 0) and
        (Result.Frame in [0, 1]) and
        ((Result.Min mod 10) <> 0) then Result.Frame := 2;
  end;
  //-----------------
 {  Function InterSecTC ( TmpTc1,TmpTc2 : TTimeCodeMs) : Word;
      Var
         C1,C2  : Cardinal;
      Begin
         C1 := TmpTc1.Hour * 3600 + TmpTc1.Min * 60 + TmpTc1.sec;
         C2 := TmpTc2.Hour * 3600 + TmpTc2.Min * 60 + TmpTc2.sec;
         Result := C2 - C1;
      End; }
  //-----------------
  //Added by LRN (LordRuslanNightmare@gmail.com)
  function XMLizeString(s : Widestring): Widestring;
  var
    I1 : integer;
  begin
    Result := '';
    for I1 := 1 to Length(s) do
    begin
      if ord(s[I1]) > 127 then
        Result := Result + '&#' + IntToStr(ord(s[I1])) + ';'
      else if s[I1] = '&' then Result := Result + '&amp;'
      else if s[I1] = '''' then Result := Result + '&apos;'
//      else if s[I1] = '!' then Result := Result + '&bang;' //MP4Box don't change this
//      else if s[I1] = '=' then Result := Result + '&eq;' //MP4Box don't change this
      else if s[I1] = '>' then Result := Result + '&gt;'
      else if s[I1] = '<' then Result := Result + '&lt;'
//      else if s[I1] = '?' then Result := Result + '&quest;' //MP4Box don't change this
      else if s[I1] = '"' then Result := Result + '&quot;'
//      else if s[I1] = '/' then Result := Result + '&slash;' //MP4Box don't change this
      else Result := Result + s[I1];
    end;
    Result := Result;
  end;

  procedure AddSubTitleTTXT;
  var
    TmpLine,TmpLine2,TmpLine3 : Widestring;
    I1,I2 : integer;
    IsI, IsB, IsU : string;
    Styles : string;
  begin
    TmpLine3 := '';
    for I2 := 1 to TmpSub.NbLine do
    begin
      Styles := '';

      TmpLine := TmpSub.Line[I2];
      TmpLine := Tnt_WideStringReplace(TmpLine,'<i>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'<b>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'<u>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'</i>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'</b>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'</u>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'<I>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'<B>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'<U>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'</I>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'</B>','',[rfReplaceAll]);
      TmpLine := Tnt_WideStringReplace(TmpLine,'</U>','',[rfReplaceAll]);
      TmpLine2 := Tnt_WideLowerCase(TmpSub.Line[I2]);

      IsI := '';
      IsB := '';
      IsU := '';

      I1 := 1;
      while I1 <= Length(TmpLine2) do
      begin
        //style begins
        if (TmpLine2[I1] = '<') and (TmpLine2[I1+2] = '>') then
        begin
          //close previous style
          if not ((IsI = '') and (IsB = '') and (IsU = '')) then
            Styles := Styles + Tnt_WideFormat(' toChar="%d"/>',[I1-1]);

          if TmpLine2[I1+1] = 'i' then
          begin
            IsI := 'Italic ';
            TmpLine2 := Tnt_WideStringReplace(TmpLine2,'<i>','',[]);
          end
          else if TmpLine2[I1+1] = 'b' then
          begin
            IsB := 'Bold ';
            TmpLine2 := Tnt_WideStringReplace(TmpLine2,'<b>','',[]);
          end
          else if TmpLine2[I1+1] = 'u' then
          begin
            IsU := 'Underine ';
            TmpLine2 := Tnt_WideStringReplace(TmpLine2,'<u>','',[]);
          end;
          //open new style
          if Styles <> '' then Styles := Styles + chr(13)+chr(10);
          Styles := Styles + Tnt_WideFormat('<Style fromChar="%d" styles="%s%s%s" fontSize="%d" color="%x %x %x %x"',[I1-1,IsU,IsB,IsI,Form13.OutPut.TTXT.FontSize,Form13.OutPut.TTXT.FontColor[0],Form13.OutPut.TTXT.FontColor[1],Form13.OutPut.TTXT.FontColor[2],Form13.OutPut.TTXT.FontColor[3]]);
          Inc(I1);
          continue;
        end
        //style ends
        else if (TmpLine2[I1] = '<') and (TmpLine2[I1+1] = '/') and (TmpLine2[I1+3] = '>') then
        begin
          //close previous style
          if not ((IsI = '') and (IsB = '') and (IsU = '')) then
            Styles := Styles + Tnt_WideFormat(' toChar="%d"/>',[I1-1]);

          if TmpLine2[I1+2] = 'i' then
          begin
            IsI := '';
            TmpLine2 := Tnt_WideStringReplace(TmpLine2,'</i>','',[]);
          end
          else if TmpLine2[I1+2] = 'b' then
          begin
            IsB := '';
            TmpLine2 := Tnt_WideStringReplace(TmpLine2,'</b>','',[]);
          end
          else if TmpLine2[I1+2] = 'u' then
          begin
            IsU := '';
            TmpLine2 := Tnt_WideStringReplace(TmpLine2,'</u>','',[]);
          end;
          //if not all styles was closed, open new style
          if not ((IsI = '') and (IsB = '') and (IsU = '')) then
          begin
            if Styles <> '' then Styles := Styles + chr(13)+chr(10);
            Styles := Styles + Tnt_WideFormat('<Style fromChar="%d" styles="%s%s%s" fontSize="%d" color="%x %x %x %x"',[I1-1,IsU,IsB,IsI,Form13.OutPut.TTXT.FontSize,Form13.OutPut.TTXT.FontColor[0],Form13.OutPut.TTXT.FontColor[1],Form13.OutPut.TTXT.FontColor[2],Form13.OutPut.TTXT.FontColor[3]]);
          end;
          Inc(I1);
          continue;
        end;
        Inc(I1);
      end;

      TmpLine := XMLizeString(TmpLine); //transfer non-latin chars to 2-byte hex unicode and change illegal chars

      TmpLine3 := TmpLine3 + '''' + TmpLine + '''';

    end;

    with TTXTLastStop do
      if (Hour <> 0) or (Min <> 0) or (Sec <> 0) or (Ms <> 0) then
        if (TmpSub.StartTC.Hour > Hour) or (TmpSub.StartTC.Hour >= Hour) and ( (TmpSub.StartTC.Min > Min) or (TmpSub.StartTC.Min >= Min) and ( (TmpSub.StartTC.Sec > Sec) or (TmpSub.StartTC.Sec >=Sec) and (TmpSub.StartTC.Ms > Ms) ) ) then
        begin
          AddLine(Tnt_WideFormat('<TextSample sampleTime="%.2d:%.2d:%.2d.%.3d" text="">',[Hour,Min,Sec,Ms]));
          AddLine('</TextSample>');
        end;

    with TmpSub.StartTC do AddLine(Tnt_WideFormat('<TextSample sampleTime="%.2d:%.2d:%.2d.%.3d" text="%s">',[Hour,Min,Sec,Ms,TmpLine3]));
    if Styles <> '' then
      AddLine(Styles);
    AddLine('</TextSample>');
    TTXTLastStop := TmpSub.StopTC;
  end;
  //-----------------
  procedure AddSubTitleSubRip;
  var
    I1: Integer;
    StCtrl: Widestring;
  begin
    AddLine(IntToStr(WNumSub + Form13.SpinEditSubRipOffset.Value - TxtFile.SplitIndex));
    StCtrl := Unit07.TCmsToStr(TmpSub.StartTC) + ' --> ' + Unit07.TCmsToStr(TmpSub.StopTC);
    //---------------------        Increase time between two sub if smaller than a value
    { If (WNumSub < Form1.SubTitles.NbSub) Then
       Begin
           NextTmpTc :=  Form1.SubTitles.Sub[WNumSub +1].StartTC;
         If (TmpSub.StopTc.Hour = NextTmpTc.Hour) And
            (TmpSub.StopTc.Min = NextTmpTc.Min) And
            (TmpSub.StopTc.Sec = NextTmpTc.Sec) And
            ( (TmpSub.StopTc.Ms Div 100) = (NextTmpTc.Ms Div 100) ) And
            ( ( (NextTmpTc.Ms Div 100) - (TmpSub.StopTc.Ms Div 100)) < 2  ) Then Show/\Message ( IntToStr(WNumSub) );
       End;   }
    //---------------------
    if Form13.OutPut.SubRip.Extended or
      (TxtFile.OutputFormat = OFIAuthor) then
      StCtrl := StCtrl + Tnt_WideFormat('  X1:%.3d X2:%.3d Y1:%.3d Y2:%.3d',
        [TmpSub.Coord.Left, TmpSub.Coord.Right,
        TmpSub.Coord.Top, TmpSub.Coord.Bottom]);
    AddLine(StCtrl);

    if Form13.OutPut.SubRip.ClrTags and (TxtFile.OutputFormat <> OFIAuthor) then
      for I1 := 1 to TmpSub.NbLine do
        AddLine('<font color="#' +
          Tnt_WideLowerCase(IntToHex(TmpSub.PaClr[I1], 6)) +
          '">' + TmpSub.Line[I1] + '</font>')
    else
      for I1 := 1 to TmpSub.NbLine do
        AddLine(TmpSub.Line[I1]);

    AddLine('');
  end;
  //-----------------
  procedure AddSubTitleMDVD;
  var
    I1, pom: Integer; //pom .. for decimal point position
    StTC1, StTC2: Integer;
    St1, StyleS: Widestring;
    kFPS: Integer; //FPS * 1000
  begin
    //decimal point processing (, or . depending on country)
    pom := 0;
    if Pos('.', Form13.MDVDComboBox.Text) > 0
      then pom := Pos('.', Form13.MDVDComboBox.Text);
    if Pos(',', Form13.MDVDComboBox.Text) > 0
      then pom := Pos(',', Form13.MDVDComboBox.Text);
    if pom > 0
      then kFPS := StrToIntDef(Copy(Form13.MDVDComboBox.Text, 1, pom - 1), 25) * 1000 +
      StrToIntDef(Copy(Form13.MDVDComboBox.Text, pom + 1, Length(Form13.MDVDComboBox.Text) - pom), 0)
    else kFPS := 1000 * StrToIntDef(Form13.MDVDComboBox.Text, 25); //dic point not present

    StTC1 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StartTC) / 1000)); //brackets have reason here :-)
    StTC2 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StopTC) / 1000));

    St1 := '{' + IntToStr(StTC1) + '}{' + IntToStr(StTC2) + '}';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '|'; //Line separator

      //style - MicroDVD DOC NORM:
      //{y:style}/{Y:style} ... subtitle line/item style (bold, italic, underline)
      //b, i and u, e.g. bi to make the line bold+italic, or i,u to make it italic-underline.
      //You can use any separator you wish, all chars besides b, i and u are ignored.
      StyleS := '{y:';
      if (Pos('<b>', Tnt_WideLowerCase(TmpSub.Line[I1])) = 1) and
        (Pos('</b>', Tnt_WideLowerCase(TmpSub.Line[I1])) = Length(TmpSub.Line[I1]) - 3)
        then
      begin
        StyleS := StyleS + 'b';
        TmpSub.Line[I1] := Copy(TmpSub.Line[I1], 4, Length(TmpSub.Line[I1]) - 7);
      end;
      if (Pos('<i>', Tnt_WideLowerCase(TmpSub.Line[I1])) = 1) and
        (Pos('</i>', Tnt_WideLowerCase(TmpSub.Line[I1])) = Length(TmpSub.Line[I1]) - 3)
        then
      begin
        StyleS := StyleS + 'i';
        TmpSub.Line[I1] := Copy(TmpSub.Line[I1], 4, Length(TmpSub.Line[I1]) - 7);
      end;
      if (Pos('<u>', Tnt_WideLowerCase(TmpSub.Line[I1])) = 1) and
        (Pos('</u>', Tnt_WideLowerCase(TmpSub.Line[I1])) = Length(TmpSub.Line[I1]) - 3)
        then
      begin
        StyleS := StyleS + 'u';
        TmpSub.Line[I1] := Copy(TmpSub.Line[I1], 4, Length(TmpSub.Line[I1]) - 7);
      end;

      if StyleS <> '{y:' then
        TmpSub.Line[I1] := StyleS + '}' + TmpSub.Line[I1];

      St1 := St1 + TmpSub.Line[I1];
    end;

    St1 := Tnt_WideStringReplace(St1, '<b>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '<i>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '<u>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '</b>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '</i>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '</u>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '""', '"', [rfReplaceAll]);

    AddLine(St1);
  end;
  //-----------------
  procedure AddSubTitleSubStationAlpha;
  var
    I1, Postn: Integer;
    StCtrl: Widestring;
    StTC1, StTC2: Widestring;
    StBegin, StEnd: Widestring;
  begin
    Postn := 1;
    StTC1 := Unit07.TCMsToStr(TmpSub.StartTC);
    StTC2 := Unit07.TCMsToStr(TmpSub.StopTC);
    StBegin := Copy(StTC1, 2, 7) + '.' + Copy(StTC1, 10, 2);
    StEnd := Copy(StTC2, 2, 7) + '.' + Copy(StTC2, 10, 2);
    for I1 := 1 to TmpSub.NbLine do
    begin
      StCtrl := StCtrl + TmpSub.Line[I1];
      if I1 < TmpSub.NbLine then
      begin
        //style related
        try //when Length < asked :-)
          if TmpSub.Line[I1 + 1][1] = '<' then
          begin
            Postn := 4;
            if TmpSub.Line[I1 + 1][4] = '<' then
            begin
              Postn := 7;
              if TmpSub.Line[I1 + 1][7] = '<' then Postn := 10;
            end;
          end;
        finally
        end;

        //insert either \N or \n for SSA "smart-wrapping" feature
        if Tnt_WideUpperCase(TmpSub.Line[I1 + 1][Postn]) = TmpSub.Line[I1 + 1][Postn]
          then StCtrl := StCtrl + '\N'
        else StCtrl := StCtrl + '\n';
      end;
    end;

    //SSA styles
    if Pos('<', StCtrl) > 0 then
    begin
      //no underline support (only in .ASS)
      StCtrl := Tnt_WideStringReplace(StCtrl, '<u>', '', [rfReplaceAll, rfIgnoreCase]);
      StCtrl := Tnt_WideStringReplace(StCtrl, '</u>', '', [rfReplaceAll, rfIgnoreCase]);
      //interline
      StCtrl := Tnt_WideStringReplace(StCtrl, '</b>\N<b>', '\N', [rfReplaceAll]);
      StCtrl := Tnt_WideStringReplace(StCtrl, '</b>\n<b>', '\n', [rfReplaceAll]);
      StCtrl := Tnt_WideStringReplace(StCtrl, '</i>\N<i>', '\N', [rfReplaceAll]);
      StCtrl := Tnt_WideStringReplace(StCtrl, '</i>\n<i>', '\n', [rfReplaceAll]);
      //There is an {\i1}italicised{\i0} word here
      StCtrl := Tnt_WideStringReplace(StCtrl, '<i>', '{\i1}', [rfReplaceAll, rfIgnoreCase]);
      StCtrl := Tnt_WideStringReplace(StCtrl, '</i>', '{\i0}', [rfReplaceAll, rfIgnoreCase]);
      //There is a {\b1}bold{\b0} word here
      StCtrl := Tnt_WideStringReplace(StCtrl, '<b>', '{\b1}', [rfReplaceAll, rfIgnoreCase]);
      StCtrl := Tnt_WideStringReplace(StCtrl, '</b>', '{\b0}', [rfReplaceAll, rfIgnoreCase]);
    end;
    AddLine('Dialogue: Marked=0,' + StBegin + ',' + StEnd + ',Style1,Comment,0000,0000,0000,,' + StCtrl);
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleTMPlayer;
  var
    I1, I2: Integer;
    TimeS, St1: Widestring;
    TmpTime: TTimeCodeMs;
  begin
    TmpTime := RoundTC(TmpSub.StartTC);
    if Form13.OutPut.TMPlayer.TMPlType in [2, 4]
      then TimeS := Tnt_WideFormat('%.1d', [TmpTime.Hour])
    else TimeS := Tnt_WideFormat('%.2d', [TmpTime.Hour]);
    TimeS := TimeS + Tnt_WideFormat(':%.2d:%.2d', [TmpTime.Min, TmpTime.Sec]);

    if Form13.OutPut.TMPlayer.TMPlType in [1, 2] then TimeS := TimeS + ':';
    if Form13.OutPut.TMPlayer.TMPlType in [3, 4] then TimeS := TimeS + '=';

    if Form13.OutPut.TMPlayer.TMPlType <> 5
      then
    begin
      for I1 := 1 to TmpSub.NbLine do
      begin
        if I1 > 1 then St1 := St1 + '|'; //Line separator
        St1 := St1 + TmpSub.Line[I1];
      end;
      AddLine(TimeS + StripStyle(St1));
    end
    else
    begin
      for I1 := 1 to TmpSub.NbLine do
      begin
        St1 := '';
        if TmpSub.NbLine = 1 then
        begin
          AddLine(TimeS + ',1=' + StripStyle(TmpSub.Line[1]));
          AddLine(TimeS + ',2=');
        end;
        if TmpSub.NbLine > 1 then
        begin
          AddLine(TimeS + ',1=' + StripStyle(TmpSub.Line[1]));
          for I2 := 2 to TmpSub.NbLine do
            St1 := St1 + TmpSub.Line[I2] + ' ';
          AddLine(TimeS + ',2=' + StripStyle(St1));
          Exit;
        end;
      end;
    end;
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  //This is modified procedure AddSubTitleMDVD;
  procedure AddSubTitleMpl;
  var
    I1, pom: Integer; //pom .. for decimal point position
    StTC1, StTC2: Integer;
    St1: Widestring;
    kFPS: Integer; //FPS * 1000
  begin
    //decimal point processing (, or . depending on country)
    pom := 0;
    if Pos('.', Form13.ComboBoxMpl.Text) > 0
      then pom := Pos('.', Form13.ComboBoxMpl.Text);
    if Pos(',', Form13.ComboBoxMpl.Text) > 0
      then pom := Pos(',', Form13.ComboBoxMpl.Text);
    if pom > 0
      then kFPS := StrToIntDef(Copy(Form13.ComboBoxMpl.Text, 1, pom - 1), 25) * 1000 +
      StrToIntDef(Copy(Form13.ComboBoxMpl.Text, pom + 1, Length(Form13.ComboBoxMpl.Text) - pom), 0)
    else kFPS := 1000 * StrToIntDef(Form13.ComboBoxMpl.Text, 25); //dic point not present

    StTC1 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StartTC) / 1000)); //brackets have reason here :-)
    StTC2 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StopTC) / 1000));

    St1 := IntToStr(StTC1) + ',' + IntToStr(StTC2) + ',0,';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if (I1 > 1) then St1 := St1 + '|'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;

    AddLine(StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleMacSUB;
  var
    I1, pom: Integer; //pom .. for decimal point position
    StTC1, StTC2: Integer;
    St1: Widestring;
    kFPS: Integer; //FPS * 1000
  begin
    //decimal point processing (, or . depending on country)
    pom := 0;
    if Pos('.', Form13.ComboBoxMacSUB.Text) > 0
      then pom := Pos('.', Form13.ComboBoxMacSUB.Text);
    if Pos(',', Form13.ComboBoxMacSUB.Text) > 0
      then pom := Pos(',', Form13.ComboBoxMacSUB.Text);
    if pom > 0
      then kFPS := StrToIntDef(Copy(Form13.ComboBoxMacSUB.Text, 1, pom - 1), 25) * 1000 +
      StrToIntDef(Copy(Form13.ComboBoxMacSUB.Text, pom + 1, Length(Form13.ComboBoxMpl.Text) - pom), 0)
    else kFPS := 1000 * StrToIntDef(Form13.ComboBoxMacSUB.Text, 25); //dic point not present

    StTC1 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StartTC) / 1000)); //brackets have reason here :-)
    StTC2 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StopTC) / 1000));

    St1 := '/' + IntToStr(StTC1);
    //+ ',' + IntToStr(StTC2) + ',0,';
    AddLine(StripStyle(St1));
    for I1 := 1 to TmpSub.NbLine do
    begin
      {If (I1 > 1) Then St1 := St1 + '|'; //Line separator}
      St1 := TmpSub.Line[I1];
      AddLine(StripStyle(St1));
    end;
    St1 := '/' + IntToStr(StTC2);
    AddLine(StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleMpl2;
  var
    I1: Integer;
    StartSec, StopSec, St1: Widestring;
  begin
    StartSec := '[' + IntToStr(TmpSub.StartTC.Hour * 36000 + TmpSub.StartTC.Min * 600 + TmpSub.StartTC.Sec * 10 + Round(TmpSub.StartTC.Ms / 100)) + ']';
    StopSec := '[' + IntToStr(TmpSub.StopTC.Hour * 36000 + TmpSub.StopTC.Min * 600 + TmpSub.StopTC.Sec * 10 + Round(TmpSub.StopTC.Ms / 100)) + ']';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '|'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(StartSec + StopSec + StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleDks;
  var
    I1: Integer;
    TimeS, St1: Widestring;
    TmpTime: TTimeCodeMs;
  begin
    TmpTime := RoundTC(TmpSub.StartTC);
    TimeS := Tnt_WideFormat('[%.2d:%.2d:%.2d]', [TmpTime.Hour, TmpTime.Min, TmpTime.Sec]);
    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '[br]'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(TimeS + StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleViPlay;
  var
    I1: Integer;
    TimeS, St1: Widestring;
  begin
    TimeS := Unit07.TCmsToStr(TmpSub.StartTC) + '-' + Unit07.TCmsToStr(TmpSub.StopTC) + '=';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '|'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(TimeS + StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleZeroG;
  var
    I1: Integer;
    TimeS, St1: Widestring;
  begin
    TimeS := 'E 1 ' +
      Tnt_WideFormat('%.1d:%.2d:%.2d.%.2d', [TmpSub.StartTC.Hour, TmpSub.StartTC.Min,
      TmpSub.StartTC.Sec, Round(TmpSub.StartTC.Ms / 10)]) + ' ' +
      Tnt_WideFormat('%.1d:%.2d:%.2d.%.2d', [TmpSub.StopTC.Hour, TmpSub.StopTC.Min,
      TmpSub.StopTC.Sec, Round(TmpSub.StopTC.Ms / 10)]) + ' Default NTP ';

    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '\n'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(TimeS + StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleTurboTitler;
  var
    I1: Integer;
    TimeS, St1: Widestring;
  begin
    TimeS := Tnt_WideFormat('%.1d:%.2d:%.2d.%.2d', [TmpSub.StartTC.Hour, TmpSub.StartTC.Min,
      TmpSub.StartTC.Sec, Round(TmpSub.StartTC.Ms / 10)]) + ',' +
      Tnt_WideFormat('%.1d:%.2d:%.2d.%.2d', [TmpSub.StopTC.Hour, TmpSub.StopTC.Min,
      TmpSub.StopTC.Sec, Round(TmpSub.StopTC.Ms / 10)]) + ',NTP ';

    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '|'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(TimeS + StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitlePowerDivX;
  var
    I1: Integer;
    TimeS, St1: Widestring;
    TmpTime: TTimeCodeMs;
  begin
    TmpTime := RoundTC(TmpSub.StartTC);
    TimeS := Tnt_WideFormat('{%.2d:%.2d:%.2d}', [TmpTime.Hour, TmpTime.Min, TmpTime.Sec]);
    TmpTime := RoundTC(TmpSub.StopTC);
    TimeS := TimeS + Tnt_WideFormat('{%.2d:%.2d:%.2d}', [TmpTime.Hour, TmpTime.Min, TmpTime.Sec]);
    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '|'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(TimeS + StripStyle(St1));
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitleDVDSubtitle;
  var I: Integer;
  begin
    AddLine(Tnt_WideFormat('{T %.2d:%.2d:%.2d:%.2d',
      [TmpSub.StartTC.Hour, TmpSub.StartTC.Min,
      TmpSub.StartTC.Sec, Round(TmpSub.StartTC.Ms / 10)]));
    for I := 1 to TmpSub.NbLine do
      AddLine(StripStyle(TmpSub.Line[I]));
    AddLine('}');
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddSubTitlePhoenix;
  var
    I1, pom: Integer; //pom .. for decimal point position
    StTC1, StTC2: Integer;
    St1, St2: Widestring;
    kFPS: Integer; //FPS * 1000
  begin
    //decimal point processing (, or . depending on country)
    pom := 0;
    if Pos('.', Form13.ComboBoxMpl.Text) > 0
      then pom := Pos('.', Form13.ComboBoxMpl.Text);
    if Pos(',', Form13.ComboBoxMpl.Text) > 0
      then pom := Pos(',', Form13.ComboBoxMpl.Text);
    if pom > 0
      then kFPS := StrToIntDef(Copy(Form13.ComboBoxMpl.Text, 1, pom - 1), 25) * 1000 +
      StrToIntDef(Copy(Form13.ComboBoxMpl.Text, pom + 1, Length(Form13.ComboBoxMpl.Text) - pom), 0)
    else kFPS := 1000 * StrToIntDef(Form13.ComboBoxMpl.Text, 25); //dic point not present

    StTC1 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StartTC) / 1000)); //brackets have reason here :-)
    StTC2 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StopTC) / 1000));
    St1 := IntToStr(StTC1);
    while Length(St1) <> 7 do St1 := ' ' + St1;
    St2 := St1;

    St1 := IntToStr(StTC2);
    while Length(St1) <> 7 do St1 := ' ' + St1;

    St1 := St2 + ',' + St1 + ', ';

    St2 := '';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if (I1 > 1) then St2 := St2 + '|'; //Line separator
      St2 := St2 + TmpSub.Line[I1];
    end;
    St2 := '"' + St2 + '"';
    St1 := St1 + St2;
    AddLine(StripStyle(St1));
  end;
  //-----------------
  procedure AddSubTitleSubViewer;
  var
    I1: Integer;
    St1: Widestring;
    TmpTc: TTimeCodeMs;
    TmpTc2: TTimeCodeMs;
    PrevTmpTc: TTimeCodeMs;
  begin
    TmpTc := TmpSub.StartTC;
    TmpTc2 := TmpSub.StopTC;
    if (WNumSub > 1) then PrevTmpTc := Form1.SubTitles.Sub[WNumSub - 1].StopTC;
    if Form13.CheckBoxRoundTC.Checked then
    begin
      TmpTc := RoundTC(TmpTc);
      TmpTc2 := RoundTC(TmpTc2);
      PrevTmpTc := RoundTC(PrevTmpTc);
    end;

    if (WNumSub > 1) and (Unit07.TCMsToMSec(PrevTmpTc) < Unit07.TCMsToMSec(TmpTc)) then //Efface le precedent sous-titre si le delai est pass
    begin
      St1 := Unit07.TCMsToStr(PrevTmpTc);
      AddLine('[' + Copy(St1, 1, 8) + ']');
      AddLine('');
    end;
    St1 := Unit07.TCMsToStr(TmpTc);

    AddLine('[' + Copy(St1, 1, 8) + ']');
    St1 := '';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if (I1 = 2) then St1 := St1 + '|' //Ajoute le sparateur de ligne
      else if (I1 > 2) then
        if not (Form13.CheckBox2LineMax.Checked) then St1 := St1 + '|' else St1 := St1 + ' ';
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(StripStyle(St1));
  end;
  //-----------------
  procedure AddSubTitleSubViewer2;
  var
    I1: Integer;
    StTC1, StTC2: Widestring;
    StBegin, StEnd: Widestring;
    St1: Widestring;
  begin
    StTC1 := Unit07.TCMsToStr(TmpSub.StartTC);
    StTC2 := Unit07.TCMsToStr(TmpSub.StopTC);
    StBegin := Copy(StTC1, 1, 8) + '.' + Copy(StTC1, 10, 2);
    StEnd := Copy(StTC2, 1, 8) + '.' + Copy(StTC2, 10, 2);

    AddLine(StBegin + ',' + StEnd); //TimeCode line
    St1 := '';
    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '[br]'; //Line separator
      if Form13.Output.SubV2.PresStyles then
        St1 := St1 + '<font color="#' + Tnt_WideLowerCase(IntToHex(TmpSub.PaClr[I1], 6)) + '">' +
          TmpSub.Line[I1] + '</font>'
      else
        St1 := St1 + TmpSub.Line[I1]
    end;
    if Form13.Output.SubV2.PresStyles then
      AddLine(St1)
    else
      AddLine(StripStyle(St1));
    AddLine(''); //blank font-style line
  end;
  //-----------------
  procedure AddSubTitleSTL;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    St1, StBegin, StEnd, StyleS: Widestring;
    I1: Integer;
  begin
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));
    St1 := StBegin + ',' + StEnd + ',';

    for I1 := 1 to TmpSub.NbLine do
    begin
      if (I1 > 1) then St1 := St1 + '|'; //Line separator
      //style - ^i for italic, ^u underline, ^b, bold (affects the whole line)
      StyleS := '';
      if (Pos('<b>', Tnt_WideLowerCase(TmpSub.Line[I1])) = 1) and
        (Pos('</b>', Tnt_WideLowerCase(TmpSub.Line[I1])) = Length(TmpSub.Line[I1]) - 3) then
      begin
        StyleS := StyleS + '^b';
        TmpSub.Line[I1] := Copy(TmpSub.Line[I1], 4, Length(TmpSub.Line[I1]) - 7);
      end;
      if (Pos('<i>', Tnt_WideLowerCase(TmpSub.Line[I1])) = 1) and
        (Pos('</i>', Tnt_WideLowerCase(TmpSub.Line[I1])) = Length(TmpSub.Line[I1]) - 3) then
      begin
        StyleS := StyleS + '^i';
        TmpSub.Line[I1] := Copy(TmpSub.Line[I1], 4, Length(TmpSub.Line[I1]) - 7);
      end;
      if (Pos('<u>', Tnt_WideLowerCase(TmpSub.Line[I1])) = 1) and
        (Pos('</u>', Tnt_WideLowerCase(TmpSub.Line[I1])) = Length(TmpSub.Line[I1]) - 3) then
      begin
        StyleS := StyleS + '^u';
        TmpSub.Line[I1] := Copy(TmpSub.Line[I1], 4, Length(TmpSub.Line[I1]) - 7);
      end;
      if StyleS <> '' then
        TmpSub.Line[I1] := StyleS + TmpSub.Line[I1];
      St1 := St1 + TmpSub.Line[I1];
    end;

    St1 := Tnt_WideStringReplace(St1, '<b>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '<i>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '<u>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '</b>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '</i>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '</u>', '"', [rfReplaceAll, rfIgnoreCase]);
    St1 := Tnt_WideStringReplace(St1, '""', '"', [rfReplaceAll]);

    AddLine(St1);
  end;
  //----------
  function GetOrigClrIdxs(UsedFmt: Byte): Widestring;
  begin
    if UsedFmt = 3 then //SST add 1
      Result := Tnt_WideFormat('(%d %d %d %d)',
        [TmpSub.Clr and $000F + 1,
        (TmpSub.Clr and $00F0) shr 4 + 1,
        (TmpSub.Clr and $0F00) shr 8 + 1,
        (TmpSub.Clr and $F000) shr 12 + 1])
    else
      Result := Tnt_WideFormat('(%d %d %d %d)',
        [TmpSub.Clr and $000F,
        (TmpSub.Clr and $00F0) shr 4,
        (TmpSub.Clr and $0F00) shr 8,
        (TmpSub.Clr and $F000) shr 12]);
  end;
  //----------
  function GetOrigCtrIdxs: Widestring;
  begin
    Result := Format('(%d %d %d %d)',
      [TmpSub.Ctr and $000F,
      (TmpSub.Ctr and $00F0) shr 4,
      (TmpSub.Ctr and $0F00) shr 8,
      (TmpSub.Ctr and $F000) shr 12]);
  end;
  //-G1-------
  procedure AddSubTitlePhilips;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    St1: Widestring;
  begin
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    if not Form1.BMPOutPreset[1].Color.Custom and not TxtFile.Loaded then
    begin
      if (Form1.BMPOutPreset[1].Color.BitPerPixel = pf4bit) and
        ((WNumSub = 1) or
        (TmpSub.Clr <> Form1.SubTitles.Sub[WNumSub - 1].Clr)) then
        AddLine('COLOR'#9#9 + GetOrigClrIdxs(1));
      if (WNumSub = 1) or
        (TmpSub.Ctr <> Form1.SubTitles.Sub[WNumSub - 1].Ctr) then
        AddLine('CONTRAST'#9 + GetOrigCtrIdxs);
    end;

    St1 := TmpSub.Line[1] + ' ' +
      TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame)) + ' ' +
      TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame)) +
      Format(' %.3d %.3d %.3d %.3d',
      [TmpSub.Coord.Right - TmpSub.Coord.Left + 1, //Width
      TmpSub.Coord.Bottom - TmpSub.Coord.Top + 1, //Height
        TmpSub.Coord.Left, TmpSub.Coord.Top]); //Left, Top

    AddLine(St1);
  end;
  //-G2-------
  procedure AddSubTitleSonic;
  var
    I1: Integer;
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    StBegin, StEnd: Widestring;
    StNbSub: Widestring;
  begin
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    StNbSub := Format('%.4d', [WNumSub - TxtFile.SplitIndex]);
    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));
    AddLine(StNbSub + '  ' + StBegin + '  ' + StEnd + '  ' + TmpSub.Line[1]);
    for I1 := 2 to TmpSub.NbLine do AddLine(TmpSub.Line[I1]);
    AddLine('');
  end;
  //-G3-------
  procedure AddSubTitleSST;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    StBegin, StEnd: Widestring;
  begin
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    if not Form1.BMPOutPreset[3].Color.Custom and not TxtFile.Loaded then
    begin
      if (WNumSub = 1) or
        (TmpSub.Clr <> Form1.SubTitles.Sub[WNumSub - 1].Clr) then
        AddLine('Color'#9#9 + GetOrigClrIdxs(3));
      if (WNumSub = 1) or
        (TmpSub.Ctr <> Form1.SubTitles.Sub[WNumSub - 1].Ctr) then
        AddLine('Contrast'#9 + GetOrigCtrIdxs);
    end;

    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));

    AddLine(IntToStr(WNumSub - TxtFile.SplitIndex) + #9#9 + StBegin + #9 +
      StEnd + #9 + TmpSub.Line[1]);
  end;
  //-G4-------
  //Added by PRI
  procedure AddSubTitleDVDMaestro;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    StBegin, StEnd: Widestring;
    StNbSub: Widestring;
  begin
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    if not Form1.BMPOutPreset[4].Color.Custom and not TxtFile.Loaded then
    begin
      if (WNumSub = 1) or
        (TmpSub.Clr <> Form1.SubTitles.Sub[WNumSub - 1].Clr) then
        AddLine('Color'#9#9 + GetOrigClrIdxs(4));
      if (WNumSub = 1) or
        (TmpSub.Ctr <> Form1.SubTitles.Sub[WNumSub - 1].Ctr) then
        AddLine('Contrast'#9 + GetOrigCtrIdxs);
    end;

{    if Form13.OutPut.DVDMaestro.Extended then
      case Form13.Output.FrameRate of
        0: AddLine('Display_Area'#9 +
            Format('(%.3d %.3d 719 573)', [TmpSub.Coord.Left, TmpSub.Coord.Top]));
        1: AddLine('Display_Area'#9 +
            Format('(%.3d %.3d 719 477)', [TmpSub.Coord.Left, TmpSub.Coord.Top]));
      end;}
    if Form13.OutPut.DVDMaestro.Extended then
      AddLine('Display_Area'#9 +
        Format('(%.3d %.3d %.3d %.3d)', [TmpSub.Coord.Left, TmpSub.Coord.Top,
        TmpSub.Coord.Right, TmpSub.Coord.Bottom]));

    StNbSub := Format('%.4d', [WNumSub + Form13.MaeOffsetSpinEdit.Value - TxtFile.SplitIndex]);
    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));
    AddLine(StNbSub + #9#9 + StBegin + #9 +
      StEnd + #9 + TmpSub.Line[1]);
  end;
  //-G5-------
  procedure AddSubTitleImpre;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    StBegin, StEnd: Widestring;
  begin
    //Impression info from Christophe thieme [christophe.thieme@imt-sa.com]
    //The BMP must be 8bit and max. 4 colors.
    //In the BMP file: Background is BLACK, Font is WHITE, Outline is BLACK, Antialiasing is BLACK.
    //The colors of Background, Font, Outline and Antialiasing can be other, but must be true color:
    //White 255, 255, 255 - Black 0, 0, 0 - Blue 0, 0, 255 - Red 255, 0, 0 - Green 0, 255, 0
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));

    AddLine(StBegin + ' ' + StEnd + ' ' + TmpSub.Line[1]);
  end;
  //----------
  procedure AddSubTitleFAB;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    StBegin, StEnd: Widestring;
    I1: Integer;
  begin
    //www.fab-online.com
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));
    AddLine(StBegin + '  ' + StEnd);

    for I1 := 1 to TmpSub.NbLine do
      AddLine(StripStyle(TmpSub.Line[I1]));
    AddLine('');
  end;
  //----------
  procedure AddSubTitleMacDVDStudio;
  var
    WFrameRate: Word;
    BoolDropFrame: Boolean;
    St1, StBegin, StEnd: Widestring;
    I1: Integer;
  begin
    //time in "TAB" time out "TAB" subtitle text. For subtitles with two lines
    //there should be "<P>" instead of a return.
    //For example:
    //00:00:27:00	00:00:29:07	Au fin fond de l'ouest,<P>il y avait ce type.
    //1) the last position in the timecode are the frames
    //2) supports subtitles with more than two lines
    if Form13.Output.FrameRate = 0 then WFrameRate := 2500 else WFrameRate := 3000;
    BoolDropFrame := (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame;

    StBegin := TCToStr(TCmsToTC(TmpSub.StartTC, WFrameRate, BoolDropFrame));
    StEnd := TCToStr(TCmsToTC(TmpSub.StopTC, WFrameRate, BoolDropFrame));
    St1 := StBegin + #9 + StEnd + #9;

    for I1 := 1 to TmpSub.NbLine do
    begin
      if I1 > 1 then St1 := St1 + '<P>'; //Line separator
      St1 := St1 + TmpSub.Line[I1];
    end;
    AddLine(StripStyle(St1));
  end;
  //-----------------
  //Added by ai4spam (ai4spam@gmail.com)
  //This is modified procedure AddSubTitleMDVD;
  //for bitmap sequences saved for later subtitle removal from videos
  procedure AddSubTitleBms;
  var
//    I1: Integer; //pom .. for decimal point position
    StTC1, StTC2: Integer;
    St1: Widestring;
    kFPS: Integer; //FPS * 1000
  begin
    kfps:=Form21.VideoFrameRate;

    StTC1 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StartTC) / 1000)); //brackets have reason here :-)
    StTC2 := Round((kFPS / 1000) * (TCMsToMSec(TmpSub.StopTC) / 1000));

    St1 := IntToStr(WNumSub-1) + ',' + IntToStr(StTC1) + ',' + IntToStr(StTC2) + ','
        + IntToStr(TmpSub.Coord.Left) + ',' + IntToStr(TmpSub.Coord.Top);
    Form21.BitmapList.Add(St1);
  end;
  //----------
begin {AddSubTitle}

  TxtFile.Modified := True;
  TmpSub := Form1.SubTitles.Sub[WNumSub];

  if Form21.VideoOpen and Form21.cbSave.Checked then AddSubtitleBms;//added by ai4spam@gmail.com

  if TxtFile.Split then
  begin
    CanShow := CanShowSub(TmpSub, TxtFile.SplitStart, TxtFile.SplitStop);
    if CanShow then
      TmpSub := CorrectSplitTime(TmpSub, TxtFile.SplitStart, TxtFile.SplitStop)
    else TxtFile.SplitIndex := WNumSub;
  end
  else CanShow := True;

  if CanShow then
    case TxtFile.OutputFormat of
      OFTTXT: AddSubTitleTTXT;
      OFSubRip: AddSubTitleSubRip;
      OFMDVD: AddSubTitleMDVD;
      OFSubStationAlpha: AddSubTitleSubStationAlpha;
      OFTMPlayer: AddSubTitleTMPlayer;
      OFMpl: AddSubTitleMpl;
      OFMpl2: AddSubTitleMpl2;
      OFDks: AddSubTitleDks;
      OFDVDSubtitle: AddSubTitleDVDSubtitle;
      OFSubSubViewer: AddSubTitleSubViewer;
      OFSubSubViewer2: AddSubTitleSubViewer2;
      OFSTL: AddSubTitleSTL;
      OFIAuthor: AddSubTitleSubRip; //Pas de conversion  la vole pour cause de Problme de taille maxi dans TListBox (Fichiers IAuthor trs volumineux)
      OFPhilips: AddSubTitlePhilips;
      OFSonic: AddSubTitleSonic;
      OFDVDMaestro: AddSubTitleDVDMaestro;
      OFSST: AddSubTitleSST;
      OFImpre: AddSubTitleImpre;
      OFMacSUB: AddSubTitleMacSUB;
      OFViPlay: AddSubTitleViPlay;
      OFZeroG: AddSubTitleZeroG;
      OFTurboTitler: AddSubTitleTurboTitler;
      OFPowerDivX: AddSubTitlePowerDivX;
      OFPhoenix: AddSubTitlePhoenix;
      OFFAB: AddSubTitleFAB;
      OFMacDVDStudio: AddSubTitleMacDVDStudio;
    end;
  if CheckBoxScrollDown.Checked and Visible and BScrollDown then
    ListBoxSubtitle.ItemIndex := ListBoxSubtitle.Items.Count - 1; //Go to last sub
  LabelNbSubTitle.Caption := IntToStr(WNumSub);
end; {AddSubTitle}

//------------------------------------------------------------------------------

procedure TForm3.AddAllSubTitles;
var W1: Word;
  //----------
  //Added by LRN (LordRuslanNightmare@gmail.com)
  procedure AddTTXTHeader;
  begin
    with Form13 do
    begin

      TTXTLastStop.Hour := 0;
      TTXTLastStop.Min := 0;
      TTXTLastStop.Sec := 0;
      TTXTLastStop.Ms := 0;

      AddLine('<?xml version="1.0" encoding="UTF-8" ?>');
      AddLine('<!-- GPAC 3GPP Text Stream -->');
      AddLine('<TextStream version="1.0">');
      AddLine('<TextStreamHeader width="400" height="60" layer="0" translation_x="0" translation_y="0">');
      with OutPut.TTXT do AddLine(Tnt_WideFormat('<TextSampleDescription horizontalJustification="center" verticalJustification="bottom" backColor="%x %x %x %x" verticalText="no" fillTextRegion="no" continuousKaraoke="no" scroll="None">',[BackColor[0],BackColor[1],BackColor[2],BackColor[3]]));
      AddLine('<FontTable>');
      AddLine('<FontTableEntry fontName="' + OutPut.TTXT.Font + '" fontID="1"/>');
      AddLine('</FontTable>');
      AddLine('<TextBox top="0" left="0" bottom="60" right="400"/>');
      with OutPut.TTXT do AddLine(Tnt_WideFormat('<Style styles="Normal" fontID="1" fontSize="%d" color="%x %x %x %x"/>',[FontSize,FontColor[0],FontColor[1],FontColor[2],FontColor[3]]));
      AddLine('</TextSampleDescription>');
      AddLine('</TextStreamHeader>');
      AddLine('<TextSample sampleTime="00:00:00.000" text="">');
      AddLine('</TextSample>');
    end;
  end;
  //----------
  procedure AddSSAHeader;
  var
    StBold, StItalic: Widestring;
  begin
    with Form13 do
    begin
      if fsBold in OutPut.SSA.SelFont.Style then StBold := '-1' else StBold := '0';
      if fsItalic in OutPut.SSA.SelFont.Style then StItalic := '-1' else StItalic := '0';
      AddLine('[Script Info]');
      AddLine('Title: ' + EditSubStationAlphaTitle.Text);
      AddLine('Original Script: ' + EditSubStationAlphaScript.Text);
      AddLine('ScriptType: v4.00');
      AddLine('');
      AddLine('[V4 Styles]');
      AddLine('Format: Name, Fontname, Fontsize, PrimaryColour, SecondaryColour, TertiaryColour, BackColour, Bold, Italic, BorderStyle, Outline, Shadow, Alignment, MarginL, MarginR, MarginV, AlphaLevel, Encoding');
      //----------
      //changed by mrSHADOW (mrshadow@howto.pl)
      AddLine(Tnt_WideFormat('Style: Style1,%s,%d,%d,%d,%d,%d,' +
        StBold + ',' + StItalic + ',1,%d,%d,2,%d,%d,%d,0,%d',
        [OutPut.SSA.SelFont.Name, OutPut.SSA.SelFont.Size, OutPut.SSA.Color[0],
        OutPut.SSA.Color[1], OutPut.SSA.Color[2], OutPut.SSA.Color[3],
        OutPut.SSA.Border, OutPut.SSA.Shadow, OutPut.SSA.VMargin,
        OutPut.SSA.VMargin, OutPut.SSA.BMargin, Output.SSA.SelFont.Charset]));
      //----------
      AddLine('');
      AddLine('[Events]');
      AddLine('Format: Marked, Start, End, Style, Name, MarginL, MarginR, MarginV, Effect, Text');
    end;
  end;
  //-----------------
  //Added by MJQ (subrip@divx.pl)
  procedure AddDVDSubtitleHeader;
  begin
    AddLine('{HEAD');
    AddLine('DISCID=' + Form13.EditDVDDiscID.Text);
    AddLine('DVDTITLE=' + Form13.EditDVDSubtitleDVDTitle.Text);
    AddLine('CODEPAGE='+IntToStr(CodePage));
    AddLine('FORMAT=ASCII');
    AddLine('LANG=' + Form13.EditDVDSubtitleLanguage.Text);
    AddLine('TITLE=1');
    AddLine('ORIGINAL=ORIGINAL');
    AddLine('AUTHOR=' + Form13.EditDVDSubtitleAuthor.Text);
    AddLine('WEB=' + Form13.EditDVDSubtitleWeb.Text);
    AddLine('INFO=' + Form13.EditDVDSubtitleInfo.Text);
    AddLine('LICENSE=' + Form13.EditDVDSubtitleLicense.Text);
    AddLine('}');
  end;
  //-----------------
  procedure AddSubViewerHeader;
  begin
    with Form13 do
    begin
      AddLine('[TITLE]');
      AddLine(EditSubviewerTitle.Text);
      AddLine('[AUTHOR]');
      AddLine(EditSubviewerAUTHOR.Text);
      AddLine('[SOURCE]');
      AddLine(EditSubviewerSOURCE.Text);
      AddLine('[PRG]');
      AddLine(EditSubviewerProgram.Text);
      AddLine('[FILEPATH]');
      AddLine(EditSubviewerFILEPATH.Text);
      AddLine('[DELAY]');
      AddLine(IntToStr(SpinEditSubViewerDelay.Value));
      AddLine('[CD TRACK]');
      AddLine('0');
      AddLine('[BEGIN]');
      AddLine('******** START SCRIPT ********');
    end;
  end;
  //-----------------
  procedure AddSubViewer2Header;
  var
    StStyle: Widestring;
  begin
    with Form13 do
    begin
      //Subviewer 2 can't handle more than one font style at once. Then we must set the prioriters ones
      StStyle := 'no';
      if fsStrikeout in OutPut.SubV2.SelFont.Style then StStyle := 'st';
      if fsUnderline in OutPut.SubV2.SelFont.Style then StStyle := 'ud';
      if fsBold in OutPut.SubV2.SelFont.Style then StStyle := 'bd';
      if fsItalic in OutPut.SubV2.SelFont.Style then StStyle := 'it';
      AddLine('[INFORMATION]');
      AddLine('[TITLE]' + EditSubviewer2Title.Text);
      AddLine('[AUTHOR]' + EditSubviewer2AUTHOR.Text);
      AddLine('[SOURCE]' + EditSubviewer2SOURCE.Text);
      AddLine('[PRG]' + EditSubviewer2Program.Text);
      AddLine('[FILEPATH]' + EditSubviewer2FILEPATH.Text);
      AddLine('[DELAY]' + IntToStr(SpinEditSubViewer2Delay.Value));
      AddLine('[CD TRACK]' + IntToStr(SpinEditSubViewer2CDTrack.Value));
      AddLine('[COMMENT]' + EditSubviewer2Comment.Text);
      AddLine('[END INFORMATION]');
      AddLine('[SUBTITLE]');
      AddLine('[COLF]&H' + IntToHex(({Form2.FontDialog.Font.Color //ToDo
        and} $FFFFFF), 6) + ',[STYLE]' + StStyle + ',[SIZE]' +
        IntToStr(OutPut.SubV2.SelFont.Size) + ',[FONT]' + OutPut.SubV2.SelFont.Name);
      AddLine('00:00:00.00,00:00:00.10'); AddLine(''); AddLine(''); //SubViewer2 Need that the first subtitle start at time 0 else it directly start at the first subtitle time
    end;
  end;
  //-----------------
  procedure AddSTLHeader;
  var dummy: Widestring;
  begin
    AddLine('//');
    AddLine('// Generated by SubRip ' + VersionStr + ' on ' + DateTimeToStr(Now));
    AddLine('//');

    AddLine('//Font select and font size');
    AddLine('$FontName       = ' + Form13.OutPut.STL.SelFont.Name);
    AddLine('$FontSize       = ' + IntToStr(Form13.OutPut.STL.SelFont.Size));
    AddLine('');

    AddLine('//Character attributes (global)');
    if fsBold in Form13.OutPut.STL.SelFont.Style then dummy := 'TRUE' else dummy := 'FALSE';
    AddLine('$Bold           = ' + dummy);
    if fsUnderline in Form13.OutPut.STL.SelFont.Style then dummy := 'TRUE' else dummy := 'FALSE';
    AddLine('$UnderLined     = ' + dummy);
    if fsItalic in Form13.OutPut.STL.SelFont.Style then dummy := 'TRUE' else dummy := 'FALSE';
    AddLine('$Italic         = ' + dummy);
    AddLine('');

    AddLine('//Position Control');
    if Form13.Output.STL.HAlign = 0 then dummy := 'Left';
    if Form13.Output.STL.HAlign = 1 then dummy := 'Center';
    if Form13.Output.STL.HAlign = 2 then dummy := 'Right';
    AddLine('$HorzAlign      = ' + dummy);
    if Form13.Output.STL.VAlign = 0 then dummy := 'Top';
    if Form13.Output.STL.VAlign = 1 then dummy := 'Center';
    if Form13.Output.STL.VAlign = 2 then dummy := 'Bottom';
    AddLine('$VertAlign      = ' + dummy);
    AddLine('$XOffset        = ' + IntToStr(Form13.Output.STL.HOffset));
    AddLine('$YOffset        = ' + IntToStr(Form13.Output.STL.VOffset));
    AddLine('');

    AddLine('//Colors');
    AddLine('$ColorIndex1    = 0');
    AddLine('$ColorIndex2    = 1');
    AddLine('$ColorIndex3    = 2');
    AddLine('$ColorIndex4    = 3');
    AddLine('');

    AddLine('//Contrast Control');
    AddLine('$Contrast1      = ' + IntToStr(Form13.Output.STL.Contrast[0]));
    AddLine('$Contrast2      = ' + IntToStr(Form13.Output.STL.Contrast[1]));
    AddLine('$Contrast3      = ' + IntToStr(Form13.Output.STL.Contrast[2]));
    AddLine('$Contrast4      = ' + IntToStr(Form13.Output.STL.Contrast[3]));
    AddLine('');

    AddLine('//Effects Control');
    AddLine('$ForceDisplay   = FALSE');
    AddLine('$FadeIn         = 0');
    AddLine('$FadeOut        = 0');
    AddLine('');

    AddLine('//Other Controls');
    AddLine('$TapeOffset     = FALSE');
    AddLine('');

    AddLine('//Subtitles');
  end;
  //-G1-------
  procedure AddPhilipsHeader;
  var
    StFRAMERATE, StDROPFRAME: Widestring;
    B1: Byte;
    //----------
    function TColorToStr(TmpColor: TColor): Widestring;
    var
      BTmpColor: array[0..3] of Byte absolute TmpColor;
    begin
      Result := Tnt_WideFormat('(%d, %d, %d)', [BTmpColor[0], BTmpColor[1], BTmpColor[2]]);
    end;
    //----------
  begin
    with Form13 do
    begin
      if Output.FrameRate = 0 then StFRAMERATE := 'PAL' else StFRAMERATE := 'NTSC';
      if Output.DropFrame then StDROPFRAME := 'YES' else StDROPFRAME := 'NO';
      AddLine('# PHILIPS SVCD DESIGNER 1.5 - 2.0 SUBTITLES FILE');
      AddLine('#');
      AddLine('# GENERATED BY SubRip ' + VersionStr + ' on ' + DateTimeToStr(Now));
      AddLine('#');
      AddLine('[HEADER]');
      AddLine('TITLE'#9#9 + EditPhilipsTitle.Text);
      AddLine('FRAMERATE'#9 + StFRAMERATE);
      if Output.FrameRate = 1 then AddLine('DROPFRAME'#9 + StDROPFRAME);

      if Form1.BMPOutPreset[1].Color.Custom or TxtFile.Loaded then
      begin
        AddLine(Tnt_WideFormat('CONTRAST'#9 + '(%d %d %d %d)',
          [Form1.BMPOutPreset[1].Color.CustContrast[0], Form1.BMPOutPreset[1].Color.CustContrast[1],
          Form1.BMPOutPreset[1].Color.CustContrast[2], Form1.BMPOutPreset[1].Color.CustContrast[3]]));
        if Form1.BMPOutPreset[1].Color.BitPerPixel = pf4bit then
        begin
          AddLine('COLOR'#9#9 + '(0 1 2 3)');
          AddLine('');
          AddLine('[PALETTE]');
          for B1 := 0 to 3 do
            AddLine(IntToStr(B1) + ' ' +
              TColorToStr(Form1.BMPOutPreset[1].Color.CustColors[B1]));
        end;
      end
      else //OrigClrs
        if Form1.BMPOutPreset[1].Color.BitPerPixel = pf4bit then
        begin
          AddLine('');
          AddLine('[PALETTE]');
          for B1 := 0 to 15 do
            AddLine(IntToStr(B1) + ' ' +
              TColorToStr(Form1.Process.Palette[B1]));
        end;

      AddLine('');
      AddLine('[LIST]');
    end;
  end;
  //----------
  procedure AddREMPaletteEntries(UsedFmt: Byte);
  var
    I: Byte;
    //----------
    function ThreeLength(X: Byte): Widestring;
    var
      S: Widestring;
      I2: Byte;
    begin
      S := IntToStr(X);
      for I2 := Length(S) + 1 to 3 do S := ' ' + S;
      Result := S;
    end;
    //----------
  begin
    AddLine('#');
    AddLine('# Palette entries:');
    AddLine('#');
    if Form1.BMPOutPreset[UsedFmt].Color.Custom or TxtFile.Loaded then
      for I := 0 to 3 do
        //# 00 : RGB(255,255,  0)
        AddLine(Tnt_WideFormat('# %.2d : RGB(', [I + 4 - UsedFmt]) +
          ThreeLength(GetRValue(Form1.BMPOutPreset[UsedFmt].Color.CustColors[I])) + ',' +
          ThreeLength(GetGValue(Form1.BMPOutPreset[UsedFmt].Color.CustColors[I])) + ',' +
          ThreeLength(GetBValue(Form1.BMPOutPreset[UsedFmt].Color.CustColors[I])) + ')')
    else
      for I := 0 to 15 do
        AddLine(Tnt_WideFormat('# %.2d : RGB(', [I + 4 - UsedFmt]) +
          ThreeLength(GetRValue(Form1.Process.Palette[I])) + ',' +
          ThreeLength(GetGValue(Form1.Process.Palette[I])) + ',' +
          ThreeLength(GetBValue(Form1.Process.Palette[I])) + ')');
    AddLine('#');
    AddLine('');
  end;
  //-G3-------
  procedure AddSSTHeader;
  var
    StFRAMERATE: Widestring;
  begin
    AddLine('st_format'#9'2');
    AddLine('Display_Start'#9'non_forced');
    if Form13.Output.FrameRate = 0 then StFRAMERATE := 'PAL' else StFRAMERATE := 'NTSC';
    AddLine('TV_Type'#9#9 + StFRAMERATE);

    if (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame then
      AddLine('Tape_Type'#9'DROP')
    else AddLine('Tape_Type'#9'NON_DROP');

    if Form13.Output.FrameRate = 0 then
    begin //PAL
      //according to FilipeAmadeuO (for 574)
      AddLine('Pixel_Area'#9'(0 ' + IntToStr(Form1.BMPOutPreset[3].CropBMP.MinY) + ')');
      AddLine('Display_Area'#9'(0 2 719 ' + IntToStr(Form1.BMPOutPreset[3].CropBMP.MinY) + ')');
      //AddLine('Pixel_Area'#9'(0 573)');
      //AddLine('Subtitle'#9'PREFIX');
      //AddLine('Display_Area'#9'(0 2 719 575)');
    end
    else
    begin //NTSC
      AddLine('Pixel_Area'#9'(0 ' + IntToStr(Form1.BMPOutPreset[3].CropBMP.MinY - 1) + ')');
      //AddLine('Subtitle'#9'PREFIX');
      AddLine('Display_Area'#9'(0 2 719 479)');
    end;

    if Form1.BMPOutPreset[3].Color.Custom or TxtFile.Loaded then
    begin
      AddLine('Color'#9#9'(0 1 2 3)');
      AddLine(Tnt_WideFormat('Contrast'#9'(%d %d %d %d)',
        [Form1.BMPOutPreset[3].Color.CustContrast[0], Form1.BMPOutPreset[3].Color.CustContrast[1],
        Form1.BMPOutPreset[3].Color.CustContrast[2], Form1.BMPOutPreset[3].Color.CustContrast[3]]));
    end;

    AddLine('E2'#9#9'(255 0 0 ===)');
    AddLine('E1'#9#9'(0 0 0 ===)');
    AddLine('PA'#9#9'(0 0 255 ===)');
    AddLine('BG'#9#9'(255 255 255 ===)');

    AddLine('Directory'#9 + Form1.SaveDialogBmpSup.InitialDir);
    AddLine('');
    AddREMPaletteEntries(3);
    AddLine('#########################################################');
    AddLine('SP_NUMBER'#9'START'#9#9'END'#9#9'FILE_NAME');
  end;
  //-G4------- Added by PRI
  procedure AddDVDMaestroHeader;
  var StFRAMERATE: Widestring;
  begin
    AddLine('st_format'#9'2');
    AddLine('Display_Start'#9'non_forced');
    if Form13.Output.FrameRate = 0 then StFRAMERATE := 'PAL' else StFRAMERATE := 'NTSC';
    AddLine('TV_Type'#9#9 + StFRAMERATE);

    if (Form13.Output.FrameRate = 1) and Form13.Output.DropFrame then
      AddLine('Tape_Type'#9'DROP')
    else AddLine('Tape_Type'#9'NON_DROP');

    case Form13.Output.FrameRate of
      0: AddLine('Pixel_Area'#9'(0 575)');
      1: AddLine('Pixel_Area'#9'(0 479)');
    end;
    AddLine('Directory'#9 + Form1.SaveDialogBmpSup.InitialDir);
    AddLine('');
    AddREMPaletteEntries(4);
    AddLine('SP_NUMBER'#9'START'#9#9'END'#9#9'FILE_NAME');
    if Form1.BMPOutPreset[4].Color.Custom or TxtFile.Loaded then
    begin
      AddLine ('Color'#9#9'(0 1 2 3)');
      AddLine(Tnt_WideFormat('Contrast'#9'(%d %d %d %d)',
        [Form1.BMPOutPreset[4].Color.CustContrast[0], Form1.BMPOutPreset[4].Color.CustContrast[1],
        Form1.BMPOutPreset[4].Color.CustContrast[2], Form1.BMPOutPreset[4].Color.CustContrast[3]]));
    end;
  end;
  //-G5-------
  procedure AddImpreHeader;
  begin
    AddLine('-------------------------------------------------');
    AddLine('#INPOINT OUTPOINT PATH');
    AddLine('-------------------------------------------------');
  end;
  //----------
begin {AddAllSubTitles}
  needUniCode:=false;
  SubFormat.Caption:='ANSI';//default is ansi !!!unicode
  SubFormat.Font.Color:=clGreen;
  ListBoxSubtitle.Clear;
  WideSubs.Clear;
  case TxtFile.OutputFormat of //Ajoute l'ventuelle En-tete au fichier texte
    OFTTXT: AddTTXTHeader;
    //OFSubRip: ;
    OFMDVD:
      if Form13.DXG400CheckBox.Checked then
        AddLine('{1}{1}' + Form13.MDVDComboBox.Text);
    OFSubStationAlpha: AddSSAHeader;
    //OFTMPlayer: ;
    //OFMpl: ;
    //OFMpl2: ;
    //OFDks: ;
    OFDVDSubtitle: AddDVDSubtitleHeader;
    OFSubSubViewer: AddSubViewerHeader;
    OFSubSubViewer2: AddSubViewer2Header;
    OFSTL: AddSTLHeader;
    //OFIAuthor: ;
    OFPhilips: AddPhilipsHeader;
    //OFSonic: ;
    OFDVDMaestro: AddDVDMaestroHeader;
    OFSST: AddSSTHeader;
    OFImpre: AddImpreHeader;
    //OFMacSUB: ;
    OFViPlay: AddLine('{* VIPLAY SUBTITLE FILE *}');
    OFZeroG:
      begin
        AddLine('% Zero G 1.0');
        AddLine('');
      end;
    //OFTurboTitler: ;
    //OFPowerDivX: ;
    //OFPhoenix: ;
    //OFFAB: ;
    //OFMacDVDStudio: ;
  end;

  if Form21.VideoOpen and Form21.cbSave.Checked then//added by ai4spam@gmail.com
  begin
    Form21.BitmapList.Clear;
    Form21.BitmapList.BeginUpdate;
  end;
  ListBoxSubtitle.Items.BeginUpdate;
  for W1 := 1 to Form1.Subtitles.NbSub do //Ajoute tout les sous-titres
    AddSubTitle(W1, False);
  TxtFile.SplitIndex := 0; //reset Index
  ListBoxSubtitle.Items.EndUpdate;
  if Form21.VideoOpen and Form21.cbSave.Checked then//added by ai4spam@gmail.com
    Form21.BitmapList.EndUpdate;
  if CheckBoxScrollDown.Checked and Visible then
    ListBoxSubtitle.ItemIndex := ListBoxSubtitle.Items.Count - 1 //Go to last sub
  else
    ListBoxSubtitle.ItemIndex := 0;
end; {AddAllSubTitles}

//------------------------------------------------------------------------------

procedure TForm3.FormCreate(Sender: TObject);
begin
  FNewWndProc := MakeObjectInstance(ControlWndProc);
  FOldWndProc := Pointer(SetWindowLongW(Handle, GWL_WNDPROC, Longint(FNewWndProc)));
  DragAcceptFiles(Handle, True);

  TxtFile.Modified := False;
  TxtFile.FileName := DefaultFileName;
  TxtFile.Split := False;
  TxtFile.SplitStart := NulTimeCodeMs;
  TxtFile.SplitStop := NulTimeCodeMs;
  TxtFile.SplitIndex := 0;
  TxtFile.Loaded := False;
  //Left := 0;
  //Top := Screen.Height - Height;
  WideSubs:=TTntStringList.Create;
  img.Picture.Bitmap:=TBitmap.Create;
  cbFontName.Items.Assign(Screen.Fonts);
end;

//------------------------------------------------------------------------------

procedure TForm3.FormDestroy(Sender: TObject);
begin
  DragAcceptFiles(Handle, False);
  SetWindowLongW(Handle, GWL_WNDPROC, Longint(FOldWndProc));
  FreeObjectInstance(FNewWndProc);
  WideSubs.Destroy;
end;

//------------------------------------------------------------------------------

procedure TForm3.ControlWndProc(var Msg: TMessage);
begin
  with Msg do
    if Msg = WM_DROPFILES then
      DropFiles(WParam)
    else
      Result := CallWindowProc(FOldWndProc, Handle, Msg, WParam, LParam);
end;

//------------------------------------------------------------------------------

procedure TForm3.DropFiles(DropHandle: HDROP);
var
  FileName: array[0..MAX_PATH] of Char;
begin
  DragQueryFile(DropHandle, 0, @FileName, Sizeof(FileName));
  OpenDialogSubRipText.FileName := FileName;
  Application.BringToFront;
  OpenSubRipFormat1Click(nil);
  DragFinish(DropHandle);
end;

//------------------------------------------------------------------------------

procedure TForm3.SetFileName(StF: Widestring);
begin
  TxtFile.FileName := StF;
  StF := WideExtractFileName(StF);

  if Length(WideExtractFileExt(StF))<=4 then
    StF := Copy(StF, 1, Length(StF) - Length(WideExtractFileExt(StF)));

  case Form3.TxtFile.OutputFormat of
    OFSubRip: StF := StF + '.srt';
    OFMDVD: StF := StF + '.sub';
    OFSubStationAlpha: StF := StF + '.ssa';
    OFTMPlayer: StF := StF + '.txt';
    OFMpl: StF := StF + '.mpl';
    OFMpl2: StF := StF + '.mpl';
    OFDks: StF := StF + '.dks';
    OFDVDSubtitle: StF := StF + '.sub';
    OFSubSubViewer: StF := StF + '.sub';
    OFSubSubViewer2: StF := StF + '.sub';
    OFSTL: StF := StF + '.stl';
    OFIAuthor: StF := StF + '.txt';
    OFPhilips: StF := StF + '.sub';
    OFSonic: StF := StF + '.txt';
    OFDVDMaestro: StF := StF + '.son';
    OFSST: StF := StF + '.sst';
    OFImpre: StF := StF + '.txt';
    OFMacSUB: StF := StF + '.scr';
    OFViPlay: StF := StF + '.vsf';
    OFZeroG: StF := StF + '.zeg';
    OFTurboTitler: StF := StF + '.tts';
    OFPowerDivX: StF := StF + '.psb';
    OFPhoenix: StF := StF + '.pjs';
    OFFAB: StF := StF + '.txt';
    OFMacDVDStudio: StF := StF + '.txt';
  end;

  if Pos(' | ', Caption) > 0 then
    Caption := Copy(Caption, 1, Pos(' | ', Caption) + 2) + StF //international 'Subtitles | ' + StF
  else
    Caption := Caption + ' | ' + StF;
  SaveDialogText.FileName := StF;
  SaveDialogText.InitialDir := ExtractFilePath(TxtFile.FileName);
end;

//------------------------------------------------------------------------------

procedure TForm3.SetOutputFormat1Click(Sender: TObject);
begin
  Form13.ShowModal;
  CheckBoxFormat.Enabled:=TxtFile.OutputFormat=OFSubRip;
end;

//------------------------------------------------------------------------------

function TForm3.CanWriteToFile(const FileName: WideString): Boolean;
var
  FileHandle: THandle;
begin
  if not WideFileExists(FileName) then
    FileHandle := WideFileCreate(FileName)
  else
    FileHandle := WideFileOpen(FileName, fmOpenWrite or fmShareDenyNone);
  Result := not (FileHandle = INVALID_HANDLE_VALUE);
  if Result then FileClose(FileHandle);
end;

//------------------------------------------------------------------------------

procedure TForm3.SaveAs(Sender: TObject);
var
//  cnt:word;
  C1: Cardinal;
  Fic: TextFile;
  TmpSub: TSub;
  CanShow: Boolean;
  F: TFileStream;
  SPF: array[0..63] of Byte;
  LetsSaveIt: Boolean;
//  i:integer;
//  MyHwnd: THandle; //called from Form1, 3 & 17 (done to be always Modal + OnTop)
  //----------
  function TCMsToIAuthorStrTime(TmpTcMs: TTimeCodeMs): string;
  var
    TmpMsec: Integer; //Sec/1000
    TmpSec: Integer; //sec
    TmpCSec: Byte; //sec/100
  begin
    TmpMsec := TCMsToMSec(TmpTcMs) + 100; //The IAuthor OGT Creator automatically add 0.1s to each time (Don't know if really needed)
    TmpSec := TmpMsec div 1000;
    TmpCSec := (TmpMsec mod 1000) div 10;
    Result := Tnt_WideFormat('%d.%.2d', [TmpSec, TmpCSec]);
  end;
  //-G0-------
  procedure AddIAuthorHeader;
  begin
    WideWriteLn(Fic, StringToWideString('*******IAUTHOR OGT GENERATED BY SUBRIP ' + VersionStr + ' on ' + DateTimeToStr(Now)));
    WideWriteLn(Fic, '************************************************************************');
    WideWriteLn(Fic, '');
  end;
  //-G0-------
  procedure AddSubTitleIAuthor(WNumSub: Word);
  var
    StTime: Widestring;
    StRegion: Widestring;
    StBlend: Widestring;
    YCbCr: TColor;
    BYCbCr: array[0..3] of Byte absolute YCbCr;
    I: Byte;
    //----------
    function ValuesToStr(Bval0, Bval1, Bval2: Byte): Widestring;
    begin
      Result := Tnt_WideFormat('%d, %d, %d', [Bval0, Bval1, Bval2]);
    end;
    //----------
  begin
    if TmpSub.NbLine < 1 then Exit; //There is no BMP File name
    WideWriteLn(Fic, 'BMPFILE: ' + TmpSub.Line[1]); //BMP File Name
    WideWriteLn(Fic, '');
    StTime := TCMsToIAuthorStrTime(TmpSub.StartTC);
    WideWriteLn(Fic, 'STARTTIME: ' + StTime); WideWriteLn(Fic, '');

    if Form1.BMPOutPreset[0].Color.Custom or TxtFile.Loaded then
      for I := 0 to 3 do
      begin
        YCbCr := Form1.BMPOutPreset[0].Color.CustColors[I];
        WideWriteLn(Fic, 'TIME: ' + StTime + ' SETCOLOR Primary ' + IntToStr(I) +
          ', ' + ValuesToStr(BYCbCr[0], BYCbCr[1], BYCbCr[2])); WideWriteLn(Fic, '');
      end
    else
      for I := 0 to 3 do
      begin
        YCbCr := Form1.Process.Palette[(TmpSub.Clr shr (4 * I)) and $000F];
        WideWriteLn(Fic, 'TIME: ' + StTime + ' SETCOLOR Primary ' + IntToStr(I) +
          ', ' + ValuesToStr(BYCbCr[0], BYCbCr[1], BYCbCr[2])); WideWriteLn(Fic, '');
      end;

    WideWriteLn(Fic, 'TIME: ' + StTime + ' SETCOLOR Highlight 0, 16, 128, 128'); WideWriteLn(Fic, '');
    WideWriteLn(Fic, 'TIME: ' + StTime + ' SETCOLOR Highlight 1, 209, 146, 17'); WideWriteLn(Fic, '');
    WideWriteLn(Fic, 'TIME: ' + StTime + ' SETCOLOR Highlight 2, 81, 239, 91'); WideWriteLn(Fic, '');
    WideWriteLn(Fic, 'TIME: ' + StTime + ' SETCOLOR Highlight 3, 144, 35, 54'); WideWriteLn(Fic, '');
    StRegion := IntToStr(TmpSub.Coord.Left) + ', ' + IntToStr(TmpSub.Coord.Top) + ' to '
      + IntToStr(TmpSub.Coord.Right) + ', ' + IntToStr(TmpSub.Coord.Bottom);
    WideWriteLn(Fic, 'TIME: ' + StTime + ' region ' + StRegion); WideWriteLn(Fic, '');

    if Form1.BMPOutPreset[0].Color.Custom or TxtFile.Loaded then
      StBlend := Tnt_WideFormat('%d, %d, %d, %d',
        [Form1.BMPOutPreset[0].Color.CustContrast[0],
        Form1.BMPOutPreset[0].Color.CustContrast[1],
        Form1.BMPOutPreset[0].Color.CustContrast[2],
        Form1.BMPOutPreset[0].Color.CustContrast[3]])
    else
      StBlend := Tnt_WideFormat('%d, %d, %d, %d',
      [TmpSub.Ctr and $000F,
      (TmpSub.Ctr and $00F0) shr 4,
      (TmpSub.Ctr and $0F00) shr 8,
      (TmpSub.Ctr and $F000) shr 12]);

    WideWriteLn(Fic, 'TIME: ' + StTime + ' SETBLEND Primary ' + StBlend); WideWriteLn(Fic, '');
    WideWriteLn(Fic, 'TIME: ' + StTime + ' SETBLEND Hightlight 0, 15, 15, 15'); WideWriteLn(Fic, '');
    WideWriteLn(Fic, 'TIME: ' + StTime + ' FIELDINDEX 0, 1'); WideWriteLn(Fic, '');
    WideWriteLn(Fic, 'TIME: ' + StTime + ' ENABLE_OGT'); WideWriteLn(Fic, '');
    StTime := TCMsToIAuthorStrTime(TmpSub.StopTC);
    WideWriteLn(Fic, 'TIME: ' + StTime + ' DISABLE_OGT'); WideWriteLn(Fic, '');
    WideWriteLn(Fic, '************ Page #' + IntToStr(WNumSub) + ' Finished ***************'); WideWriteLn(Fic, '');
  end;
  //----------
begin
  if ListBoxSubtitle.Items.Count > 0 then //evite de planter si la feuille est vide
  begin
    if Form1.CLI.Wanted then
    begin
      LetsSaveIt := True;
      SaveDialogText.FileName := Form1.CLI.OutFile + '.' + SaveDialogText.DefaultExt;
    end
    else LetsSaveIt := SaveDialogText.Execute;

    if LetsSaveIt then
    begin
//      if Sender = Form17.ButtonOpenAVI then MyHwnd := Form17.Handle
//      else MyHwnd := Application.Handle;
      if not Form1.CLI.Wanted and FileExists(SaveDialogText.FileName) and
        (
//        MessageBox(MyHwnd, PChar(MsgStr[3] + ' ' + WideExtractFileName(SaveDialogText.FileName) +
//        ' ' + MsgStr[4]), PChar(MsgStr[71]), MB_YESNO or MB_ICONWARNING) = IDNO
        WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[3] + ' ' + WideExtractFileName(SaveDialogText.FileName) +
        ' ' + MsgStr[4], mtWarning, [mbYes, mbNo], 0) = mrNo
        ) then
        Exit;

      //read-only attribute lead to I/0 error 103
      if not CanWriteToFile(SaveDialogText.FileName) then
      begin
//        MessageBox(MyHwnd, PChar(MsgStr[9] + #13#10 + MsgStr[17] + ' ' +
//          WideExtractFileName(SaveDialogText.FileName) + '.'),
//          PChar(MsgStr[72]), MB_OK or MB_ICONERROR);
        WideMessageDlg(MsgStr[72] + #13#10 + MsgStr[9] + #13#10 + MsgStr[17] + ' ' +
          WideExtractFileName(SaveDialogText.FileName) + '.',
          mtError, [mbOk], 0);
        Exit;
      end;

      try
        SaveDialogText.InitialDir := WideExtractFilePath(SaveDialogText.FileName);

        //SPF 16 colors (16 x RGB0)
        if TxtFile.OutputFormat in [OFDVDMaestro, OFSTL] then
        begin
          FillChar(SPF, SizeOf(SPF), 0);
          if TxtFile.OutputFormat = OFDVDMaestro then
          begin
            if Form1.BMPOutPreset[4].Color.Custom or TxtFile.Loaded then
              for C1 := 0 to 3 do
              begin
                SPF[C1 * 4] := GetRValue(Form1.BMPOutPreset[4].Color.CustColors[C1]);
                SPF[C1 * 4 + 1] := GetGValue(Form1.BMPOutPreset[4].Color.CustColors[C1]);
                SPF[C1 * 4 + 2] := GetBValue(Form1.BMPOutPreset[4].Color.CustColors[C1]);
              end
            else //orig
              for C1 := 0 to 15 do
              begin
                SPF[C1 * 4] := GetRValue(Form1.Process.Palette[C1]);
                SPF[C1 * 4 + 1] := GetGValue(Form1.Process.Palette[C1]);
                SPF[C1 * 4 + 2] := GetBValue(Form1.Process.Palette[C1]);
              end
          end
          else //OFSTL
            for C1 := 0 to 3 do
            begin
              SPF[C1 * 4] := GetRValue(Form13.OutPut.STL.Color[C1]);
              SPF[C1 * 4 + 1] := GetGValue(Form13.OutPut.STL.Color[C1]);
              SPF[C1 * 4 + 2] := GetBValue(Form13.OutPut.STL.Color[C1]);
            end;
          F := TFileStream.Create(ChangeFileExt(SaveDialogText.FileName, '.spf'), fmCreate or fmShareExclusive);
          try //TFileStream
            F.Position := 0;
            F.Write(SPF, SizeOf(SPF));
          finally
            F.Free;
          end;
        end;

        AssignFile(Fic, SaveDialogText.FileName);
        FileMode := 1; //Ecriture Seule
        Rewrite(Fic);
        if needUniCode then
          write(Fic,chr($ff),chr($fe));//UniCode "header"
        case TxtFile.OutputFormat of
          OFIAuthor: begin
              AddIAuthorHeader;
              for C1 := 1 to Form1.Subtitles.NbSub do
              begin
                TmpSub := Form1.SubTitles.Sub[C1];
                if TxtFile.Split then
                begin
                  CanShow := CanShowSub(TmpSub, TxtFile.SplitStart, TxtFile.SplitStop);
                  if CanShow then TmpSub := CorrectSplitTime(TmpSub, TxtFile.SplitStart, TxtFile.SplitStop);
                end
                else CanShow := True;
                if C1 < Form1.Subtitles.NbSub then
                  TmpSub.StopTc := ForceMinInterMs(TmpSub.StopTc, Form1.SubTitles.Sub[C1 + 1].StartTC, Form13.Output.IAuthor.MinimumInterval);
                if CanShow then AddSubTitleIAuthor(C1); //Ajoute tout les sous-titres au format IAuthor directement dans le fichier texte (Problme de taille maxi dans TListBox)
              end;
            end;
        else
          for C1 := 0 to ListBoxSubtitle.Items.Count - 1 do
            WideWriteLn(Fic, ListBoxSubtitle.Items[C1]);
        end;

        case TxtFile.OutputFormat of //append eventual sequence to EoF
          //OFSubRip: ;
          //OFMDVD: ;
          //OFSubStationAlpha: ;
          //OFTMplayer: ;
          //OFMpl: ;
          //OFMpl2: ;
          //OFDks: ;
          //OFDVDSubtitle: ;
          OFSubSubViewer:
          begin
            WideWriteLn(Fic, '[END]');
            WideWriteLn(Fic, '******** End Script ********');
          end;
          //OFSubSubViewer2: ;
          //OFSTL: ;
          OFIAuthor: WideWriteLn(Fic, '');
          //OFPhilips: ;
          //OFSonic: ;
          //OFDVDMaestro: ;
          //OFSST: ;
          OFImpre: WideWriteLn(Fic, '-------------------------------------------------');
          //OFMacSUB: ;
          //OFViPlay: ;
          //OFZeroG: ;
          //OFTurboTitler: ;
          //OFPowerDivX: ;
          //OFPhoenix: ;
          //OFFAB: ;
          //OFMacDVDStudio: ;
        end;
        TxtFile.Modified := False;
        SetFileName(SaveDialogText.FileName);
        if Form21.VideoOpen and Form21.cbSave.Checked then//added by ai4spam@gmail.com
        begin
          if Form21.BitmapList.Count>0 then
          begin
            if Form21.BitmapList[0]<>IntToStr(Form21.BitmapList.Count) then
              Form21.BitmapList.Insert(0,IntToStr(Form21.BitmapList.Count));
            Form21.BitmapList.SaveToFile(Form21.BmpOutputDir+'\index.bms');
          end;
        end;
      finally
        CloseFile(Fic);
        SaveDialogText.Tag:=1;//mark it as saved already
      end;
    end
    else SaveDialogText.FileName := '';
  end;
end;

//------------------------------------------------------------------------------

procedure TForm3.PostOCRCorrection1Click(Sender: TObject);
begin
  Form10.ShowModal;
end;

//------------------------------------------------------------------------------

procedure TForm3.OpenSubtitle(breset: boolean);
//Modified by MJQ (subrip@divx.pl)
var
//  i:integer;
  Fic: TextFile;
  St1, St2, Style: WideString;
  TmpStl: TTntStrings;
  FirstNumBool: Boolean;
  TmpTC, TmpTC2: TTimeCodeMs;
  TmpCoord: TRect;
  IgnoreError: Boolean;
  frm1, frm2: WideString;
  i1{, pom}: Integer;
  kFPS: Cardinal; //FPS * 1000
  SubType: Word; // 1 - SubRip, 2 - MicroDVD, 3 - Mpl2
                 // 4 - TMPlayer, 5 - TMPlayer Multiline
                 // 6 - Mpl, 7 - Dks, 8 - MacSUB
                 // 9 - ViPlay, 10 - ZeroG
                 //11 - TurboTitler, 12 - PowerDivX
                 //13 - Phoenix, 14 - SubViewer 2
  //----------
  procedure StrToFrame(const Chars: WideString; var St1, Start, Stop: WideString);
  var
    I1, I2: Integer;
  begin
    I1 := Pos(Chars[1], St1);
    I2 := Pos(Chars[2], St1) - Pos(Chars[1], St1);
    Start := Copy(St1, I1 + 1, I2 - 1);
    Delete(St1, I1, I2 + 1);
    I1 := Pos(Chars[1], St1);
    I2 := Pos(Chars[2], St1) - Pos(Chars[1], St1);
    Stop := Copy(St1, I1 + 1, I2 - 1);

    //workaround for {x}{} MDVD subtitles / or missing 2nd TimeCode
    if Stop = '' then Stop := IntToStr(Trunc(StrToInt(Start) +
        Form16.SpinEditMaxTMP.Value / 1000 * kFPS / 1000 + 0.5)); //Stop = Start + MaxTMP msec.

    Delete(St1, I1, I2 + 1);
  end;
  //----------
  function MsgError(W1: Word; var IgnoreError: Boolean): Boolean;
  begin
    Result := False;
    if not IgnoreError then
      case WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[15] + ' ' + IntToStr(W1 + 1) + #13 + MsgStr[16],
        MtWarning, [mbCancel, mbIgnore, mbYesToAll], 0) of
        //mrIgnore: ;
        mrYesToAll: IgnoreError := True;
        mrCancel: Result := True;
      end;
  end;
  //----------
  //Correct Display time
  procedure CorrectTime;
  var SubNumber: Integer;
  begin
    with Form1 do
      for SubNumber := 1 to SubTitles.NbSub - 1 do
        if (TCMsToMSec(SubTitles.Sub[SubNumber].StopTC) >= Unit07.TCMsToMSec(SubTitles.Sub[SubNumber + 1].StartTC))
          and (Unit07.TCMsToMSec(SubTitles.Sub[SubNumber + 1].StartTC) <> 0) then
          SubTitles.Sub[SubNumber].StopTC := Unit07.MSecToTCMs(Unit07.TCMsToMSec(SubTitles.Sub[SubNumber + 1].StartTC) - Form16.SpinEditMinTime.Value);
  end;

  //Open SubRip Format
  procedure OpenSubRip;
  var
    W1: Word;
  begin
    Reset(Fic);
    W1 := 0; //only initialize
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1) until Eof(Fic) or (Trim(St1) <> '');
        if St1 <> '' then
        begin
          W1 := StrToInt(Trim(St1));
          if FirstNumBool then
          begin
            Form13.SpinEditSubRipOffset.Value := W1 - 1;
            FirstNumBool := False;
          end;
        end;
        WideReadLn(Fic, St1);
        if St1 <> '' then
        begin
          St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
          //00:00:03,000 --> 00:00:20,000
          TmpTC := Unit07.StrToTCMs(Copy(St1, 1, 12)); //Lit le Start time code
          if Pos(' --> ', St1) = 0 then
            TmpTC2 := Unit07.StrToTCMs(Copy(St1, 18, 12)) //Lit le Stop time code
          else
            TmpTC2 := Unit07.StrToTCMs(Copy(St1, Pos(' --> ', St1) + 5, 12)); //prevent errors (missing numbers, e.g. :9: instead of :09:)
        end;
        if Length(St1) > 31 then //Extended mode with Picture sizes & positions
        begin
          St1 := Trim(Copy(St1, 31, 30));
          if Tnt_WideLowerCase(St1[1]) = 'x' then
          begin
            TmpCoord.Left := StrToInt(Copy(St1, 4, 3));
            TmpCoord.Right := StrToInt(Copy(St1, 11, 3));
            TmpCoord.Top := StrToInt(Copy(St1, 18, 3));
            TmpCoord.Bottom := StrToInt(Copy(St1, 25, 3));
            Form13.OutPut.SubRip.Extended := True;
          end;
        end
        else
        begin
          TmpCoord := NulCoord;
          Form13.OutPut.SubRip.Extended := False;
        end;
        repeat
          WideReadLn(Fic, St1); //Lit les lignes du sous-titre
          St1 := Trim(St1);
          if St1 <> '' then
          begin
            //text color
            if Pos('<font color="#', St1) = 1 then
            begin
              Form1.CharRegion.Lines[TmpStl.Count + 1].PatternClr := //RGB
                StrToInt('$' + Copy(St1, 15, 6));
              Delete(St1, 1, 22); //slower but safer
              St1 := Tnt_WideStringReplace(St1, '</font>', '', []); //slower but safer
            end
            else
              Form1.CharRegion.Lines[TmpStl.Count + 1].PatternClr := $FFFFFF; //RGB

            //MicroDVD styles in .srt (if the conversion was done in some util that doesn't support styles)
            if Pos('{y:i}', St1) > 0 then
            begin
              St1 := Tnt_WideStringReplace(St1, '{y:i}', '', [rfReplaceAll]);
              St1 := '<i>' + St1 + '</i>';
            end;

            if Pos('{y:b}', St1) > 0 then
            begin
              St1 := Tnt_WideStringReplace(St1, '{y:b}', '', [rfReplaceAll]);
              St1 := '<b>' + St1 + '</b>';
            end;

            if Pos('{y:u}', St1) > 0 then
            begin
              St1 := Tnt_WideStringReplace(St1, '{y:u}', '', [rfReplaceAll]);
              St1 := '<u>' + St1 + '</u>';
            end;

            TmpStl.Add(St1);
          end;
        until St1 = ''; //Fin du sous-titre courant

        if TmpStl.Count > 0 then //skip blank (=useless) subtitles
          Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
      except
        if MsgError(W1 - 1, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open MicroDVD Format
  procedure OpenMicroDVD;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
    if ((Pos('{1}{1}', St1) = 1) or
      (Pos('{0}{0}', St1) = 1)) and //compatibility mode
      ((Length(St1) = 12) or (Length(St1) = 8)) //can be like this: {1}{1}25
      then
    try
      kFps := 1000 * StrToInt(Copy(St1, 7, 2)) +
        StrToIntDef(Copy(St1, 10, 3), 0);
      //must be determined here (because of TCmsToTC + AddTCFrames proper work)
      Unit07.FPS := Trunc(kFPS / 1000 + 0.5) - 1;
      if Unit07.FPS < 25 then Form13.Output.FrameRate := 0 //phui
      else Form13.Output.FrameRate := 1;

      if Length(St1) = 12 then ComboBoxFPS.Text := Copy(St1, 7, 6)
      else ComboBoxFPS.Text := FloatToStr(kfps / 1000) + '.000';
      ComboBoxFPSChange(nil);
    except
      Reset(fic);
    end
    else Reset(fic);
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)
        until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line

        StrToFrame('{}', St1, frm1, frm2);
        TmpTC := Unit07.FrameToTCMs(frm1, kFps);
        TmpTC2 := Unit07.FrameToTCMs(frm2, kFps);

        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          if (Pos('{y', St2) = 1) or (Pos('{Y', St2) = 1) //ToDo: control code may appear anywhere on uniline
            then //subtitle line/item style
          begin
            Style := Copy(St2, 4, Pos('}', St2) - 4);
            if (Pos('{Y', St2) <> 0) and (St1 <> '')
              then St1 := '{Y:' + Style + '}' + St1;
            Delete(St2, 1, pos('}', St2));
            if Pos('u', style) <> 0
              then St2 := '<u>' + St2 + '</u>';
            if Pos('i', style) <> 0
              then St2 := '<i>' + St2 + '</i>';
            if Pos('b', style) <> 0
              then St2 := '<b>' + St2 + '</b>';
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if TmpStl.Count > 0 then //skip blank (=useless) subtitles
          Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open MPL2 Format
  procedure OpenMPL2;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line

        StrToFrame('[]', St1, frm1, frm2);
        TmpTC := Unit07.Mpl2ToTCMs(frm1);
        TmpTC2 := Unit07.Mpl2ToTCMs(frm2);

        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if TmpStl.Count > 0 then //skip blank (=useless) subtitles
          Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open TMPlayer Format
  procedure OpenTMPlayer;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        St2 := Copy(St1, 1, 8);
        if (St2[8] < '0') or (St2[8] > '9') then Delete(St1, 1, 8) else Delete(St1, 1, 9);
        if (St2[8] < '0') or (St2[8] > '9') then St2 := Copy(St2, 1, 7);

        if Length(St2) = 7 then St2 := '0' + St2 + ',000'
        else St2 := St2 + ',000';

        TmpTC := Unit07.StrToTCMs(WideStringToString(St2));
        TmpTC2 := Unit07.AddTCMs(TmpTc, Unit07.MSecToTCMs(Form16.SpinEditMaxTMP.Value));

        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if TmpStl.Count = 0 then TmpStl.Add(''); //workaround for empty CLEAR-VISIBLE-SUB-USED subtitle
        if (TCMsToMSec(TmpTC) <> 0) then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
           //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
    CorrectTime;
  end;

  //Open TMPlayerMultiline Format
  procedure OpenTMPlayerMultiline;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        St2 := Copy(St1, 1, 8);
        Delete(St1, 1, 11);
        TmpTC := Unit07.StrToTCMs(St2 + ',000');
        TmpTC2 := Unit07.AddTCMs(TmpTc, Unit07.MSecToTCMs(Form16.SpinEditMaxTMP.Value));

        St1 := Trim(St1);
        if St1 <> '' then TmpStl.Add(St1);

        WideReadLn(Fic, St1);
        Delete(St1, 1, 11);

        St1 := Trim(St1);
        if St1 <> '' then TmpStl.Add(St1);

        if TmpStl.Count = 0 then TmpStl.Add(''); //workaround for empty CLEAR-VISIBLE-SUB-USED subtitle
        if (TCMsToMSec(TmpTC) <> 0) then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
    CorrectTime;
  end;

  //Open MPL Format
  procedure OpenMPL;
  begin //Mpl Format
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line

        Frm1 := Copy(St1, 1, Pos(',', St1) - 1);
        Delete(St1, 1, Pos(',', St1));

        Frm2 := Copy(St1, 1, Pos(',', St1) - 1);
        Delete(St1, 1, Pos(',', St1));
        Delete(St1, 1, Pos(',', St1));

        TmpTC := Unit07.FrameToTCMs(frm1, kFps);
        TmpTC2 := Unit07.FrameToTCMs(frm2, kFps);

        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if TmpStl.Count > 0 then //skip blank (=useless) subtitles
          Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open DKS Format
  procedure OpenDKS;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1) until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        St2 := Copy(St1, 2, 8);
        Delete(St1, 1, 10);
        St2 := St2 + ',000';

        TmpTC := Unit07.StrToTCMs(St2);
        TmpTC2 := Unit07.AddTCMs(TmpTc, Unit07.MSecToTCMs(Form16.SpinEditMaxTMP.Value));

        repeat
          i1 := Pos('[br]', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1 + 3);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if (TmpStl.Count > 0) //skip blank (=useless) subtitles
          and (TCMsToMSec(TmpTC) <> 0)
          then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
           //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
    CorrectTime;
  end;

  //Open MacSUB Format
  procedure OpenMacSUB;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line

        if St1 <> '' then begin

          Frm1 := Copy(St1, 2, Length(St1) - 1);

          WideReadLn(Fic, St1);
          St1 := Trim(St1); //Cut unwanted spaces at begin and end of line

          repeat
            TmpStl.Add(St1);
            WideReadLn(Fic, St1);
            St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
          until (St1[1] = '/') and (St1[2] in [WideChar('0')..WideChar('9')])
            and (st1 <> '');

           {St1 := Trim(St1); //Cut unwanted spaces at begin and end of line}
          Frm2 := Copy(St1, 2, Length(St1) - 1);

          TmpTC := Unit07.FrameToTCMs(frm1, kFps);
          TmpTC2 := Unit07.FrameToTCMs(frm2, kFps);

          if (TCMsToMSec(TmpTC) <> 0) then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
        end;
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open ViPlay Format
  procedure OpenViPlay;
  begin
    Reset(fic);
    repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> ''); //Read Header
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line

        TmpTC := Unit07.StrToTCMs(Copy(St1, 1, 12));
        TmpTC2 := Unit07.StrToTCMs(Copy(St1, 14, 12));
        Delete(St1, 1, 26);

        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if (TmpStl.Count > 0) //skip blank (=useless) subtitles
          and (TCMsToMSec(TmpTC) <> 0)
          then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open ZeroG Format
  procedure OpenZeroG;
  begin
    Reset(fic);
    repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> ''); //Read Header
    repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> ''); //Read Header
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        TmpTC := Unit07.StrToTCMs('0' + Copy(St1, 5, 10) + '0');
        TmpTC2 := Unit07.StrToTCMs('0' + Copy(St1, 16, 10) + '0');
        Delete(St1, 1, 38);

        repeat
          i1 := Pos('\n', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1 + 1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if (TmpStl.Count > 0) //skip blank (=useless) subtitles
          and (TCMsToMSec(TmpTC) <> 0)
          then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
           //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open TurboTitler Format
  procedure OpenTurboTitler;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        TmpTC := Unit07.StrToTCMs('0' + Copy(St1, 1, 10) + '0');
        TmpTC2 := Unit07.StrToTCMs('0' + Copy(St1, 12, 10) + '0');
        Delete(St1, 1, 25);
        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if (TmpStl.Count > 0) //skip blank (=useless) subtitles
          and (TCMsToMSec(TmpTC) <> 0)
          then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
           //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open PowerDivX Format
  procedure OpenPowerDivX;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        TmpTC := Unit07.StrToTCMs(Copy(St1, 2, 8) + ',000');
        TmpTC2 := Unit07.StrToTCMs(Copy(St1, 12, 8) + ',000');
        Delete(St1, 1, 20);
        repeat
          i1 := Pos('|', St1);
          if i1 = 0 then begin St2 := St1; St1 := ''; end
          else begin
            St2 := copy(St1, 1, i1 - 1);
            Delete(St1, 1, i1);
          end;
          St2 := Trim(St2);
          if St2 <> '' then TmpStl.Add(St2);
        until St1 = '';
        if (TmpStl.Count > 0) //skip blank (=useless) subtitles
          and (TCMsToMSec(TmpTC) <> 0)
          then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open Phoenix Format
  procedure OpenPhoenix;
  begin
    Reset(fic);
    TmpStl := TTntStringList.Create;
    repeat
      try
        TmpStl.Clear;
        WideReadLn(Fic, St1);
        if St1 <> '' then begin
          Frm1 := Trim(Copy(St1, 1, 7));
          Frm2 := Trim(Copy(St1, 9, 7));
          Delete(St1, 1, 18);
          Delete(St1, Length(st1), 1);
          St1 := Trim(St1);
          repeat
            i1 := Pos('|', St1);
            if i1 = 0 then begin St2 := St1; St1 := ''; end
            else begin
              St2 := copy(St1, 1, i1 - 1);
              Delete(St1, 1, i1);
            end;
            St2 := Trim(St2);
            if St2 <> '' then TmpStl.Add(St2);
          until St1 = '';

          TmpTC := Unit07.FrameToTCMs(frm1, kFps);
          TmpTC2 := Unit07.FrameToTCMs(frm2, kFps);

          if (TmpStl.Count > 0) //skip blank (=useless) subtitles
            and (TCMsToMSec(TmpTC) <> 0)
            then Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, TmpCoord); //Ajoute le sous-titre au tableau
        end;
          //Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC := TmpTC; //Ajoute le time code au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

  //Open SubViewer 2 Format
  procedure OpenSV2;
  begin
    Reset(Fic);
    TmpStl := TTntStringList.Create;

    //HeaDER
    repeat WideReadLn(Fic, St1) until Eof(Fic) or (Trim(St1) <> '');
    while Pos('[COLF]&', St1) <> 1 do
    begin
      if Pos('[TITLE]', St1) = 1 then
        Form13.EditSubviewer2Title.Text := Copy(St1, 8, Length(St1) - 7)
      else
        if Pos('[AUTHOR]', St1) = 1 then
          Form13.EditSubviewer2Author.Text := Copy(St1, 9, Length(St1) - 8)
        else
          if Pos('[SOURCE]', St1) = 1 then
          begin
           Delete(St1, 1, 8); Trim(St1);
           if St1 <> '' then Form13.EditSubviewer2Source.Text := St1;
          end
          else
            if Pos('[PRG]', St1) = 1 then
              Form13.EditSubviewer2Program.Text := Copy(St1, 6, Length(St1) - 5)
            else
              if Pos('[FILEPATH]', St1) = 1 then
                Form13.EditSubviewer2FilePath.Text := Copy(St1, 11, Length(St1) - 10)
              else
                if Pos('[DELAY]', St1) = 1 then
                  Form13.SpinEditSubViewer2Delay.Value := StrToIntDef(Copy(St1, 8, Length(St1) - 7), 0)
                else
                  if Pos('[CD TRACK]', St1) = 1 then
                    Form13.SpinEditSubViewer2CDTrack.Value := StrToIntDef(Copy(St1, 11, Length(St1) - 10), 0)
                  else
                    if Pos('[COMMENT]', St1) = 1 then
                      Form13.EditSubviewer2Comment.Text := Copy(St1, 10, Length(St1) - 9);
      WideReadLn(Fic, St1);
    end;

    //[COLF]&HFFFFFF,[STYLE]bd,[SIZE]22,[FONT]Arial (ToDo: [COLF])
    St2 := Copy(St1, Pos('[STYLE]', St1) + 7, 2);
    if St2 = 'no' then Form13.OutPut.SubV2.SelFont.Style := [];
    if St2 = 'st' then Form13.OutPut.SubV2.SelFont.Style := [fsStrikeout];
    if St2 = 'ud' then Form13.OutPut.SubV2.SelFont.Style := [fsUnderline];
    if St2 = 'bd' then Form13.OutPut.SubV2.SelFont.Style := [fsBold];
    if St2 = 'it' then Form13.OutPut.SubV2.SelFont.Style := [fsItalic];
    Delete(St1, 1, Pos('[SIZE]', St1) + 5);
    St2 := Copy(St1, 1, Pos(',', St1) - 1);
    Form13.OutPut.SubV2.SelFont.Size := StrToIntDef(St2, 18);
    Delete(St1, 1, Pos('[FONT]', St1) + 5);
    Form13.OutPut.SubV2.SelFont.Name := Trim(St1);

    repeat
      try
        TmpStl.Clear;

        //TiME
        repeat WideReadLn(Fic, St1) until Eof(Fic) or (Trim(St1) <> '');
        if Eof(Fic) then Break;
        St1 := Trim(St1); //Cut possible unwanted spaces at begin and end of line
        //00:01:01.16,00:01:04.64
        TmpTC := Unit07.StrToTCMs(Copy(St1, 1, 11) + '0'); //Lit le Start time code
        TmpTC2 := Unit07.StrToTCMs(Copy(St1, 13, 11) + '0'); //Lit le Stop time code

        //TeXT
        WideReadLn(Fic, St1);
        while Length(St1) > 0 do
        begin
          i1 := Pos('[br]', St1);
          if i1 = 0 then
          begin
            St2 := Trim(St1); St1 := '';
          end
          else
          begin
            St2 := Trim(Copy(St1, 1, i1 - 1));
            Delete(St1, 1, i1 + 3);
          end;
          //text color
          if Pos('<font color="#', St2) = 1 then
          begin
            Form1.CharRegion.Lines[TmpStl.Count + 1].PatternClr := //RGB
              StrToInt('$' + Copy(St2, 15, 6));
            Delete(St2, 1, 22); //slower but safer
            St2 := Tnt_WideStringReplace(St2, '</font>', '', []); //slower but safer
          end
          else
            Form1.CharRegion.Lines[TmpStl.Count + 1].PatternClr := $FFFFFF; //RGB
          if St2 <> '' then TmpStl.Add(St2);
        end;

        if TmpStl.Count > 0 then //skip blank (=useless) subtitles
          Form1.AddOneSubTitle(TmpStl, False, TmpTC, TmpTC2, NulCoord); //Ajoute le sous-titre au tableau
      except
        if MsgError(Form1.SubTitles.NbSub, IgnoreError) then Exit;
      end;
    until Eof(Fic);
    TmpStl.Free;
  end;

begin
    IgnoreError := False;
    bbDone.BringToFront;
    if FileExists(OpenDialogSubRipText.FileName) then
    begin
      OpenDialogSubRipText.InitialDir := WideExtractFilePath(OpenDialogSubRipText.FileName);
      Clear1Click(Form3);
      if breset then//reset to make it show the conversion window when errors occur
      begin
//        CodePage:=1252;
        pConversion.Color:=clRed;//means input conversion
      end;
      SetFileName(OpenDialogSubRipText.FileName);
      SaveDialogText.Tag:=1;//mark name as set
      FirstNumBool := True;
      try
        AssignFile(Fic, OpenDialogSubRipText.FileName);
        FileMode := 0; //Lecture Seule
        SubFormat.Caption:='ANSI';//default is ansi !!!unicode
        SubFormat.Font.Color:=clGreen;
        needUniCode:=false;
        Reset(Fic);
        repeat WideReadLn(Fic, St1)until Eof(Fic) or (Trim(St1) <> '');
        St1 := Trim(St1); //Cut unwanted spaces at begin and end of line
        repeat WideReadLn(Fic, St2)until Eof(Fic) or (Trim(St2) <> '');
        St2 := Trim(St2); //Cut unwanted spaces at begin and end of line

        SubType := 0;

        //try to autodetect the file format
        if StrToIntDef(St1, -1) <> -1 then SubType := 1; //SubRip (could be Index Offset)
        if St1[1] = '{' then SubType := 2; //MicroDVD Format
        if St1[1] = '[' then
          if St1  = '[INFORMATION]' then SubType := 14 //SubViewer 2
          else
            if St1[4] = ':' then SubType := 7 //DKS Files
            else SubType := 3; //Mpl2 Format
        if (Length(St1) > 1) and (St1[1] >= '0')
          and (St1[1] <= '9') and (Pos(':', St1) <> 0)
          then SubType := 4; //TMPlayer Format
        if (Copy(St1, 1, 9) = Copy(St2, 1, 9))
          and (St1[10] = '1') and (St2[10] = '2')
          then SubType := 5; //TMPlayer Multiline Format
        if (Pos(',0,', St1) <> 0) and (St1[Pos(',0,', St1) - 1] >= '0')
        and (St1[Pos(',0,', St1) - 1] <= '9') then SubType := 6; //Mpl Format
        if St1[1] = '/' then SubType := 8; //MacSUB Format
        if Pos('VIPLAY', St1) <> 0 then SubType := 9; //ViPlay
        if (St1[1] = '%') and (Pos('Zero', St1) <> 0) then SubType := 10; //ZeroG
        if (St1[11] = ',') and (St1[22] = ',') and (Pos('NTP', St1) = 23) then SubType := 11; //TurboTitler
        if (St1[1] = '{') and (St1[10] = '}') and (St1[4] = ':') then SubType := 12; //PowerDivX
        if (St1[Pos(',', St1) + 8] = ',') then SubType := 13; //Phoenix

        St1 := ''; St2 := '';
        case SubType of
          0:
//          MessageBox(Application.Handle, PChar(MsgStr[60]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING); //Urecognized file format
          WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[60], mtWarning, [mbOk], 0); //Urecognized file format
          1: OpenSubRip;
          2: OpenMicroDVD;
          3: OpenMPL2;
          4: OpenTMPlayer;
          5: OpenTMPlayerMultiline;
          6: OpenMPL;
          7: OpenDKS;
          8: OpenMacSUB;
          9: OpenViPlay;
          10: OpenZeroG;
          11: OpenTurboTitler;
          12: OpenPowerDivX;
          13: OpenPhoenix;
          14: OpenSV2;
        end;
      finally
        CloseFile(Fic);
        TxtFile.Split := False;
        TxtFile.Loaded := True;
        AddAllSubTitles;
        if SubFormat.Caption='UNICODE' then
        begin//may need to convert it
          Panel1.Hide;
          pConversion.Show;
{//          ANSIsubs.Assign(ListBoxSubtitle.Items);// .LoadFromFile(OpenDialogSubRipText.FileName);
  AnsiSubs.Clear;
  for i:=0 to ListBoxSubtitle.Count-1 do
    AnsiSubs.Add(WideStringToString(ListBoxSubtitle.Items[i]));}
          SpealingCorrection1.Enabled:=false;
          OutputFormat1.Enabled:=false;
          Saveas1.Enabled:=false;
        end;
        if Panel1.Visible then Unit07.OverlapInfo; //inform about overlapping
      end;
    end;
  TxtFile.Modified := False;
  InputType := Form3.OpenDialogSubRipText.FilterIndex;
end;

//------------------------------------------------------------------------------

procedure TForm3.TimeCorrection1Click(Sender: TObject);
begin
  Form14.ShowModal;
end;

//------------------------------------------------------------------------------

procedure TForm3.FormShow(Sender: TObject);
begin
  Width := Form1.Width;
  Left := Form1.Left;
  Top := Form1.Top + Form1.Height - Height;
  SetFileName(TxtFile.FileName);
  cbFontNameChange(cbFontName);
  seFontSizeChange(seFontSize);
  ListBoxSubtitle.ItemHeight:=-ListBoxSubtitle.Font.Height+((-ListBoxSubtitle.Font.Height) div 3+1);
  AddAllSubTitles; //to add the Header if current format had one
end;

//------------------------------------------------------------------------------

procedure TForm3.Clear1Click(Sender: TObject);
//var
//  MyHwnd: THandle; //called from Form3 & 6 (done to be always Modal + OnTop)
begin
  if TxtFile.Modified then
  begin
//    if Sender = Form6.ButtonClearText then MyHwnd := Form6.Handle
//    else MyHwnd := Application.Handle;
    if
//    MessageBox(MyHwnd, PChar(MsgStr[9] + #13 + MsgStr[18]), PChar(MsgStr[74]),
//      MB_YESNO or MB_ICONQUESTION) = IDNO
    WideMessageDlg(MsgStr[74] + #13#10 + MsgStr[9] + #13 + MsgStr[18], mtConfirmation, [mbYes, mbNo], 0)=mrNo
    then Exit;
  end;
  SpealingCorrection1.Enabled:=true;
  OutputFormat1.Enabled:=true;
  Saveas1.Enabled:=true;

  TxtFile.Modified := False;
  TxtFile.Loaded := False;
  SetFileName(DefaultFileName);

  Form1.Subtitles.NbSub := 0;
  LabelNbSubTitle.Caption := '0';
  AddAllSubTitles; //to add the Header if current format had one
  Form1.Process.SmallSkipped := 0;
  LabelSkip.Visible := False;
  pConversion.Hide;
  Panel1.Show;
  SaveDialogText.Tag:=0;//new file
end;

procedure TForm3.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  AllowChange := False;
  case Direction of
    updUp:
      ListBoxSubtitle.ItemIndex := 0;
    updDown:
      ListBoxSubtitle.ItemIndex := ListBoxSubtitle.Items.Count - 1;
  end;
end;

procedure TForm3.Splitoutputfile1Click(Sender: TObject);
begin
  Form17.Show;//Modal;
end;

procedure TForm3.ComboBoxFPSChange(Sender: TObject);
begin
  if Sender = nil then
  begin
    Form13.MDVDComboBox.Text := ComboBoxFPS.Text;
    Form13.ComboBoxMpl.Text := ComboBoxFPS.Text;
    Form13.ComboBoxMacSUB.Text := ComboBoxFPS.Text;
    Form13.ComboBoxPhoenix.Text := ComboBoxFPS.Text;
  end
  else
  begin
    Form13.MDVDComboBox.Text := (Sender as TTntComboBox).Text;
    Form13.ComboBoxMpl.Text := (Sender as TTntComboBox).Text;
    Form13.ComboBoxMacSUB.Text := (Sender as TTntComboBox).Text;
    Form13.ComboBoxPhoenix.Text := (Sender as TTntComboBox).Text;
    ComboBoxFPS.Text := (Sender as TTntComboBox).Text;
  end
end;

procedure TForm3.cbCodePageChange(Sender: TObject);
var
  i,p,cp:integer;
  ws:Widestring;
  s:AnsiString;
begin
  i:=pos(':',cbCodePage.Text);
  s:=copy(cbCodePage.Text,1,i-1);
  cp:=StrToIntDef(s,1252);
//  if pConversion.Color=clRed then
  begin//refresh when converting from input
    p:=ListBoxSubtitle.ItemIndex;
{  AnsiSubs.Clear;
  for i:=0 to ListBoxSubtitle.Count-1 do
    AnsiSubs.Add(WideStringToString(ListBoxSubtitle.Items[i]));}
    ListBoxSubtitle.Clear;
    for i:=0 to WideSubs.Count-1 do
    begin
      codePage:=1252;
      s:=WideStringToString(WideSubs[i]);
      codePage:=cp;
      ws:=StringToWideString(s);
      ListBoxSubtitle.Items.Add(ws);
    end;
    if (CheckBoxScrollDown.Checked) then ListBoxSubtitle.ItemIndex:=p;
  end;
end;

function EnumProc(const EnumLogFontEx: TEnumLogFontEx;
  const NewTextMetricEx: TNewTextMetricEx;
  FontType: Integer;
  Strings: TStrings): Integer; stdcall;
var
  I: Integer;
  ID: Integer;
  S: string;
begin
  ID := EnumLogFontEx.elfLogFont.lfCharSet;
  S  := Format('Unknown charset %d', [ID]);
  for I := 0 to NumCharSets - 1 do
    if CharSets[I].ID = ID then
    begin
      S := CharSets[I].Name;
      Break;
    end;
  Strings.Add(S);
  Result := 1
end;

procedure GetAvailableCharSets(const FaceName: string; CharSets: TTntStrings);
var
  DC: THandle;
  LogFont: TLogFont;
  sl:TStringList;
begin
  DC := GetDC(GetDesktopWindow);
  if DC <> 0 then
    try
      sl:=TStringList.Create;
      FillChar(LogFont, SizeOf(LogFont), 0);
      Move(FaceName[1], LogFont.lfFaceName, Length(FaceName));
      LogFont.lfCharSet := DEFAULT_CHARSET;
      EnumFontFamiliesEx(DC, LogFont, @EnumProc, lParam(sl), 0);
      CharSets.Assign(sl);
      CharSets.Add('DEFAULT');
    finally
      ReleaseDC(GetDesktopWindow, DC);
      sl.Free;
    end
end;

function TForm3.FontCharSet: WideString;
var
  i:integer;
begin
  Result:='DEFAULT';
  for i:=0 to NumCharsets-1 do
  begin
    if CharSets[i].ID=FontDialog.Font.CharSet then
    begin
      Result:=CharSets[i].Name;
      break;
    end;
  end;
end;

procedure TForm3.FormResize(Sender: TObject);
begin
  if pConversion.Visible then
    if Height<190 then Height:=190;
end;

procedure TForm3.bbDoneClick(Sender: TObject);
begin
  pConversion.Hide;
  Panel1.Show;
  SpealingCorrection1.Enabled:=true;
  OutputFormat1.Enabled:=true;
  Saveas1.Enabled:=true;
end;

procedure TForm3.SaveAsClick(Sender: TObject);
begin
  case TxtFile.OutputFormat of //Reglage des extensions  utiliser
    OFTTXT:
      begin
        with Form13 do
        begin
          OutPut.TTXT.Font := TntEditFont.Text;
          OutPut.TTXT.FontSize := SpinEditFontSize.Value;
          OutPut.TTXT.FontColor := ReadTTXTFontColor;
          OutPut.TTXT.BackColor := ReadTTXTBackColor;
        end;
        SaveDialogText.Filter := '3GPP TTXT (*.ttxt)|*.ttxt|All|*.*';
        SaveDialogText.DefaultExt := 'ttxt';
      end;
    OFSubRip: begin
        SaveDialogText.Filter := 'SubRip (*.srt)|*.srt|All|*.*';
        SaveDialogText.DefaultExt := 'srt';
      end;
    OFMDVD: begin
        SaveDialogText.Filter := 'MicroDVD (*.sub; *.txt)|*.sub;*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'sub';
      end;
    OFSubStationAlpha: begin
        SaveDialogText.Filter := 'Sub Station Alpha (*.ssa)|*.ssa|All|*.*';
        SaveDialogText.DefaultExt := 'ssa';
      end;
    OFTMPlayer: begin
        SaveDialogText.Filter := 'TMPlayer (*.txt)|*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'txt';
      end;
    OFMpl: begin
        SaveDialogText.Filter := 'Mpl (*.mpl)|*.mpl|All|*.*';
        SaveDialogText.DefaultExt := 'mpl';
      end;
    OFMpl2: begin
        SaveDialogText.Filter := 'Mpl2 (*.mpl)|*.mpl|All|*.*';
        SaveDialogText.DefaultExt := 'mpl';
      end;
    OFDks: begin
        SaveDialogText.Filter := 'Dks (*.dks)|*.dks|All|*.*';
        SaveDialogText.DefaultExt := 'dks';
      end;
    OFDVDSubtitle: begin
        SaveDialogText.Filter := 'DVDSubtitle (*.sub)|*.sub|All|*.*';
        SaveDialogText.DefaultExt := 'sub';
      end;
    OFSubSubViewer: begin
        SaveDialogText.Filter := 'SubViewer (*.sub)|*.sub|All|*.*';
        SaveDialogText.DefaultExt := 'sub';
      end;
    OFSubSubViewer2: begin
        SaveDialogText.Filter := 'SubViewer 2 (*.sub)|*.sub|All|*.*';
        SaveDialogText.DefaultExt := 'sub';
      end;
    OFSTL: begin
        SaveDialogText.Filter := 'Spruce subtitle (*.stl)|*.stl|All|*.*';
        SaveDialogText.DefaultExt := 'stl';
      end;
    OFIAuthor: begin
        SaveDialogText.Filter := 'IAuthor OGT (*.txt)|*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'txt';
      end;
    OFPhilips: begin
        SaveDialogText.Filter := 'Philips SVCD Designer (*.sub)|*.sub|All|*.*';
        SaveDialogText.DefaultExt := 'sub';
      end;
    OFSonic: begin
        SaveDialogText.Filter := 'Sonic DVD Creator (*.txt)|*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'txt';
      end;
    OFDVDMaestro: begin
        SaveDialogText.Filter := 'DVDMaestro (*.son)|*.son|All|*.*';
        SaveDialogText.DefaultExt := 'son';
      end;
    OFSST: begin
        SaveDialogText.Filter := 'Sonic Scenarist (*.sst)|*.sst|All|*.*';
        SaveDialogText.DefaultExt := 'sst';
      end;
    OFImpre: begin
        SaveDialogText.Filter := 'Pinnacle Impression (*.txt)|*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'txt';
      end;
    OFMacSUB: begin
        SaveDialogText.Filter := 'MacSUB (*.scr)|*.scr|All|*.*';
        SaveDialogText.DefaultExt := 'scr';
      end;
    OFViPlay: begin
        SaveDialogText.Filter := 'ViPlay (*.vsf)|*.vsf|All|*.*';
        SaveDialogText.DefaultExt := 'vsf';
      end;
    OFZeroG: begin
        SaveDialogText.Filter := 'ZeroG (*.zeg)|*.zeg|All|*.*';
        SaveDialogText.DefaultExt := 'zeg';
      end;
    OFTurboTitler: begin
        SaveDialogText.Filter := 'Turbo Titler (*.tts)|*.tts|All|*.*';
        SaveDialogText.DefaultExt := 'tts';
      end;
    OFPowerDivX: begin
        SaveDialogText.Filter := 'PowerDivX (*.psb)|*.psb|All|*.*';
        SaveDialogText.DefaultExt := 'psb';
      end;
    OFPhoenix: begin
        SaveDialogText.Filter := 'Phoenix Japanimation (*.pjs)|*.pjs|All|*.*';
        SaveDialogText.DefaultExt := 'pjs';
      end;
    OFFAB: begin
        SaveDialogText.Filter := 'FAB Subtitler (*.txt)|*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'txt';
      end;
    OFMacDVDStudio: begin
        SaveDialogText.Filter := 'Mac DVD Studio Pro (*.txt)|*.txt|All|*.*';
        SaveDialogText.DefaultExt := 'txt';
      end;
  end;

  AddAllSubtitles;

  //Added by LRN (LordRuslanNightmare@gmail.com)
  case TxtFile.OutputFormat of
    OFTTXT:
    begin
      with Form13 do
      begin
        with Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StopTC do AddLine(Tnt_WideFormat('<TextSample sampleTime="%.2d:%.2d:%.2d.%.3d" text="">',[Hour,Min,Sec,Ms]));
        AddLine('</TextSample>');
        AddLine('</TextStream>');
      end;
    end;
  end;
  //--------------


  if needUniCode then
    needUniCode:=WideMessageDlg(MsgStr[87] + ' ' + #13 + MsgStr[88], mtConfirmation, [mbYes, mbNo],0)=mrYes;
  if needUniCode then SaveAs(Sender)
  else//user wants ANSI, wait for selection
  begin
    bbSave.BringToFront;
    pConversion.Color:=clSkyBlue;
    Panel1.Hide;
    pConversion.Show;
    SpealingCorrection1.Enabled:=false;
    OutputFormat1.Enabled:=false;
    Saveas1.Enabled:=false;
    while pConversion.Visible and not Application.Terminated
      do Application.ProcessMessages;
  end;
end;

procedure TForm3.OpenSubRipFormat1Click(Sender: TObject);
var
  pom:integer;
  kFPS: Integer; //FPS * 1000
begin
  //decimal point processing (, or . depending on country)
  Form3.OpenDialogSubRipText.FilterIndex := InputType;
  SpealingCorrection1.Enabled:=true;
  OutputFormat1.Enabled:=true;
  Saveas1.Enabled:=true;

  pom := 0;
  if Pos('.', ComboBoxFPS.Text) > 0
    then pom := Pos('.', ComboBoxFPS.Text);
  if Pos(',', ComboBoxFPS.Text) > 0
    then pom := Pos(',', ComboBoxFPS.Text);
  if pom > 0
    then kFPS := StrToIntDef(Copy(ComboBoxFPS.Text, 1, pom - 1), 25) * 1000 +
    StrToIntDef(Copy(ComboBoxFPS.Text, pom + 1, Length(ComboBoxFPS.Text) - pom), 0)
  else kFPS := 1000 * StrToIntDef(ComboBoxFPS.Text, 25); //dec point not present

  //must be determined here (because of TCmsToTC + AddTCFrames proper work)
  Unit07.FPS := Trunc(kFPS / 1000 + 0.5) - 1;
  if Unit07.FPS < 25 then Form13.Output.FrameRate := 0 //phui
  else Form13.Output.FrameRate := 1;

  if TxtFile.Modified and
    (
//    MessageBox(Application.Handle, PChar(MsgStr[9] + #13 + MsgStr[14]), PChar(MsgStr[74]),
//    MB_YESNO or MB_ICONQUESTION) = IDNO
    WideMessageDlg(MsgStr[74] + #13#10 + MsgStr[9] + #13 + MsgStr[14], mtConfirmation, [mbYes, mbNo], 0) = mrNo
    ) then
    Exit;
  TxtFile.Modified := False;

  if OpenDialogSubRipText.Execute then OpenSubtitle(true);//reset CodePage
end;

procedure TForm3.bbSaveClick(Sender: TObject);
var
  Ext:AnsiString;
  i:integer;
begin
  Ext:='';
  if Form2.ComboBoxCharLoc.Text<>'' then
  begin
    Ext:='.';
    i:=1;
    while (i<=Length(Form2.ComboBoxCharLoc.Text))and(Form2.ComboBoxCharLoc.Text[i]<>'|') do
    begin
      Ext:=Ext+Form2.ComboBoxCharLoc.Text[i];
      i:=i+1;
    end;
  end;
  Ext:=Ext+'.'+SaveDialogText.DefaultExt;
  if SaveDialogText.Tag=0 then//only if it wasn't saved before or reset
  if Form21.VideoOpen then SaveDialogText.FileName:=ChangeFileExt(Form21.VideoFileName,Ext)//added by ai4spam@gmail.com
  else SaveDialogText.FileName:=ChangeFileExt(Form6.OpenDialogVob.FileName,Ext);

  if pConversion.Color=clSkyBlue then
  begin//output conversion
    needUniCode:=false;//force saving as ANSI
    SaveAs(Sender);//can save now, user chose code page
    needUniCode:=true;
  end;
  pConversion.Hide;
  Panel1.Show;
  SpealingCorrection1.Enabled:=true;
  OutputFormat1.Enabled:=true;
  Saveas1.Enabled:=true;
end;

procedure TForm3.ListBoxSubtitleDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  lb: TTntListBox;
  x,c:integer;
  t:WideString;
  o:boolean;
  r1,r2:TRect;
begin
  lb:=TTntListBox(Control);
  img.Picture.Bitmap.Height:=lb.ItemHeight;
  img.Picture.Bitmap.Width:=lb.ItemHeight*3;
  img.Canvas.Font:=lb.Font;
  if odSelected in State then
  begin
    lb.Canvas.Brush.Color:=clHighlight;
    lb.Canvas.Font.Color:=clHighlightText;
    img.Canvas.Brush.Color:=clHighlight;
    img.Canvas.Font.Color:=clHighlightText;
  end
  else
  begin
    lb.Canvas.Brush.Color:=clBlack;
    lb.Canvas.Font.Color:=clWhite;
    img.Canvas.Brush.Color:=clBlack;
    img.Canvas.Font.Color:=clWhite;
  end;
  x:=Rect.Left;
  lb.Canvas.CopyMode:=cmSrcCopy;
  lb.Canvas.FillRect(Rect);
  lb.Canvas.CopyMode:=cmSrcPaint;
  t:=lb.Items[Index];
if CheckBoxFormat.Checked and(TxtFile.OutputFormat=OFSubRip) then
begin
  lb.Canvas.Font.Style:=[];
  c:=0;
  while c<Length(t) do
  begin
    c:=c+1;
    o:=true;
    while o and(t[c]='<')and(c<Length(t)-2) do//may be a tag
    begin
      o:=false;
      if c<=Length(t)-2 then
      begin
        if (uppercase(t[c+1])='I')and(t[c+2]='>') then
        begin
          img.Canvas.Font.Style:=img.Canvas.Font.Style+[fsItalic];
          c:=c+3;
          o:=true;
        end;
        if (uppercase(t[c+1])='B')and(t[c+2]='>') then
        begin
          img.Canvas.Font.Style:=img.Canvas.Font.Style+[fsBold];
          c:=c+3;
          o:=true;
        end;
        if (uppercase(t[c+1])='U')and(t[c+2]='>') then
        begin
          img.Canvas.Font.Style:=img.Canvas.Font.Style+[fsUnderline];
          c:=c+3;
          o:=true;
        end;
      end;
      if c<=Length(t)-3 then
      begin
        if (uppercase(t[c+2])='I')and(t[c+3]='>')and(t[c+1]='/') then
        begin
          img.Canvas.Font.Style:=img.Canvas.Font.Style-[fsItalic];
          c:=c+4;
          o:=true;
        end;
        if (uppercase(t[c+2])='B')and(t[c+3]='>')and(t[c+1]='/') then
        begin
          img.Canvas.Font.Style:=img.Canvas.Font.Style-[fsBold];
          c:=c+4;
          o:=true;
        end;
        if (uppercase(t[c+2])='U')and(t[c+3]='>')and(t[c+1]='/') then
        begin
          img.Canvas.Font.Style:=img.Canvas.Font.Style-[fsUnderline];
          c:=c+4;
          o:=true;
        end;
      end;
      if c<=Length(t)-21 then//font color tags
      begin
        if (Copy(t,c,14)='<font color="#')and(t[c+21]='>')then
        begin
          img.Canvas.Font.Color:=StrToIntDef('$'+Copy(t,c+14,6),$ffffff);
          c:=c+22;
          o:=true;
        end;
      end;
      if c<=Length(t)-6 then//font end tags
      begin
        if (Copy(t,c,7)='</font>')then
        begin
          img.Canvas.Font.Color:=clWhite;
          c:=c+8;
          o:=true;
        end;
      end;
    end;
    if c<=Length(t) then
    begin
      img.Canvas.FillRect(Classes.Rect(0,0,img.Picture.Bitmap.Width,img.Picture.Bitmap.Height));
      WideCanvasTextOut(img.Canvas,0,0,t[c]);
      r1:=Classes.Rect(0,0,lb.Canvas.Font.Size*3,Rect.Bottom-Rect.Top);
      r2:=Classes.Rect(x,Rect.Top,x+lb.Canvas.Font.Size*3,Rect.Bottom);
      lb.Canvas.CopyRect(r2,img.Canvas,r1);
      x:=x+lb.Canvas.TextWidth(t[c]);
    end;
  end;
end
else WideCanvasTextOut(lb.Canvas,Rect.Left,Rect.Top,t);
end;

procedure TForm3.CheckBoxFormatClick(Sender: TObject);
begin
  ListBoxSubtitle.Repaint;
end;

procedure TForm3.bbConversionClick(Sender: TObject);
{var
  i:integer;}
begin
  pConversion.Color:=clRed;//means input conversion
  bbSave.SendToBack;
  Panel1.Hide;
  pConversion.Show;
{//  ANSIsubs.Assign(ListBoxSubtitle.Items);// .LoadFromFile(OpenDialogSubRipText.FileName);
  AnsiSubs.Clear;
  for i:=0 to ListBoxSubtitle.Count-1 do
    AnsiSubs.Add(WideStringToString(ListBoxSubtitle.Items[i]));}
  SpealingCorrection1.Enabled:=false;
  OutputFormat1.Enabled:=false;
  Saveas1.Enabled:=false;
end;

procedure TForm3.cbFontNameChange(Sender: TObject);
begin
  ListBoxSubtitle.Font.Name:=cbFontName.Text;
  ListBoxSubtitle.Font.Charset:=DEFAULT_CHARSET;
  ListBoxSubtitle.ItemHeight:=-ListBoxSubtitle.Font.Height+((-ListBoxSubtitle.Font.Height) div 3+1);
end;

procedure TForm3.seFontSizeChange(Sender: TObject);
begin
  ListBoxSubtitle.Font.Size:=seFontSize.Value;
  ListBoxSubtitle.ItemHeight:=-ListBoxSubtitle.Font.Height+((-ListBoxSubtitle.Font.Height) div 3+1);
end;

procedure TForm3.TntFormHide(Sender: TObject);
begin
  pConversion.Hide;
end;

end.
