{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit07; //scan VOBs

interface

uses
  Windows, Messages, SysUtils, TntClasses, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Unit01, UCommon, TntDialogs, TntForms, TntSysUtils;

var
  SupBuf: array[0..65535] of Byte;
  SupSize: Word;
  CurrSupTotalSize: Word;
  NbSub: Cardinal; //Nombre de SUP dans le Vob courant
  TotalNbSub: Cardinal; //Nombre de SUP total (dans tout les Vob slctionns)
  TimeCode: TTimeCode;
  TimeCode2: TTimeCode; //TimeCode mit  jour entre les chapitres  ( Cel )
  TimeCodeMs: TTimeCodeMs;
  TCChapter: TTimeCode;
  LastTCChapter: TTimeCode;

  TCLastSCRresetMs: TTimeCodeMs;
  SubTimeCodeMs: TTimeCodeMs;

  SCR: Integer; //Timer
  LastSCR: Integer; //Timer
  CalculateLastScr: Boolean;
  SCRIncr: Word; //Valeur incremente  chaques SCR ( A ajouter au moment du reset du SCR )

  FrameRate: Word; //Nombre d'images /s * 100 pour le calcul des ms
  FrameOffset: Byte; //Valeur  retirer au champs Frame pour avoir la bonne valeur ( Pal : $40  NTSC : $C0 )
  FPS: Byte; //Nombre d'images aprs lesquelles on incrment les secondes. ( Fps - 1 puisqu'on part de 0 )
  FrameIncr: Byte; //Nombre d'images qui sont incrementes  chaque Paquet NAV (Navigation) ( A ajouter au moment du changement de Chapitre (Cell) )
  DetectFRonVOBbegin: Boolean; //force the FR and size detection on each VOB debut *ONLY* - prevents flickering

  NbChapter: Word;

  //SCC: TStrings;
  RefreshTicker: Int64;
  RealF1Pause : Boolean; //Form1.ButtonPause was really clicked

function ByteToTC(Bh, Bm, Bs, Bf: Byte): TTimeCode;
function TCToTCms(const TmpTcode: TTimeCode): TTimeCodeMs;
function TCToStr(const TmpTcode: TTimeCode): Widestring;
function TCmsToStr(const TmpTcodeMs: TTimeCodeMs): Widestring;
function StrToTCMs(const S: Widestring): TTimeCodeMs;
function AddTC(const TmpTcode1: TTimeCode; TmpTcode2: TTimeCode): TTimeCode;
function AddTCFrames(const TmpTcode1: TTimeCode; Frames: Word): TTimeCode; //adds Frames to TC
function AddTCMs(const TmpTcode1: TTimeCodeMs; TmpTcode2: TTimeCodeMs): TTimeCodeMs;
function IsTC1SmallerThanTC2(const TmpTcode1, TmpTcode2: TTimeCode): Boolean;
function DecodeSCR(L1: Cardinal; L2: Word): Int64; //SCR, compteur prsent dans tout les paquets bas sur une horloge  90KHz
function TimerToMs(const LTimer: Integer): Integer;
function MsToTimer(const LMs: Integer): Integer;
function MSecToTCMs(const LNbMSec: Integer): TTimeCodeMs;
function TCMsToMSec(const TmpTCMs: TTimeCodeMs): LongInt; //Transforme un time code en nombre de ms
function FrameToTCMs(const Frame: Widestring; kFPS: Cardinal): TTimeCodeMs; //Added by MJQ (subrip@divx.pl)
function TCMsToFrame(const tc: TTimeCodeMs; kFPS: Cardinal): Cardinal; //Added by MJQ (subrip@divx.pl)
function Mpl2ToTCMs(const TimeMPL: Widestring): TTimeCodeMs; //Added by MJQ (subrip@divx.pl)
function VOBMapStr2Int(Index: Cardinal): Int64;

procedure DetectFrameRate(const Bframe: Byte);
procedure SaveBMP(const TmpBmp: TBitmap; const StFileName: Widestring);
procedure SaveSup(const StFileName: Widestring);
procedure ScanVob(const FName: Widestring);
procedure RestoreVOBMapPos;
procedure IncSmallSkipped;
procedure OverlapInfo;
procedure DoAfterProcess;

implementation

uses Unit03, Unit06, Unit08, Unit11, Unit13, Unit16, Unit18, UGraph;

//------------------------------------------------------------------------------

function ByteToTC(Bh, Bm, Bs, Bf: Byte): TTimeCode;
begin
  Result.Hour := (((Bh shr 4) and $0F) * 10) + (Bh and $0F);
  Result.Min := (((Bm shr 4) and $0F) * 10) + (Bm and $0F);
  Result.Sec := (((Bs shr 4) and $0F) * 10) + (Bs and $0F);
  Bf := Bf - FrameOffset;
  Result.Frame := (((Bf shr 4) and $0F) * 10) + (Bf and $0F);
end;

//------------------------------------------------------------------------------

function AddTC(const TmpTcode1: TTimeCode; TmpTcode2: TTimeCode): TTimeCode; //additionne 2 time code
begin
  Result.Frame := TmpTcode1.Frame + TmpTcode2.Frame;
  if Result.Frame > FPS then begin Dec(Result.Frame, FPS + 1); Inc(TmpTcode2.Sec); end;
  Result.Sec := TmpTcode1.Sec + TmpTcode2.Sec;
  if Result.Sec > 59 then begin Dec(Result.Sec, 60); Inc(TmpTcode2.Min); end;
  Result.Min := TmpTcode1.Min + TmpTcode2.Min;
  if Result.Min > 59 then begin Dec(Result.Min, 60); Inc(TmpTcode2.Hour); end;
  Result.Hour := TmpTcode1.Hour + TmpTcode2.Hour;
end;

//------------------------------------------------------------------------------

function AddTCFrames(const TmpTcode1: TTimeCode; Frames: Word): TTimeCode; //adds Frames to TC
begin
  Result := TmpTcode1;
  Inc(Result.Frame, Frames);
  while Result.Frame > FPS do begin Dec(Result.Frame, FPS + 1); Inc(Result.Sec); end;
  while Result.Sec > 59 do begin Dec(Result.Sec, 60); Inc(Result.Min); end;
  while Result.Min > 59 do begin Dec(Result.Min, 60); Inc(Result.Hour); end;
end;

//------------------------------------------------------------------------------

function AddTCMs(const TmpTcode1: TTimeCodeMs; TmpTcode2: TTimeCodeMs): TTimeCodeMs; //additionne 2 time code Ms
begin
  Result.Ms := TmpTcode1.Ms + TmpTcode2.Ms;
  if Result.Ms > 999 then begin Dec(Result.Ms, 1000); Inc(TmpTcode2.Sec); end;
  Result.Sec := TmpTcode1.Sec + TmpTcode2.Sec;
  if Result.Sec > 59 then begin Dec(Result.Sec, 60); Inc(TmpTcode2.Min); end;
  Result.Min := TmpTcode1.Min + TmpTcode2.Min;
  if Result.Min > 59 then begin Dec(Result.Min, 60); Inc(TmpTcode2.Hour); end;
  Result.Hour := TmpTcode1.Hour + TmpTcode2.Hour;
end;

//------------------------------------------------------------------------------

function IsTC1SmallerThanTC2(const TmpTcode1, TmpTcode2: TTimeCode): Boolean; //Regarde si TC1 est plus petit que TC2
var
  C1, C2: Cardinal;
  B1: array[0..3] of Byte absolute C1;
  B2: array[0..3] of Byte absolute C2;
begin
  B1[0] := TmpTcode1.Frame;
  B1[1] := TmpTcode1.Sec;
  B1[2] := TmpTcode1.Min;
  B1[3] := TmpTcode1.Hour;

  B2[0] := TmpTcode2.Frame;
  B2[1] := TmpTcode2.Sec;
  B2[2] := TmpTcode2.Min;
  B2[3] := TmpTcode2.Hour;

  Result := C1 < C2;
end;

//------------------------------------------------------------------------------

function TCToStr(const TmpTcode: TTimeCode): Widestring;
begin
  Result := Tnt_WideFormat('%.2d:%.2d:%.2d:%.2d',
    [TmpTcode.Hour, TmpTcode.Min, TmpTcode.Sec, TmpTcode.Frame]);
end;

//------------------------------------------------------------------------------

function TCmsToStr(const TmpTcodeMs: TTimeCodeMs): Widestring;
begin
  Result := Tnt_WideFormat('%.2d:%.2d:%.2d,%.3d',
    [TmpTcodeMs.Hour, TmpTcodeMs.Min, TmpTcodeMs.Sec, TmpTcodeMs.Ms]);
end;

//------------------------------------------------------------------------------

function StrToTCMs(const S: Widestring): TTimeCodeMs;
var
  W1, W2: Word;
begin
  //--safer to prevent 01:22:3,000-like errors--
  //01:22:03,000
  W1 := Pos(':', S) + 1; //(+ 1) only for next use
  Result.Hour := StrToInt(Copy(S, 1, W1 - 2));
  //22:03,000
  W2 := W1;
  while (Length(S) > W1) and (S[W1] <> ':') do Inc(W1);
  Result.Min := StrToInt(Copy(S, W2, W1 - W2)); Inc(W1);
  //03,000
  W2 := W1;
  while (Length(S) > W1) and not (S[W1] in [WideChar(','), WideChar(':'), WideChar('.')]) do Inc(W1);
  Result.Sec := StrToInt(Copy(S, W2, W1 - W2)); Inc(W1);
  //000
  Result.Ms := StrToInt(Copy(S, W1, 3));
end;

//------------------------------------------------------------------------------

function TCToTCms(const TmpTcode: TTimeCode): TTimeCodeMs;
var
  WMsec: Word;
begin
  WMsec := (TmpTcode.Frame * 1000 * 100) div FrameRate; //On calcule le nombre de ms correspondant  la frame courante
  Result.hour := TmpTcode.hour;
  Result.Min := TmpTcode.Min;
  Result.Sec := TmpTcode.Sec;
  Result.Ms := WMsec;
end;

//------------------------------------------------------------------------------

function FrameToTCMs(const Frame: Widestring; kFPS: Cardinal): TTimeCodeMs; //Added by MJQ (subrip@divx.pl)
var
  fr: Cardinal;
begin
  fr := StrToInt(Frame) * 1000;
  Result.Hour := fr div (3600 * kFps); fr := fr mod (3600 * kFps);
  Result.Min := fr div (60 * kFps); fr := fr mod (60 * kFps);
  Result.Sec := fr div kFps; fr := fr mod kFps;
  Result.Ms := Trunc(fr * (1000 / kFps) + 0.5);

  //43948 f @ 23.976 fps lead to 999.666 ms (=1000)
  //maxicorrect way
  if Result.Ms = 1000 then
  begin
    Result.Ms := 0; Inc(Result.Sec);
    if Result.Sec = 60 then
    begin
      Result.Sec := 0; Inc(Result.Min);
      if Result.Min = 60 then
      begin
        Result.Min := 0; Inc(Result.Hour);
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------

function Mpl2ToTCMs(const TimeMPL: Widestring): TTimeCodeMs; //Added by MJQ (subrip@divx.pl)
var
  mpl, ms, sec, min, hour: Integer;
begin
  mpl := StrToInt(TimeMPL);
  hour := mpl div 36000;
  min := (mpl div 600);
  sec := (mpl div 10);
  ms := (mpl * 100);
  ms := ms - sec * 1000;
  sec := sec - min * 60;
  min := min - hour * 60;
  Result.Hour := hour;
  Result.Min := min;
  Result.Sec := sec;
  Result.Ms := ms;
end;

//------------------------------------------------------------------------------

procedure DetectFrameRate(const Bframe: Byte);
begin
  if Bframe < $C0 then //PAL 25 fps
  begin
    FrameRate := 2500;
    FrameOffset := $40;
    FPS := 24;
    Form1.Process.VideoSize := Point(720, 576);
  end
  else //NTSC ~30 fps
  begin
    FrameRate := 3000;
    FrameOffset := $C0;
    FPS := 29;
    Form1.Process.VideoSize := Point(720, 480);
  end;
  Form6.SetPALNTSCSize;
  DetectFRonVOBbegin := False; //do not detect FR more in current VOB
end;

//------------------------------------------------------------------------------

function TimerToMs(const LTimer: Integer): Integer;
begin
  Result := LTimer div 90; //Clock  90Khz
end;

//------------------------------------------------------------------------------

function MsToTimer(const LMs: Integer): Integer;
begin
  Result := LMs * 90; //Clock  90Khz
end;

//------------------------------------------------------------------------------

function DecodeSCR(L1: Cardinal; L2: Word): Int64;
begin
  //methode base sur une source linux en C mais petite correction:
  //Ligne Originale : Result := ((L1 AND $31000000) Shl 3)
  //qui ne donnait pas un bon rsultat au del de env. 50mn
  //(premier octet qui passe de $44  $45 )
  {Result := ((L1 and $30000000) shl 3);
  Inc(Result, ((L1 and $03FFF800) shl 4));
  Inc(Result, ((L1 and $000003FF) shl 5));
  Inc(Result, ((L2 and $F800) shr 11));}

  //according to mpucoder
  Result :=
    (L1 and $38000000) shl 3 +
    (L1 and $03FFF800) shl 4 +
    (L1 and $000003FF) shl 5 +
    (L2 and $F800) shr 11;
end;

//------------------------------------------------------------------------------

function MSecToTCMs(const LNbMSec: Integer): TTimeCodeMs; //Transforme un nombre de ms en time code
var
  LSec: Integer;
begin
  LSec := LNbMSec div 1000;
  with Result do
  begin
    Hour := LSec div 3600;
    Min := (LSec mod 3600) div 60;
    Sec := LSec - (Hour * 3600) - (Min * 60);
    Ms := LNbMSec mod 1000;
  end;
end;

//------------------------------------------------------------------------------

function TCMsToMSec(const TmpTCMs: TTimeCodeMs): LongInt; //Transforme un time code en nombre de ms
begin
  with TmpTCMs do
    Result := (Hour * 3600 * 1000) + (Min * 60 * 1000) + (Sec * 1000) + Ms;
end;

//------------------------------------------------------------------------------

function CalcTCLastSCRresetMs(LCurrentSCR: Integer): TTimeCodeMs;
var
  L1, L2: Integer;
begin
  L1 := MsToTimer(TCMsToMsec(Form6.GetLastSCREdit));
  if L1 > LCurrentSCR then
    L2 := L1 - LCurrentSCR
  else
    L2 := 0;
  Result := MSecToTCMs(TimerToMs(L2));
end;

//------------------------------------------------------------------------------

procedure SaveBMP(const TmpBmp: TBitmap; const StFileName: Widestring);
begin
  if Form1.BMPOut.Color.Compress then
    DooItDizWey(TmpBmp, StFileName)
  else
    TmpBmp.SaveToFile(StFileName);
end;

//------------------------------------------------------------------------------

procedure SaveSup(const StFileName: Widestring);
var
  SupFic: file;
begin
  try
    AssignFile(SupFic, StFileName);
    FileMode := 1; //Ecriture Seule
    Rewrite(SupFic, 1);
    BlockWrite(SupFic, SupBuf, SupSize);
  finally
    CloseFile(SupFic);
  end;
end;

//------------------------------------------------------------------------------

function VOBMapStr2Int(Index: Cardinal): Int64;
begin
  //StrToInt64 - to result Int64 value
  Result := 2048 * StrToInt64(Copy(Form1.VOBMap[Index], 4, 8));
end;

//------------------------------------------------------------------------------

procedure RestoreVOBMapPos;
begin
  if Form16.CheckBoxBuildMap.Checked and Form1.Process.VOBMapExists then
  begin
    Form1.VOBMap.LoadFromFile(ChangeFileExt(Form1.Process.VobFiles[Form1.Process.VobFileIndex -1], '.srm'));
    while (Form1.VOBMap.Count > 0) and (VOBMapStr2Int(0) < Form1.Process.FilePos) do
      Form1.VOBMap.Delete(0);
  end;
end;

//------------------------------------------------------------------------------

procedure IncSmallSkipped;
//inform about too small / blank / too short subtitle item
begin
  Inc(Form1.Process.SmallSkipped);
  Form3.LabelSkip.Caption := Tnt_WideFormat('(+%d ' + MsgStr[20], [Form1.Process.SmallSkipped]);
  Form3.LabelSkip.Visible := True;
end;

//------------------------------------------------------------------------------

procedure OverlapInfo;
var
  I1: Integer;
  OverlapCount: Cardinal;
begin
  if not Form1.CLI.Wanted then
  begin
    OverlapCount := 0;
    for I1 := 1 to Form1.SubTitles.NbSub - 1 do
      if TCMsToMSec(Form1.SubTitles.Sub[I1].StopTC) >
        TCMsToMSec(Form1.SubTitles.Sub[I1 + 1].StartTC) then Inc(OverlapCount);
    if OverlapCount > 0 then
//      MessageBox(Application.Handle, PChar(MsgStr[13] + ' ' + IntToStr(OverlapCount) + 'x'),
//        PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
      WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[13] + ' ' + IntToStr(OverlapCount) + 'x', mtWarning, [mbOk], 0);
  end;
end;

//------------------------------------------------------------------------------

procedure DoAfterProcess;
begin
  //1) TC of last Sub-Picture = 00:00:00,000. On certain badly authored DVDs
  //   there is no stop time in some subtitles. This does similar thing like
  //   DelLastSubTitle but for the last Sub-Picture on DVD.
  if (Form1.SubTitles.NbSub > 0) and (TCMsToMSec(Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StopTC) = 0) then
  begin
    Form3.DelLastSubTitle;
    Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StopTC :=
      MSecToTCMs(TCMsToMSec(Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC) +
      Form16.SpinEditMaxTMP.Value);
    Form3.AddSubTitle(Form1.SubTitles.NbSub, True);
  end;

  //2) INFO (for Alex): Subtitles are overlapping
  OverlapInfo;
end;

//------------------------------------------------------------------------------

procedure ScanVob(const FName: Widestring);
var
  Fic: TFileStream;
  W1: Word;
  //HeaderBuf : Array [0..63] Of Byte; //I hope 64 bytes will be enough for biggest Header (Variable size, unknow max)
  PackBuf: array[0..2047] of Byte;

  CodePacket: Integer; //Code du paquet ( ex: debut de paquet $000001ba )
  SupChannel: Byte;
  HeaderSize: Byte;
  PacketSize: Word;
  UseFulSize: Word;
  UseFulOff: Word;
  EndSupOff: Word;
  //CodedTC    : Array[0..1] of Word;
  TmpTC: Unit01.TTimeCode;

const
  BLOCK_START_CODE = $000001BA;
  BLOCK_CRYPT_MASK = $30000000;
  VID_DETECT_BYTES = $000001E0;
  AUD_DETECT_BYTES = $000001C0;
  AC3_DETECT_BYTES = $000001BD; //AC3 or Sub-Picture packet (AC3=0x80->0x88 SUP=0x20->0x3f)
  NAV_DETECT_BYTES = $000001BB;
  PCI_DETECT_BYTES = $000001BF;
  END_OF_SUBPICT = $000001BE;
  //----------
  procedure SetEndProcessValues;
  begin
    Form1.Process.Working := False;
    Form1.ButtonPause.Enabled := False;
    Form1.OpenVob1.Enabled := True;
    Form1.TntBitButtonOpenVob.Enabled := True;
    Form1.Process.FilePos := 0;
    Form1.Process.LastSupPos := 0;
    Inc(Form1.Process.VobFileIndex); //Incremente le compteur de fichiers traits
    DetectFRonVOBbegin := True; //force the FR and size detection on each VOB debut
    Form1.VOBMap.Clear;
    RefreshTicker := 0;

    //do this after processing the dvd
    if Form1.Process.VobFileIndex > Form1.Process.VobFiles.Count then DoAfterProcess;
  end;
  //----------
  //PTS = Presentation Time Stamp (Compteur bas sur une horloge  90KHz qui gere le moment precis auquel on doit afficher un lment)
  function PTSToTCMs{(W1, W2, W3: Word)}: TTimeCodeMs;
  var
    L1, LMSec: Int64;
  begin
    //Ancienne methode, Calcule bizard !!
    //(Reverse engeenering avec les valeurs affiches dans VobSnoopy)
    {W1 := B4 + (B3 * $100); L1 := W1 Div 2;
    L1 := L1 + ((B2 div 2) * ($10000 div 2));
    L1 := L1 + (B1 * ($1000000 div 4));}

    //Nouvelle methode base sur une source linux en C
    {L1 := (W1 shr 1) and $7; L1 := L1 shl 15; L1 := L1 + (W2 shr 1);
    L1 := L1 shl 15; L1 := L1 + (W3 shr 1);}

    L1 := //mpucoder's def (it's strange but it is equal to previous)
      (PackBuf[27] and $FE) shr 1 +
      PackBuf[26] shl 7 +
      (PackBuf[25] and $FE) shl 14 +
      PackBuf[24] shl 22 +
      (PackBuf[23] and $0E) shl 29;

    LMSec := TimerToMs(L1);
    Result := MSecToTCMs(LMSec);
  end;
  //----------
  procedure ProcessSup;
  var
    TmpStartTCMs, TmpStopTCMs: TTimeCodeMs;
    TmpFileName: Widestring;
    TmpCoord: TRect;
    //----------
    procedure AssignOnOffTime;
    begin
      TmpStartTCMs := AddTCMs(SubTimeCodeMs, MSecToTCMs(Unit08.DCSQTArr.SP_DCSQT[1].TimeMs)); //Temps avant d'afficher(Gnralement 0)

      //VobSub - using .idx timecodes
      if (Form1.Process.VobFiles.Count = 1) and
        (Tnt_WideLowerCase(ExtractFileExt(Form1.Process.VobFiles[0])) = '.sub') and
        (Form6.idxName <> '')
        then TmpStartTCMs := StrToTCMs(Form6.idxTC[NbSub - 1]);

      if Unit08.DCSQTArr.SP_DCSQT[1].Command = SupCmdOff then TmpStopTCMs := TmpStartTCMs;

      with Unit08.DCSQTArr.SP_DCSQT[Unit08.DCSQTArr.NbSP_DCSQT] do //With the last SP_DCSQT of the Sub-Picture...
      begin
        if (Unit08.DCSQTArr.NbSP_DCSQT > 1) and (Command = SupCmdOff)
          then //If the Sub-Picture contain a stop display command at the end
        begin
          TmpStopTCMs := AddTCMs(SubTimeCodeMs, MSecToTCMs(TimeMs)); //Temps d'affichage ( Time Stop )
          //VobSub - using .idx timecodes
          if (Form1.Process.VobFiles.Count = 1) and
            (Tnt_WideLowerCase(ExtractFileExt(Form1.Process.VobFiles[0])) = '.sub') and
            (Form6.idxName <> '')
            then TmpStopTCMs := AddTCMs(TmpStartTCMs, MSecToTCMs(TimeMs));
        end
        else TmpStopTCMs := NulTimeCodeMs; //Else the stop time code is set to 0, waiting for the next Sub-Picture
      end;

      if (Form1.SubTitles.NbSub > 0) and (TCMsToMSec(Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StopTC) = 0) then
      begin //assigne le TimeStop de la Sub precedente si il ny en avait pas (00:00:00,000 si le precedent sous-titre n'avait pas de time stop dans le DCSQT)
        Form3.DelLastSubTitle;
        Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StopTC := TmpStartTCMs;
        Form3.AddSubTitle(Form1.SubTitles.NbSub, True);
      end;
    end;
    //----------
    function IsShowPicture: Boolean;
    begin
      Result := Unit08.DCSQTArr.SP_DCSQT[1].Command = SupCmdOn;
      with Unit08.DCSQTArr.SP_DCSQT[Unit08.DCSQTArr.NbSP_DCSQT] do //With the last SP_DCSQT of the Sub-Picture...
      begin
        if (Unit08.DCSQTArr.NbSP_DCSQT > 1) and (Command = SupCmdOff) then //If there is a Time stop then verify that the Subtitle duration is at least SET ms
          Result := Result and (TimeMs >= (Unit08.DCSQTArr.SP_DCSQT[1].TimeMs + Form16.SpinEditMinTime.Value)); //Si la Pict dure moins de SET ms, on l'ignore
      end;
    end;
    //----------
    procedure PrintPictTCAndRes(TmpCoord2: TRect);
    var StArr: TTntStrings;
    begin
      StArr := TTntStringList.Create;
      try
        AssignOnOffTime;
        if Form3.TxtFile.OutputFormat = OFImpre then
          StArr.Add(TmpFileName)
        else
          StArr.Add(ExtractFileName(TmpFileName));
        Form1.AddOneSubTitle(StArr, True, TmpStartTCMs, TmpStopTCMs, TmpCoord2,
          Unit08.DCSQTArr.SP_DCSQT[1].Color, Unit08.DCSQTArr.SP_DCSQT[1].Contrast);
      finally
        StArr.Free;
      end;
    end;
    //----------
  begin
    //decode sup in all cases instead of SaveSup mode + No Forced
    if (Form1.Process.Action <> ASubToSup) or
      Form16.ForcedChBox.Checked
      then Unit08.DecodeSup(SupBuf);

    Form1.LabelNbSup.Caption := IntToStr(NbSub);
    Form1.LabelTotalNbSup.Caption := IntToStr(TotalNbSub);

    //Forced Subs Only
    if Form16.ForcedChBox.Checked and not Unit08.DCSQTArr.Forced then Exit;

    case Form1.Process.Action of
      ASubToTxt:
        begin
          AssignOnOffTime;
          if IsShowPicture then
            Form1.OcrPicture(Form1.SubBmp, TmpStartTCMs, TmpStopTCMs, DCSQTArr.SP_DCSQT[1].PicCoord) //Fait l'ocr et donne le Time-Code
          else
            IncSmallSkipped;
        end;
      ASubToBmp:
        if IsShowPicture then
        begin
          if Form18.ShowSettings then
            if Form1.CLI.Wanted then
            begin
              Form18.FormShow(nil);
              Form18.BitBtn1Click(nil);
            end
            else Form18.ShowModal;
          TmpCoord := UGraph.AdjustBMP(Unit08.DCSQTArr.SP_DCSQT[1].PicCoord);

          if Form3.TxtFile.OutputFormat = OFSST then
            TmpFileName := Form1.SaveDialogBmpSup.FileName + '.' + IntToStr(Form1.SubTitles.NbSub + 1) + '.bmp'
          else
            TmpFileName := Form1.SaveDialogBmpSup.FileName + Format('%.5d.bmp', [Form1.SubTitles.NbSub + 1]);

          if Form18.CanSavePicture then //Don't save the bitmap if Skip Picture was pressed
          begin
            if Form1.Process.Action2 = 1 then PrintPictTCAndRes(TmpCoord); //Recupere le timing et la rsolution de l'image dans le fichier texte
            if Form1.CheckBoxShowSubPict.Checked then Form1.ShowPicture(Form1.OutBmp, TmpCoord, True);
            SaveBMP(Form1.OutBmp, TmpFileName);
          end;
        end
        else
          IncSmallSkipped;
      ASubToSup:
        //if IsShowPicture then - NOT APPLICABLE! (DecodeSup must be before)
        begin
          if Form3.TxtFile.OutputFormat = OFSST then
            TmpFileName := Form1.SaveDialogBmpSup.FileName + '.' + IntToStr(Form1.SubTitles.NbSub + 1) + '.sup'
          else
            TmpFileName := Form1.SaveDialogBmpSup.FileName + Format('%.5d.sup', [Form1.SubTitles.NbSub + 1]);

          SaveSup(TmpFileName);
          if Form1.CheckBoxShowSubPict.Checked or (Form1.Process.Action2 = 1) then
          begin
            Unit08.DecodeSup(SupBuf);
            TmpCoord := DCSQTArr.SP_DCSQT[1].PicCoord;
            if Form1.Process.Action2 = 1 then PrintPictTCAndRes(DCSQTArr.SP_DCSQT[1].PicCoord); //Recupere le timing et la rsolution de l'image dans le fichier texte
            Form1.ShowPicture(Form1.SubBmp, TmpCoord, True);
          end;
        end;
        {NOT APPLICABLE! (DecodeSup must be before)
        else
          IncSmallSkipped;}
      AShowSub:
        if IsShowPicture then
        begin
          if Form18.ShowSettings then Form18.ShowModal;
          TmpCoord := UGraph.AdjustBMP(Unit08.DCSQTArr.SP_DCSQT[1].PicCoord);
          Form1.ShowPicture(Form1.OutBmp, TmpCoord, True);
          if not Form11.NoStop then Form11.ShowModal;
          //Save Sub-Picture
          if Form11.ModalResult = 100 then //Save BMPs
          begin
            if Form3.TxtFile.OutputFormat = OFSST then
              TmpFileName := Form1.SaveDialogBmpSup.FileName + '.' + IntToStr(Form1.SubTitles.NbSub + 1) + '.bmp'
            else
              TmpFileName := Form1.SaveDialogBmpSup.FileName + Format('%.5d.bmp', [Form1.SubTitles.NbSub + 1]);
            if Form1.Process.Action2 = 1 then PrintPictTCAndRes(TmpCoord); //Recupere le timing et la rsolution de l'image dans le fichier texte
            SaveBMP(Form1.OutBmp, TmpFileName);
          end
          else
            if Form11.ModalResult = 101 then //Save SUPs
            begin
              if Form3.TxtFile.OutputFormat = OFSST then
                TmpFileName := Form1.SaveDialogBmpSup.FileName + '.' + IntToStr(Form1.SubTitles.NbSub + 1) + '.sup'
              else
                TmpFileName := Form1.SaveDialogBmpSup.FileName + Format('%.5d.sup', [Form1.SubTitles.NbSub + 1]);
              if Form1.Process.Action2 = 1 then PrintPictTCAndRes(DCSQTArr.SP_DCSQT[1].PicCoord); //Recupere le timing et la rsolution de l'image dans le fichier texte
              SaveSup(TmpFileName);
            end;
        end;
    end;
  end;
  //----------
  procedure RefreshRemainingTimeAndProgression;
  var
    W1: Word;
    CCurrentPos: Int64;
    Elapsed: Cardinal;
  begin
    //get current total file position to CCurrentPos (bytes)
    CCurrentPos := Fic.Position;
    if Form1.Process.VobFileIndex > 1 then
      for W1 := 0 to Form1.Process.VobFileIndex - 2 do
        Inc(CCurrentPos, Form1.Process.VobFileSize[W1]);

    //current percent + MBs done
    Form1.ProgressBar1.Position := 100 * CCurrentPos div Form1.Process.TotalSize;
    Application.Title := 'SubRip - ' + IntToStr(Form1.ProgressBar1.Position) + '%';
    Form1.LabelPos.Caption := Tnt_WideFormat('%.1f / %.1f MB (%d %%)',
      [CCurrentPos / 1048576, Form1.Process.TotalSize / 1048576, Form1.ProgressBar1.Position]);

    //remaining / elapsed time
    Elapsed := GetTickCount - Form1.Process.TimeStart;
    Form1.LabelTimeElapsed.Caption := Copy(TCMsToStr(MSecToTCms(Elapsed)), 0, 8);
    if CCurrentPos <> 0 then
      Form1.LabelTimeRemaining.Caption := Copy(TCMsToStr(MSecToTCms(Elapsed * (Form1.Process.TotalSize - CCurrentPos) div CCurrentPos)), 0, 8);
    Application.ProcessMessages;
  end;
  //----------
  function Get4Bytes(WOffset: Word): Cardinal;
  var
    Bcode: array[0..3] of Byte absolute Result;
  begin
    Bcode[3] := PackBuf[WOffset];
    Bcode[2] := PackBuf[WOffset + 1];
    Bcode[1] := PackBuf[WOffset + 2];
    Bcode[0] := PackBuf[WOffset + 3];
  end;
  //----------
  function Get2Bytes(WOffset: Word): Word;
  var
    Bcode: array[0..1] of Byte absolute Result;
  begin
    Bcode[1] := PackBuf[WOffset];
    Bcode[0] := PackBuf[WOffset + 1];
  end;
  //----------
  {procedure DecodeCC;
  var
   I, J  : Integer;
   B     : Byte;
   ccNrs : TStrings;
   TempS : WideString;
   TempTC, FrameTC: TTimeCode;
  begin
    TempTC := TimeCode;
    FrameTC:= NulTimeCode; FrameTC.Frame:= 1;
    ccNrs:= TTntStringList.Create;
    for I:= 14 to 2038 do
      if ( Get4Bytes(I) = $000001B2 ) and ( Get4Bytes(I+4) = $434301F8 ) then
        begin
          B:= PackBuf[I+8] and $1E shr 1;
          //FF xx xx FE 00 00 (type A)
          if ( PackBuf[I+ 9] = $FF) and
             ( PackBuf[I+12] = $FE) and
             ( PackBuf[I+13] = $00) and
             ( PackBuf[I+14] = $00) then
            for J:= 0 to B-1 do
              ccNrs.Add( IntToHex(PackBuf[I+10 + J*6], 2) +
                         IntToHex(PackBuf[I+11 + J*6], 2) )
          else
            //FF 80 80 FF xx xx (type B)
            if ( PackBuf[I+ 9] = $FF) and
               ( PackBuf[I+10] = $80) and
               ( PackBuf[I+11] = $80) and
               ( PackBuf[I+12] = $FF) then
              for J:= 0 to B-1 do
                ccNrs.Add( IntToHex(PackBuf[I+13 + J*6], 2) +
                           IntToHex(PackBuf[I+14 + J*6], 2) )
            else
              //FE 00 00 FF xx xx (type C)
              if ( PackBuf[I+ 9] = $FE) and
                 ( PackBuf[I+10] = $00) and
                 ( PackBuf[I+11] = $00) and
                 ( PackBuf[I+12] = $FF) then
                for J:= 0 to B-1 do
                  ccNrs.Add( IntToHex(PackBuf[I+13 + J*6], 2) +
                             IntToHex(PackBuf[I+14 + J*6], 2) )
        end;

    //header
    if SCC.Count = 0 then
      begin
        SCC.Add('Scenarist_SCC V1.0');
        SCC.Add('');
      end;

    //only 8080s => end
    for I:=0 to ccNrs.Count-1 do TempS:= TempS + ' ' ;//+
   //and (ccNrs[ccNrs.Count-1] = '8080') do
      ccNrs.Delete(ccNrs.Count-1);
    if ccNrs.Count = 0 then begin ccNrs.Free; Exit; end;

  {  if ( (ccNrs[0] = '942C') and (ccNrs.Count <= 1)
       ) or
       ( (ccNrs[0] = '942C') and (ccNrs.Count > 2) and (ccNrs[2] <> '942F') )
      then SCC.Add( TCToStr(TempTC) );//endrem//
  SCC.Add( TCToStr(TempTC) );
    for I:= 0 to ccNrs.Count-1 do
      begin
  {      if ( ( I>=1 ) and ( ccNrs[I] = '94AE' ) and ( ccNrs[I-1] <> '94AE' )
           ) or
           ( ( I>=1 ) and ( ccNrs[I] = '9420' ) and
             (ccNrs[I-1] <> '94AE') and (ccNrs[I-1] <> '9420')
           ) or
           ( SCC.Count = 2 )
          then
            begin
              While Copy(SCC[SCC.Count-1], Length(SCC[SCC.Count-1])-4, 5) = ' 8080'
                do SCC[SCC.Count-1]:= Copy(SCC[SCC.Count-1], 1, Length(SCC[SCC.Count-1])-4);
              SCC.Add( TCToStr(TempTC) );
            end;//endrem//
        SCC[SCC.Count-1]:= SCC[SCC.Count-1] + ' ' + ccNrs[I];
        //TempTC:= AddTC(TempTC, FrameTC);
      end;

    Form3.ListBoxSubtitle.Items:= SCC;
  //if SCC.Count <> Form3.ListBoxSubtitle.Items.Count then
  //Form3.ListBoxSubtitle.Items.Add(SCC[SCC.Count-1]);
    ccNrs.Free;
  end;}
  //----------
  {Function IsEndSup : Boolean;
  Var
     WOff : Word;
  Begin
     WOff := UseFulSize + UseFulOff;
     Result := (PackBuf[WOff]=$00) And (PackBuf[WOff +1]=$00) And (PackBuf[WOff +2]=$01) And (PackBuf[WOff +3]=$BE); //Flag de fin de Sup
     //Normalement les 2 octets suivants indiquent le nombre d'octets jusqu' la fin du paquet mais ils ne nous sont pas utiles
  End;  }
  //----------
  function GetSupChannel: Byte;
  begin
    Result := PackBuf[23 + HeaderSize];
  end;
  //----------
  procedure VOBMapAssignIndex(DelFirst: Boolean);
  var
    LngIdx: Byte;
  begin
    if Form1.VOBMap.Count = 0 then Exit; //prevents AV next
    if DelFirst then
    begin
      Form1.VOBMap.Delete(0);
      if Form1.VOBMap.Count = 0 then Exit; //prevents AV next
    end;

    LngIdx := StrToInt(Copy(Form1.VOBMap[0], 1, 2));
    while (Form1.VOBMap.Count > 0) and
      not (LngIdx in [0, 1, SupChannel]) do
    begin
      Form1.VOBMap.Delete(0);
      if Form1.VOBMap.Count = 0 then Exit; //prevents AV next
      LngIdx := StrToInt(Copy(Form1.VOBMap[0], 1, 2));
    end;

    Form1.Process.FilePos := VOBMapStr2Int(0);
    if DelFirst then Fic.Seek(Form1.Process.FilePos, soBeginning);
  end;
  //----------
begin
  if FileExists(FName) then
  begin
    Form1.Process.Working := True;
    Form1.ButtonPause.Enabled := True;
    Form1.OpenVob1.Enabled := False;
    Form1.TntBitButtonOpenVob.Enabled := False;
    if Form1.Process.FilePos = 0 then
    begin
      NbSub := 0;
      Form1.LabelNbSup.Caption := '0';
      Form1.LabelTotalNbSup.Caption := IntToStr(TotalNbSub);
    end;
    SupChannel := Form1.Process.Language;
    SupSize := 0;

    Fic := TFileStream.Create(FName, fmOpenRead or fmShareDenyWrite);
    try //TFileStream
      //VOB's subtitle map
      if Form16.CheckBoxBuildMap.Checked then
      begin
        Form1.Process.VOBMapExists := FileExists(ChangeFileExt(FName, '.srm'));
        if (Form1.VOBMap.Count = 0) and Form1.Process.VOBMapExists then
        begin
          Form1.VOBMap.LoadFromFile(ChangeFileExt(FName, '.srm'));
          if Form1.VOBMap.Count = 0 then //blank file
            Form1.Process.VOBMapExists := False
        end;
        if Form1.Process.VOBMapExists then VOBMapAssignIndex(False);
      end;

      //VobSub - using .idx file offsets
      if (Form1.Process.VobFiles.Count = 1) and
        (Tnt_WideLowerCase(ExtractFileExt(Form1.Process.VobFiles[0])) = '.sub') and
        (Form6.idxName <> '') and (Form16.CheckBoxUseFileOffsets.Checked)
        then Form1.Process.FilePos := StrToIntDef(Form6.idxFO[NbSub],Form1.Process.FilePos);


      Fic.Seek(Form1.Process.FilePos, soBeginning);
      //Form1.Process.FilePos := 0;
      //Read VOB Packet by Packet (2048 bytes long)
      while Fic.Read(PackBuf, 2048) > 0 do //read 1 packet
      begin
        //update every ~0.5 percent of TotalSize
        if Fic.Position > Form1.Process.TotalSize div 200 + RefreshTicker then
        begin
          RefreshTicker := Fic.Position;
          RefreshRemainingTimeAndProgression;
        end;

        //Regarde si il s'agit bien d'un paquet de VOB (commence tjs par $000001ba)
        if not (Get4Bytes(0) = BLOCK_START_CODE) and
          not Form1.Process.IgnoreBadPacket then
        begin
          W1 := MessageDlg(MsgStr[26] + ' ' +
            IntToStr(Fic.Position div 2048) + #13 +
            MsgStr[27], mtWarning,
            [mbYesToAll, mbYes, mbNo], 0);
          case W1 of
            mrYesToAll:
              Form1.Process.IgnoreBadPacket := True;
            mrNo:
              begin
                Fic.Free;
                SetEndProcessValues;
                Exit;
              end;
          end;
        end;

        //Closed Captions
        //if Get4Bytes(0) = BLOCK_START_CODE {and ChciCC} then DecodeCC;

        PacketSize := (PackBuf[18] * $100) + PackBuf[19];
        HeaderSize := PackBuf[22];
        //*********************** Gestion Timer  90 KHz pour le timing ( Timer rel = 27 MHz mais divis par 300 pour eviter les overflow )
        SCR := DecodeSCR(Get4Bytes(4), Get2Bytes(8)); //Timer sur chaques Paquets
        if CalculateLastScr then //Si on a saisit une valeur dans la form6
        begin
          TCLastSCRresetMs := CalcTCLastSCRresetMs(SCR);
          LastSCR := 0;
          SCRIncr := 0;
          CalculateLastScr := False;
        end;

        //VOB's subtitle map - phase_building - add 2 previous and current VOB packets
        if Form16.CheckBoxBuildMap.Checked and not Form1.Process.VOBMapExists and
          (SCR < LastSCR) and (Fic.Position >= 6144) then
        begin
          if (Form1.VOBMap.Count > 0) and //-1
            ((VOBMapStr2Int(Form1.VOBMap.Count - 1) = Fic.Position - 4096) or
            (VOBMapStr2Int(Form1.VOBMap.Count - 1) = Fic.Position - 6144)) then
            Form1.VOBMap.Delete(Form1.VOBMap.Count - 1);
          if (Form1.VOBMap.Count > 0) and //-2
            (VOBMapStr2Int(Form1.VOBMap.Count - 1) = Fic.Position - 6144) then
            Form1.VOBMap.Delete(Form1.VOBMap.Count - 1);
          Form1.VOBMap.Add(Tnt_WideFormat('01 %.8d', [(Fic.Position - 6144) div 2048]));
          Form1.VOBMap.Add(Tnt_WideFormat('01 %.8d', [(Fic.Position - 4096) div 2048]));
          Form1.VOBMap.Add(Tnt_WideFormat('01 %.8d', [(Fic.Position - 2048) div 2048]));
        end;

        if (SCR = 0) or //Le SCR  t reset
          (Form1.Process.AvoidTimeRestart and (SCR < LastSCR)) then
        begin
          Inc(LastSCR, SCRIncr); //Ajoute l'increment normal de SCR entre 2 paquets
          TCLastSCRresetMs := AddTCMs(TCLastSCRresetMs, MSecToTCMs(TimerToMs(LastSCR)));
        end
        else
          if SCR >= LastSCR then SCRIncr := Word(SCR - LastSCR); //Sinon on calcule l'increment de timer
        LastSCR := SCR;
        //***********************  Fin Gestion Timer

        //NAV_DETECT_BYTES
        CodePacket := Get4Bytes(14); //Lit le code du sous-paquet
        if CodePacket = NAV_DETECT_BYTES then //Paquet Navigation avec Time-Code
        begin
          //VOB's subtitle map - phase_building
          if Form16.CheckBoxBuildMap.Checked and not Form1.Process.VOBMapExists and
            ((Form1.VOBMap.Count = 0) or ((Form1.VOBMap.Count > 0) and (VOBMapStr2Int(Form1.VOBMap.Count - 1) < Fic.Position - 2048))) then //don't add if '01' used previously
            Form1.VOBMap.Add(Tnt_WideFormat('00 %.8d', [(Fic.Position - 2048) div 2048]));
          //autodetect/correct framerate, when none IDX/IFO present
          //if Form1.Process.VideoSize.X = 0 - made problems with PAL titles -> menu VOB = 720x480
          if DetectFRonVOBbegin {Form1.Process.VideoSize.X = 0} then DetectFrameRate(PackBuf[72]);
          LastTCChapter := TCChapter;
          TCChapter := ByteToTC(PackBuf[69], PackBuf[70], PackBuf[71], PackBuf[72]);

          if IsTC1SmallerThanTC2(TCChapter, LastTCChapter) then //C'est un nouveau Chapitre ( le timing repart  00:00:00 00 )
          begin
            TmpTC := NulTimeCode; //    Ajoute l'increment de frames car le  time code
            TmpTC.Frame := FrameIncr; //est repass  0 (sinon on prend un retard de
                                      //FrameIncr  chaques nouveaux chapitres)
            TimeCode2 := AddTC(TimeCode, TmpTC); //On fixe le TimeCode total de la fin du prcdent chapitre
            Inc(NbChapter);
            Form1.LabelChapters.Caption := IntToStr(NbChapter);
          end
          else if (TCChapter.Sec = LastTCChapter.Sec) then //Si on est sur la mme seconde
            FrameIncr := TCChapter.Frame - LastTCChapter.Frame; //alors calcule l'increment de Frames

          TimeCode := AddTC(TimeCode2, TCChapter);
          TimeCodeMs := TCToTCMs(TimeCode);
          Form1.LabelTime.Caption := TCmsToStr(TimeCodeMs);
          Form1.LabelTime7.Caption := TCMsToStr(AddTCMs(TCLastSCRresetMs, MSecToTCMs(TimerToMs(SCR))));
        end

        //AC3_DETECT_BYTES
        else
        begin
          //VOB's subtitle map - phase_building
          if Form16.CheckBoxBuildMap.Checked and not Form1.Process.VOBMapExists and
            (CodePacket = AC3_DETECT_BYTES) and (GetSupChannel < $40) and
            ((Form1.VOBMap.Count = 0) or ((Form1.VOBMap.Count > 0) and (VOBMapStr2Int(Form1.VOBMap.Count - 1) < Fic.Position - 2048))) then //don't add if '01' used previously, or after "Pause"
            Form1.VOBMap.Add(Tnt_WideFormat('%.2d %.8d', [GetSupChannel, (Fic.Position - 2048) div 2048]));

          if (CodePacket = AC3_DETECT_BYTES) and (GetSupChannel = SupChannel) then //Check if it's a Subtitle Packet on the wanted channel
          begin
            UseFulSize := PacketSize - (4 + HeaderSize);
            UseFulOff := 24 + HeaderSize;
            if SupSize = 0 then with Form1 do //Si SupSize est  0 alors c'est le dbut du sous titre, on mmorise l'offset (en nombre de paquets)
              begin
                //total size of current Sup
                CurrSupTotalSize := Get2Bytes(UseFulOff);
                //offset in Vob of the current Sup
                Process.LastSupPos := Fic.Position - 2048;
                SubTimeCodeMs := AddTCMs(TCLastSCRresetMs, PTSToTCMs{(PackBuf[23], Get2Bytes(24), Get2Bytes(26))});
              end;

            Move(PackBuf[UseFulOff], SupBuf[SupSize], UseFulSize); //Copie la partie utile dans le SupBuffer
            Inc(SupSize, UseFulSize);
            EndSupOff := UseFulSize + UseFulOff; //Offset de la fin de la partie utile du paquet
            if ((EndSupOff <= (2048 - 6)) and
              (Get4Bytes(EndSupOff) = END_OF_SUBPICT)
              ) or
            //C'est la fin d'une sup, on l'affiche
            (SupSize >= CurrSupTotalSize) then
            begin
              Inc(NbSub); Inc(TotalNbSub);
              ProcessSup;
              SupSize := 0;
              RefreshRemainingTimeAndProgression; RefreshTicker := Fic.Position;
            end
          end;
        end;

        //Pause in all cases (not only in case of non NAV/SUB packets)
        if Form1.Process.Paused and (SupSize = 0) then
        begin
          Form1.OpenVob1.Enabled := True;
          Form1.TntBitButtonOpenVob.Enabled := True;
          Form1.Process.Working := False;
          if RealF1Pause then //Form1.ButtonPause was really clicked
          begin
            if Form16.CheckBoxBuildMap.Checked then
            begin
              if Form1.Process.VOBMapExists and (Form1.VOBMap.Count > 0) then
                Form1.VOBMap.Delete(0);
            end;
            Form1.Process.FilePos := Fic.Position;
          end
          else
            LastSCR := 0; //workaround after F2Pause or F11Pause
          Fic.Free;
          Exit;
        end;

        //VOB's subtitle map - phase_building - add 2 last VOB packets
        if Form16.CheckBoxBuildMap.Checked and not Form1.Process.VOBMapExists and
          (Fic.Position >= Fic.Size - 2048) then
        begin
          if (Form1.VOBMap.Count > 0) and
            (VOBMapStr2Int(Form1.VOBMap.Count - 1) = Fic.Position - 2048) then
            Form1.VOBMap.Delete(Form1.VOBMap.Count - 1);
          Form1.VOBMap.Add(Tnt_WideFormat('01 %.8d', [(Fic.Position - 2048) div 2048]));
        end;

        //VOB's subtitle map - phase_using
        if Form16.CheckBoxBuildMap.Checked and Form1.Process.VOBMapExists then
        begin
          VOBMapAssignIndex(True);
          if Form1.VOBMap.Count = 0 then Break; //VOB(Map) EoF reached
        end;

      //VobSub - using .idx file offsets
      if (Form1.Process.VobFiles.Count = 1) and
        (Tnt_WideLowerCase(ExtractFileExt(Form1.Process.VobFiles[0])) = '.sub') and
        (Form6.idxName <> '') and (Form16.CheckBoxUseFileOffsets.Checked)
        then
        begin
         Form1.Process.FilePos := StrToIntDef(Form6.idxFO[NbSub],Form1.Process.FilePos);
         Fic.Seek(Form1.Process.FilePos, soBeginning);
        end;

      end;//while read
      //SpeedTest:
      //Form1.Label4.Caption := IntToStr((GetTickCount - Form1.CSpeedTest) div 10);

      //save VOB's submap only if eof reached! - phase_building
      if Form16.CheckBoxBuildMap.Checked and not Form1.Process.VOBMapExists and
        (Form1.VOBMap.Count > 0) and //for "blank vob/sub" case
        Form3.CanWriteToFile(ChangeFileExt(FName, '.srm')) then //check Daemon Tools ISOs, write protected drives
        Form1.VOBMap.SaveToFile(ChangeFileExt(FName, '.srm'));

      if Form1.Process.TotalSize > 0 then //check size for case of 1 selected blank .vob/.sub file (div0)
        RefreshRemainingTimeAndProgression;
      Fic.Free;
      SetEndProcessValues;
    except //Remplacement du Finally par Except pour pouvoir Faire un SetProcessValues (Evite de que le prog relise le mme fichier en boucle en cas d'erreur)
      raise; //MessageBox(Application.Handle, PChar(MsgStr[28] + ' ' + FName + MsgStr[29] + #13 + MsgStr[30]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
      Fic.Free;
      SetEndProcessValues;
    end;
  end;
end;

function TCMsToFrame(const tc: TTimeCodeMs; kFPS: Cardinal): Cardinal; //Added by MJQ (subrip@divx.pl)
var
  ms,lkfps:double;
begin
  ms:=TCmsToMsec(tc)/1000;
  lkfps:=kfps/1000;
  Result:=Trunc(ms*lkfps);
end;


end.
