{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit08; //decode one Sub-Picture unit  partir du buffer la contenant et l'affiche dans Form1.Image1
             //puis lance l'ocr dessus
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls;

type
  TLineOff = record
    Line1Of: Word; //offset of even lines (in the sup buf) 2 4 6...
    Line2Of: Word; //offset of odd lines (in the sup buf)  1 3 5...
  end;
  TControlHeader = record
    TimeMs: Integer; //Time to wait before applying this control header
    NextOff: Word; //Offset of the next control header (if it's the last = Current Pos - 2)
    Command: Byte; //Action: $01 Show pict, $02 Hide pict
    Color: Word; //index of 4 colors in the palette
    Contrast: Word; //Contrast channel of 4 colors
    PicCoord: TRect; //Coordinates of the picture on the screen
    LineOff: TLineOff; //Offset of Even & Odd lines (in the sup buf)
  end;

var
  DCSQTArr: record
    NbSP_DCSQT: Word; //Number of SP_DCSQT in current DCSQT
    SP_DCSQT: array[1..4096] of TControlHeader; //Max 4096 commands in DCSQT (shall be enough!)
    Forced: Boolean; //Forced sign somewhere inside of DCSQTArr
  end;
  SupWidth, SupHeight: Word;

const
  SupCmdOn = 1;
  SupCmdOff = 2;

procedure DecodeSup(const SupBuf: array of Byte);


implementation

uses Unit01;

//------------------------------------------------------------------------------

procedure DecodeSup(const SupBuf: array of Byte);
var
  DumArr: array[0..255] of Byte;
  EvenOddLines: array[0..1] of record BeginOff, EndOff: Word; end;
  BL: Byte;
  SupOff: Word;

  WIndex: Word;
  WEnd: Word;

  L1: Cardinal;
  Mode: Byte;
  Mult: Word;
  NMult: Word;
  NbBits: Byte;
  {B1,} B2: Byte;

  SPUsize: Word;
  DCSQTofs: Word;
  //Line1Of: Word;
  //Line2Of: Word;
  //PxdSize: Word;
  dummyByte: Byte;

  X, Y: Word;
  PBA: PByteArray;
  CropValues: TRect;
  //---------------------
  procedure IncY;
  begin
    while ((L1 + 2) mod 8) <> 0 do Inc(L1, 2); //Resynchronisation sur l'octet entier suivant
    X := 0;
    Inc(Y, 2);
    if Y <= SupHeight then //Bmp is created 1 line higher, this line avoid to corrupt the reel last line in case of exceed of data
      PBA := Form1.SubBmp.ScanLine[Y]; //Charge la lignes WY de L'image dans PBA
  end;
  //---------------------
  procedure DrawPoints(N: Word; const BNumColor: Byte);
  var
    I: Integer;
  begin
    if (X + N) > SupWidth then
      N := SupWidth - X; //avoid crash on longer line
    if BNumColor <> 0 then
      for I:= X to X + N - 1 do
        PBA[I] := BNumColor;
    Inc(X, N);
    if X >= SupWidth then IncY;
  end;
  //---------------------
  function ReadTimeMs: Integer; //Time to wait before applying Control Header
  var
    W1: Word;
  begin
    Move(SupBuf[SupOff], W1, 2); //Read the time in 1024/90000 s
    W1 := Swap(W1);
    Result := (W1 * 1024) div 90; //time [ms] (mpucoder: Rounding up will cause the display to occur one frame late.)
    Inc(SupOff, 2);
  end;
  //---------------------
  function Read2Byte: Word;
  begin
    Move(SupBuf[SupOff], Result, 2); //Read 2 bytes
    Result := Swap(Result);
    Inc(SupOff, 2);
  end;
  //---------------------
  function ReadCoor: TRect; //$05
  begin
    Move(SupBuf[SupOff], DumArr, 6); //Read the 6 coordinates bytes
    Result.Left := (DumArr[0] * $10) + ((DumArr[1] shr 4) and $0F); ; //Calculate SupLeft  ( 12 bits )
    Result.Right := ((DumArr[1] and $0F) * $100) + DumArr[2]; //Calculate SupRight ( 12 bits )
    Result.Top := (DumArr[3] * $10) + ((DumArr[4] shr 4) and $0F); ; //Calculate SupTop    ( 12 bits )
    Result.Bottom := ((DumArr[4] and $0F) * $100) + DumArr[5]; //Calculate SupBottom ( 12 bits )
    Inc(SupOff, 6);
  end;
  //---------------------
  function ReadLinesOf: TLineOff; //$06
  begin
    Move(SupBuf[SupOff], DumArr, 4); //Read the 4 Line Offset Bytes
    Result.Line1Of := (DumArr[0] * $100) + DumArr[1]; //Calculate Line1 Offset
    Result.Line2Of := (DumArr[2] * $100) + DumArr[3]; //Calculate Line2 Offset
    Inc(SupOff, 4);
  end;
  //---------------------
  procedure ReadChn_ColCon; //$07  not used for the moment (skipped)
  var
    WSize: Word;
  begin
    WSize := Read2Byte;
    Inc(SupOff, WSize - 2);
  end;
  //---------------------
  function ReadOneSp_DCSQT(const WOff: Word): TControlHeader; //Read a control header
  begin
    SupOff := WOff; //go to start of control header

    Result.TimeMs := ReadTimeMs;
    Result.NextOff := Read2Byte;
    Result.Command := SupCmdOn; //Par defaut on affiche la sup
    Result.Contrast := $FFF0; //Par defaut toutes les couleurs opaque sauf la 0 (fond)

    repeat
      dummyByte := SupBuf[SupOff];
      Inc(SupOff);
      case dummyByte of
        $00: begin DCSQTArr.Forced := True; Result.Command := SupCmdOn; end; //FSTA_DSP - Forced start display
        $01: Result.Command := SupCmdOn; //STA_DSP - start display
        $02: Result.Command := SupCmdOff; //STP_DSP - stop display
        $03: Result.Color := Read2Byte; //SET_COLOR - set colors: 0x03wxyz: w-empahsis 2 color, x-emphasis 1 color, y-pattern color, z-background color
        $04: Result.Contrast := Read2Byte; //SET_CONTR - set contrast (transparency): 0x04wxyz w-emphasis 2 transparency and so on
        $05: Result.PicCoord := ReadCoor; //SET_DAREA - set display area: 0x05xxxXXXyyyYYY, xxx - start X coordinate, XXX - end X coordinate, yyy - start Y coordinate, YYY - end Y coordinate
        $06: Result.LineOff := ReadLinesOf; //SET_DSPXA - set display pixel area: 0x06xxxxyyyy, xxxx - start addr. of PXD Top Field, yyyy - start addr. of PXD Bottom Field
        $07: ReadChn_ColCon; //CHN_COLCON - change color/contrast, 0x07wwww ....... 0fffffff: where wwww is the length including wwww and termination code 0x0fffffff
        $FF: Break; //CMD_END - command sequence terminator, End of current Command Header
      end;
    until {(LineOfBool And CoorBool) Or}(SupOff >= SPUsize);
    //If Result.Contrast = 0 Then Result.Command  := SupCmdOff; //If all Contrast channel are 0 then picture is hidden
  end;
  //---------------------
  procedure ReadControlHeader; //read all control headers
  var
    W1: Word;
    PrevSP_DCSQTofs: Word;
    SP_DCSQTofs: Word;
    YCoo: Integer;
  begin
    if Form1.Process.VideoSize.Y = 0 then YCoo := 576 else YCoo := Form1.Process.VideoSize.Y;
    W1 := 1;
    SP_DCSQTofs := DCSQTofs; //Begin of the first SP_DCSQT
    repeat
      DCSQTArr.NbSP_DCSQT := W1;
      DCSQTArr.SP_DCSQT[W1] := ReadOneSp_DCSQT(SP_DCSQTofs); //Read a control header
      PrevSP_DCSQTofs := SP_DCSQTofs; //Save the current SP_DCSQT offset
      SP_DCSQTofs := DCSQTArr.SP_DCSQT[W1].NextOff; //Offset of the next SP_DCSQT
      Inc(W1);
    until SP_DCSQTofs <= PrevSP_DCSQTofs; //If the SP_DCSQTofs point on himself then this is the last one

    SupWidth := DCSQTArr.SP_DCSQT[1].PicCoord.Right - DCSQTArr.SP_DCSQT[1].PicCoord.Left + 1; //Calculate SupWidth  with SupRight & SupLeft
    SupHeight := DCSQTArr.SP_DCSQT[1].PicCoord.Bottom - DCSQTArr.SP_DCSQT[1].PicCoord.Top + 1; //Calculate SupHeight with SupBottom & SupTop
    if SupWidth < 1 then SupWidth := 1 else if SupWidth > 720 then SupWidth := 720; //Evite les plantage en cas
    if SupHeight < 1 then SupHeight := 1 else if SupHeight > YCoo then SupHeight := YCoo; //d'erreurs dans la taille

    //Gangsters (Fr 2001/2002) or Wild Orchid - alternating contrast (+color?)
    Form1.SubPicture.SubColor[0] := DCSQTArr.SP_DCSQT[1].Color and $000F; //b commonly
    Form1.SubPicture.SubColor[1] := (DCSQTArr.SP_DCSQT[1].Color and $00F0) shr 4; //p commonly
    Form1.SubPicture.SubColor[2] := (DCSQTArr.SP_DCSQT[1].Color and $0F00) shr 8; //e1 commonly
    Form1.SubPicture.SubColor[3] := (DCSQTArr.SP_DCSQT[1].Color and $F000) shr 12; //e2 commonly
    Form1.SubPicture.ClrChanged := DCSQTArr.SP_DCSQT[1].Color <> Form1.SubPicture.PrevClr;
    Form1.SubPicture.PrevClr := DCSQTArr.SP_DCSQT[1].Color;
    //MessageBox(Application.Handle, PChar(Format('%d %d %d %d', [Form1.SubPicture.SubColor[0], Form1.SubPicture.SubColor[1], Form1.SubPicture.SubColor[2], Form1.SubPicture.SubColor[3]])), PChar('clr'), MB_OK);
    Form1.SubPicture.SubContrast[0] := DCSQTArr.SP_DCSQT[1].Contrast and $000F; //b commonly
    Form1.SubPicture.SubContrast[1] := (DCSQTArr.SP_DCSQT[1].Contrast and $00F0) shr 4; //p commonly
    Form1.SubPicture.SubContrast[2] := (DCSQTArr.SP_DCSQT[1].Contrast and $0F00) shr 8; //e1 commonly
    Form1.SubPicture.SubContrast[3] := (DCSQTArr.SP_DCSQT[1].Contrast and $F000) shr 12; //e2 commonly
    Form1.SubPicture.CtrChanged := DCSQTArr.SP_DCSQT[1].Contrast <> Form1.SubPicture.PrevCtr;
    Form1.SubPicture.PrevCtr := DCSQTArr.SP_DCSQT[1].Contrast;
    //MessageBox(Application.Handle, PChar(Format('%d %d %d %d', [Form1.SubPicture.SubContrast[0], Form1.SubPicture.SubContrast[1], Form1.SubPicture.SubContrast[2], Form1.SubPicture.SubContrast[3]])), PChar('cTr'), MB_OK);
  end;
  //---------------------
begin
  DCSQTArr.Forced := False;
  try
    SupOff := 0;

    //SPU Size
    Move(SupBuf[SupOff], SPUsize, 2);
    SPUsize := Swap(SPUsize);
    Inc(SupOff, 2);

    //start address of control header
    Move(SupBuf[SupOff], DCSQTofs, 2);
    DCSQTofs := Swap(DCSQTofs);
    Inc(SupOff, 2);

    //read control headers
    ReadControlHeader;

    //Read Offset & size of the PXD (2 blox: Even & Odd lines)
    EvenOddLines[0].BeginOff := DCSQTArr.SP_DCSQT[1].LineOff.Line1Of; //start of Even Lines
    EvenOddLines[1].BeginOff := DCSQTArr.SP_DCSQT[1].LineOff.Line2Of; //start of Odd Lines

    EvenOddLines[0].EndOff := EvenOddLines[0].BeginOff
      + DCSQTArr.SP_DCSQT[1].LineOff.Line2Of - DCSQTArr.SP_DCSQT[1].LineOff.Line1Of; //Calculate the Size of Even Lines Buffer
    EvenOddLines[1].EndOff := EvenOddLines[1].BeginOff
      + DCSQTofs - DCSQTArr.SP_DCSQT[1].LineOff.Line2Of; //Calculate the Size of Odd  Lines Buffer

    Form1.SubBmp.Width := SupWidth;
    //BMP is created 1 line higher, this line avoid to corrupt the reel last line in case of exceed of data
    Form1.SubBmp.Height := SupHeight + 1;

    //fill rectangle with b-color
    Form1.SubBmp.Canvas.Brush.Color := 0; //b commonly!
    Form1.SubBmp.Canvas.Pen.Color := 0; //b
    Form1.SubBmp.Canvas.Pen.Width := 0;
    Form1.SubBmp.Canvas.Rectangle(0, 0, SupWidth, SupHeight);

    //--------------------------------------------------
    //Decode RLE2 bits
    for BL := 0 to 1 do
    //Decode dja les lignes paires (0 2 4 6 ...) puis les lignes impaires (1 3 5 7 ...)
    begin
      WIndex := EvenOddLines[BL].BeginOff;
      WEnd := EvenOddLines[BL].EndOff;
      Mode := 0;
      L1 := 0; //count of read bits
      X := 0;
      Y := BL; //even or odd line
      PBA := Form1.SubBmp.ScanLine[Y];
      repeat
        B2 := (SupBuf[WIndex]) shr (6 - (L1 mod 8)) and $03;
        case Mode of
          2: begin //Mode Plus de 3 pixels de mme couleur : Phase 1 Comptage du nombre de bits utiliss
              if B2 = 0 then begin Inc(NbBits, 2); end
              else begin NMult := B2 shl (NbBits - 2); Mode := 3; end;
              //Optimized-- Else Begin NMult := B2; NMult := NMult Shl (NbBits-2); Mode := 3; End;
              if NbBits = 16 then Mode := 4;
            end;
          0: begin //Detection du mode
              //Optimized-- NMult  := 0;
              //Optimized-- NbBits := 0;
              if B2 <> 0 then begin Mode := 1; Mult := B2; end
              else begin Mode := 2; NbBits := 4; end;
            end;
          3: begin //Mode Plus de 3 pixels de mme couleur : Phase 2 Quantification du nombre de pixels (compt sur NbBits)
              if NbBits = 2 then
              begin
                DrawPoints(NMult, B2);
                Mode := 0;
              end
              else
              begin
                Dec(NbBits, 2);
                //Optimized-- W1 := B2;
                //Optimized-- NMult := NMult OR (W1 Shl (NbBits - 2));
                NMult := NMult or (Word(B2) shl (NbBits - 2));
              end;
            end;
          1: begin //Mode 1  3 pixels de mme couleur
              DrawPoints(Mult, B2);
              Mode := 0;
            end;
          4: begin //Mode Fin de ligne avec la mme couleur et resynchronysation sur l'octet entier suivant
              Mult := SupWidth - X; //Calcule du Nb de pixels restant jusqu'a la fin de la ligne
              DrawPoints(Mult, B2);
              Mode := 0;
            end;
        end;
        Inc(L1, 2);
        if (L1 mod 8) = 0 then Inc(WIndex);
      until WIndex >= WEnd;
    end;

    Form1.SubBmp.Height := SupHeight;

    for BL := 0 to 3 do
      Form1.SubPicture.Texts[BL] := 2; //default

    //resize bmp to visible subpic size & correct PicCoord according to
    for BL := 0 to 3 do
      if Form1.SubPicture.SubContrast[BL] = 0 then
      begin
        Form1.SubPicture.Texts[BL] := 0;
        CropValues := Form1.CutValidRect(Form1.SubBmp, BL, True);
        Inc(DCSQTArr.SP_DCSQT[1].PicCoord.Left, CropValues.Left);
        DCSQTArr.SP_DCSQT[1].PicCoord.Right := DCSQTArr.SP_DCSQT[1].PicCoord.Left + Form1.SubBmp.Width - 1;
        Inc(DCSQTArr.SP_DCSQT[1].PicCoord.Top, CropValues.Top);
        DCSQTArr.SP_DCSQT[1].PicCoord.Bottom := DCSQTArr.SP_DCSQT[1].PicCoord.Top + Form1.SubBmp.Height - 1;
      end;
  finally
  end;
end;

end.
