{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit14;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Buttons, StdCtrls, ExtCtrls, Unit01, UConfig, Word_u, TntDialogs, Dialogs, TntForms,
  TntStdCtrls, TntExtCtrls, TntButtons;

type
  TForm14 = class(TTntForm)
    Label7: TTntLabel;
    Label6: TTntLabel;
    Label8: TTntLabel;
    Label9: TTntLabel;
    ButtonResetOffset: TTntButton;
    Word_uHour: TWord_u;
    Word_uMin: TWord_u;
    Word_uSec: TWord_u;
    Word_uMSec: TWord_u;
    BitBtnModifyTC: TTntBitBtn;
    BitBtn1: TTntBitBtn;
    CheckBoxMinusOffset: TTntCheckBox;
    Panel1: TTntPanel;
    Panel2: TTntPanel;
    Label1: TTntLabel;
    Label2: TTntLabel;
    Label3: TTntLabel;
    Label4: TTntLabel;
    ButtonResetStretch: TTntButton;
    Word_uHourS: TWord_u;
    Word_uMinS: TWord_u;
    Word_uSecS: TWord_u;
    Word_uMSecS: TWord_u;
    CheckBoxMinusStretch: TTntCheckBox;
    Label5: TTntLabel;
    Label10: TTntLabel;
    Label11: TTntLabel;
    Panel3: TTntPanel;
    Label12: TTntLabel;
    CheckBoxSubDuration: TTntCheckBox;
    RadioGroupTime: TTntRadioGroup;
    PanelFixedTime: TTntPanel;
    Word_uFixedDuration: TWord_u;
    Label13: TTntLabel;
    PanelProportionalTime: TTntPanel;
    Word_uOffsetDuration: TWord_u;
    Word_uMsPerChar: TWord_u;
    Label14: TTntLabel;
    Label15: TTntLabel;
    Panel4: TTntPanel;
    Label16: TTntLabel;
    Word_uMinInterval: TWord_u;
    Label17: TTntLabel;
    Panel5: TTntPanel;
    LabelTimeAuthor: TTntLabel;
    CheckBoxTimeAuthor: TTntCheckBox;
    procedure ButtonResetOffsetClick(Sender: TObject);
    procedure BitBtnModifyTCClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonResetStretchClick(Sender: TObject);
    procedure RadioGroupTimeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetTimeOffset(TmpTCMs: TTimeCodeMs);
    function GetTimeOffset: TTimeCodeMs;
    procedure SetTimeStretch(TmpTCMs: TTimeCodeMs);
    function GetTimeStretch: TTimeCodeMs;
    procedure ApplyTimeOffset(TmpTimeOffset: TTimeCodeMs);
    procedure ApplyTimeStretch(TmpTimeStretch: TTimeCodeMs);
    procedure ApplySubDuration;
    procedure ApplyMinInterval;
  end;

var
  Form14: TForm14;

implementation

uses Unit03, Unit07, Unit13;

{$R *.DFM}

procedure TForm14.SetTimeOffset(TmpTCMs: TTimeCodeMs);
begin
  Word_uHour.Valeur := TmpTCMs.Hour;
  Word_uMin.Valeur := TmpTCMs.Min;
  Word_uSec.Valeur := TmpTCMs.Sec;
  Word_uMSec.Valeur := TmpTCMs.Ms;
end;

function TForm14.GetTimeOffset: TTimeCodeMs;
begin
  Result.Hour := Word_uHour.Valeur;
  Result.Min := Word_uMin.Valeur;
  Result.Sec := Word_uSec.Valeur;
  Result.Ms := Word_uMSec.Valeur;
end;

procedure TForm14.SetTimeStretch(TmpTCMs: TTimeCodeMs);
begin
  Word_uHourS.Valeur := TmpTCMs.Hour;
  Word_uMinS.Valeur := TmpTCMs.Min;
  Word_uSecS.Valeur := TmpTCMs.Sec;
  Word_uMSecS.Valeur := TmpTCMs.Ms;
end;

function TForm14.GetTimeStretch: TTimeCodeMs;
begin
  Result.Hour := Word_uHourS.Valeur;
  Result.Min := Word_uMinS.Valeur;
  Result.Sec := Word_uSecS.Valeur;
  Result.Ms := Word_uMSecS.Valeur;
end;

procedure TForm14.ButtonResetOffsetClick(Sender: TObject);
begin
  SetTimeOffset(NulTimeCodeMs);
end;

procedure TForm14.ButtonResetStretchClick(Sender: TObject);
begin
  SetTimeStretch(NulTimeCodeMs);
end;

procedure TForm14.BitBtnModifyTCClick(Sender: TObject);
  //----------
  procedure CorrectTCforAuthoring;
  var
    WNbSup: Word;
    dummy: Integer;
  begin     
    with Form1.Subtitles do
    begin
      for WNbSup := 1 to NbSub - 1 do
      begin
        //avoid Eyes`Only ZeRo Duration
        //ads 1 frame to stop time and must to count with next subtitle start time
        //(subtitles with ZeRo duration are rejected by Scenarist)
        //pHase 1: check if previous subtitle won't overlap the next
        if (Unit07.TCMsToMSec(Sub[WNbSup].StopTC) > Unit07.TCMsToMSec(Sub[WNbSup + 1].StartTC)) and
          (Unit07.TCMsToMSec(Sub[WNbSup].StartTC) < Unit07.TCMsToMSec(Sub[WNbSup + 1].StartTC)) then //fuck-off reset2zero
          Sub[WNbSup].StopTC := Sub[WNbSup + 1].StartTC;
        //pHase 2: check start - stop times
        dummy := Unit07.TCMsToMSec(Sub[WNbSup].StartTC) - Unit07.TCMsToMSec(Sub[WNbSup].StopTC);
        if (dummy > -1000 / (Unit07.FPS + 1)) and //start >= stop (~1 frame reserve because of rounding frames)
          (dummy < 10000 / (Unit07.FPS + 1)) then //10 frames diff MAX ('cause could be reset2zero or w/o-stoptime)
          Sub[WNbSup].StopTC := Unit07.MSecToTCMs(Unit07.TCMsToMSec(Sub[WNbSup].StartTC) + 1000 div (Unit07.FPS + 1)); //start + 1 frame
        //pHase 3: next-start must be > stop
        if Unit07.TCMsToMSec(Sub[WNbSup].StopTC) >= Unit07.TCMsToMSec(Sub[WNbSup + 1].StartTC) then
          Sub[WNbSup + 1].StartTC :=
            Unit07.MSecToTCMs(Unit07.TCMsToMSec(Sub[WNbSup].StopTC) + 1000 div (Unit07.FPS + 1)); //prev-stop + 1 frame
      end;
      //don't forget the last subtitle
      dummy := Unit07.TCMsToMSec(Sub[NbSub].StartTC) - Unit07.TCMsToMSec(Sub[NbSub].StopTC);
      if (dummy > -1000 / (Unit07.FPS + 1)) and //start >= stop (~1 frame reserve because of rounding frames)
        (dummy < 10000 / (Unit07.FPS + 1)) then //10 frames diff MAX ('cause could be reset2zero or w/o-stoptime)
        Sub[NbSub].StopTC := Unit07.MSecToTCMs(Unit07.TCMsToMSec(Sub[NbSub].StartTC) + 1000 div (Unit07.FPS + 1)); //start + 1 frame
    end; //with
  end;
  //----------
begin
  if Form1.Subtitles.NbSub < 1 then Exit;

  Screen.Cursor := crHourglass; //Hourglass cursor on
  try
    if Unit07.TCMsToMSec(GetTimeOffset) > 0 then ApplyTimeOffset(GetTimeOffset);
    if Unit07.TCMsToMSec(GetTimeStretch) > 0 then ApplyTimeStretch(GetTimeStretch);
    if CheckBoxSubDuration.Checked then ApplySubDuration;
    if Word_uMinInterval.valeur > 0 then ApplyMinInterval;
    if CheckBoxTimeAuthor.Checked then CorrectTCforAuthoring;
    Form3.AddAllSubTitles;
  finally
    Screen.Cursor := crDefault; //Hourglass cursor off
  end;
end;

procedure TForm14.ApplyTimeOffset(TmpTimeOffset: TTimeCodeMs);
var
  WNbSup: Word;
  LOffMSec: Integer;
  LStartTime: Integer;
  LStopTime: Integer;
  LNewStartTime: Integer;
  LNewStopTime: Integer;
  Minus: Integer;
  //----------
  function AllowDec(TmpTCMs: TTimeCodeMs): Boolean;
  begin
//    Result := MessageBox(Handle, PChar(MsgStr[31] + ' ' + Unit07.TCmsToStr(TmpTCMs) +
//      ' ' + MsgStr[32] + #13 + MsgStr[33]), PChar(MsgStr[71]), MB_YESNO or MB_ICONWARNING) = IDYES;
    Result := WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[31] + ' ' + Unit07.TCmsToStr(TmpTCMs) +
      ' ' + MsgStr[32] + #13 + MsgStr[33], mtWarning, [mbYes, mbNo], 0) = mrYes;
  end;
  //----------
begin
  if CheckBoxMinusOffset.Checked then Minus := -1 else Minus := 1;
  LOffMSec := Unit07.TCMsToMSec(TmpTimeOffset) * Minus;
  with Form1.Subtitles do
    for WNbSup := 1 to NbSub do
    begin
      LStartTime := Unit07.TCMsToMSec(Sub[WNbSup].StartTC);
      LStopTime := Unit07.TCMsToMSec(Sub[WNbSup].StopTC);
      LNewStartTime := LStartTime + LOffMSec;
      LNewStopTime := LStopTime + LOffMSec;
      if LNewStartTime > 0 then Sub[WNbSup].StartTC := Unit07.MSecToTCMs(LNewStartTime)
      else if AllowDec(Sub[WNbSup].StartTC) then Sub[WNbSup].StartTC := NulTimeCodeMs
      else Break;
      if LNewStopTime < 0 then LNewStopTime := 0;
      Sub[WNbSup].StopTC := Unit07.MSecToTCMs(LNewStopTime);
    end;
end;

procedure TForm14.ApplyTimeStretch(TmpTimeStretch: TTimeCodeMs);
var
  WNbSup: Word;
  LStretchMSec: Integer;
  LTotalDurationMSec: Integer;
  LRatio: Variant; //Nombre de ms  ajouter pour chaque ms
  LStartTime: Integer;
  LStopTime: Integer;
  LNewStartTime: Integer;
  LNewStopTime: Integer;
  Minus: Integer;
begin
  if CheckBoxMinusStretch.Checked then Minus := -1 else Minus := 1;
  LStretchMSec := Unit07.TCMsToMSec(TmpTimeStretch);
  LTotalDurationMSec := Unit07.TCMsToMSec(Form1.Subtitles.Sub[Form1.Subtitles.NbSub].StartTC);
  if (LStretchMSec > LTotalDurationMSec) and (Minus = -1) then
  begin
//    MessageBox(Handle, PChar(MsgStr[34] + #13 + MsgStr[35]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
    WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[34] + #13 + MsgStr[35], mtWarning, [mbOk], 0);
    Exit;
  end;

  LRatio := LStretchMSec / LTotalDurationMSec; //Nombre de ms  ajouter pour chaque ms
  LRatio := LRatio * Minus;

  with Form1.Subtitles do
    for WNbSup := 1 to NbSub do
    begin
      LStartTime := Unit07.TCMsToMSec(Sub[WNbSup].StartTC);
      LStopTime := Unit07.TCMsToMSec(Sub[WNbSup].StopTC);
      //LRatio
      LNewStartTime := LStartTime + (LRatio * LStartTime);
      LNewStopTime := LStopTime + (LRatio * LStopTime);
      Sub[WNbSup].StartTC := Unit07.MSecToTCMs(LNewStartTime);
      Sub[WNbSup].StopTC := Unit07.MSecToTCMs(LNewStopTime);
    end;
end;

procedure TForm14.ApplySubDuration;
var
  WNbSup: Word;
  WNbLine: Byte;
  WNbChar: Word;
  WOffDur: Word;
  WPropDur: Word;
  LStartTime: Integer;
  LNextStartTime: Integer;
  LNewStopTime: Integer;
begin
  case RadioGroupTime.ItemIndex of
    0: begin WOffDur := Word_uFixedDuration.Valeur; WPropDur := 0; end;
    1: begin WOffDur := Word_uOffsetDuration.Valeur; WPropDur := Word_uMsPerChar.Valeur; end;
  end;

  with Form1.Subtitles do
    for WNbSup := 1 to NbSub do
    begin
      WNbChar := 0;
      for WNbLine := 1 to Sub[WNbSup].NbLine do Inc(WNbChar, Length(Sub[WNbSup].Line[WNbLine]));
      LStartTime := Unit07.TCMsToMSec(Sub[WNbSup].StartTC);
      if WNbSup < NbSub then LNextStartTime := Unit07.TCMsToMSec(Sub[WNbSup + 1].StartTC)
      else LNextStartTime := Unit07.TCMsToMSec(Sub[WNbSup].StartTC) + 65535;
      LNewStopTime := LStartTime + WOffDur + (WNbChar * WPropDur);

      if LNewStopTime < LNextStartTime then Sub[WNbSup].StopTC := Unit07.MSecToTCMs(LNewStopTime)
      else Sub[WNbSup].StopTC := Unit07.MSecToTCMs(LNextStartTime);
    end;
end;

procedure TForm14.ApplyMinInterval;
var
  WNbSup: Word;
begin
  with Form1.Subtitles do
    for WNbSup := 1 to NbSub do
      if (WNbSup < NbSub) then
        Sub[WNbSup].StopTc := Form3.ForceMinInterMs(Sub[WNbSup].StopTc, Sub[WNbSup + 1].StartTC, Word_uMinInterval.Valeur);
end;

procedure TForm14.FormShow(Sender: TObject);
begin
  ButtonResetOffsetClick(Sender);
  ButtonResetStretchClick(Sender);
  CheckBoxSubDuration.Checked := False;
end;

procedure TForm14.RadioGroupTimeClick(Sender: TObject);
begin
  PanelFixedTime.Visible := False;
  PanelProportionalTime.Visible := False;
  case RadioGroupTime.ItemIndex of
    0: PanelFixedTime.Visible := True;
    1: PanelProportionalTime.Visible := True;
  end;
end;

end.
