{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit17;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Unit01, Word_u, TntDialogs, TntForms,
  TntButtons, TntStdCtrls, TntExtCtrls, TntSysUtils;

type
  TForm17 = class(TTntForm)
    Panel1: TTntPanel;
    Label1: TTntLabel;
    PanelStartSplit: TTntPanel;
    Word_uHour1: TWord_u;
    Label6: TTntLabel;
    Word_uMin1: TWord_u;
    Label8: TTntLabel;
    Word_uSec1: TWord_u;
    Label9: TTntLabel;
    Word_uMSec1: TWord_u;
    ButtonResetStartSplit: TTntButton;
    CheckBoxSplit: TTntCheckBox;
    PanelStopSplit: TTntPanel;
    Word_uHour2: TWord_u;
    Label2: TTntLabel;
    Word_uMin2: TWord_u;
    Label3: TTntLabel;
    Word_uSec2: TWord_u;
    Label4: TTntLabel;
    Word_uMSec2: TWord_u;
    ButtonEndOfFile: TTntButton;
    Label5: TTntLabel;
    Label7: TTntLabel;
    Panel4: TTntPanel;
    BitBtn1: TTntBitBtn;
    SpeedButtonCopyStopToStart: TTntSpeedButton;
    Label10: TTntLabel;
    Label11: TTntLabel;
    Label12: TTntLabel;
    Label13: TTntLabel;
    Label14: TTntLabel;
    ShapeFullFile: TTntShape;
    LabelBeginOfFile: TTntLabel;
    LabelEndOfFile: TTntLabel;
    ShapeSplitFill: TTntShape;
    LabelBarStart: TTntLabel;
    LabelStartSplit: TTntLabel;
    LabelBarStop: TTntLabel;
    LabelStopSplit: TTntLabel;
    ButtonOpenAVI: TTntButton;
    OpenAvi: TTntOpenDialog;
    procedure CheckBoxSplitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButtonCopyStopToStartClick(Sender: TObject);
    procedure ButtonResetStartSplitClick(Sender: TObject);
    procedure ButtonEndOfFileClick(Sender: TObject);
    procedure Word_uHour1Change(Sender: TObject);
    procedure ButtonOpenAVIClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    EndOfFileTC: TTimeCodeMs;
    procedure SetTimeStart(TmpTCMs: TTimeCodeMs);
    function GetTimeStart: TTimeCodeMs;
    procedure SetTimeStop(TmpTCMs: TTimeCodeMs);
    function GetTimeStop: TTimeCodeMs;
    procedure RefreshShape(TmpTimeStart, TmpTimeStop, TmpEndOfFile: TTimeCodeMs);
  end;

var
  Form17: TForm17;

implementation

uses Unit03, Unit07;

{$R *.DFM}

procedure TForm17.CheckBoxSplitClick(Sender: TObject);
begin
  PanelStartSplit.Enabled := CheckBoxSplit.Checked;
  PanelStopSplit.Enabled := CheckBoxSplit.Checked;
  SpeedButtonCopyStopToStart.Enabled := CheckBoxSplit.Checked;
  ButtonOpenAVI.Enabled := CheckBoxSplit.Checked;
  if CheckBoxSplit.Checked then RefreshShape(GetTimeStart, GetTimeStop, EndOfFileTC)
  else RefreshShape(NulTimeCodeMs, EndOfFileTC, EndOfFileTC);
end;

procedure TForm17.FormShow(Sender: TObject);
begin
  if Form1.Subtitles.NbSub > 0 then EndOfFileTC := Form1.Subtitles.Sub[Form1.Subtitles.NbSub].StopTC
  else EndOfFileTC := NulTimeCodeMs;

  CheckBoxSplit.Checked := Form3.TxtFile.Split;
  SetTimeStart(Form3.TxtFile.SplitStart);
  SetTimeStop(Form3.TxtFile.SplitStop);
  CheckBoxSplitClick(Sender);
end;

procedure TForm17.BitBtn1Click(Sender: TObject);
var
  UpdateRequired: Boolean;
begin
  if CheckBoxSplit.Checked and
    (Unit07.TCMsToMSec(GetTimeStart) > Unit07.TCMsToMSec(GetTimeStop)) then
  begin
//    MessageBox(Handle, PChar(MsgStr[37]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
    WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[37], mtWarning, [mbOk], 0);
    Exit;
  end;
  UpdateRequired := Form3.TxtFile.Split or CheckBoxSplit.Checked;
  Form3.TxtFile.Split := CheckBoxSplit.Checked;
  Form3.TxtFile.SplitStart := GetTimeStart;
  Form3.TxtFile.SplitStop := GetTimeStop;
  Close;
  if UpdateRequired then Form3.AddAllSubTitles;
end;

procedure TForm17.SetTimeStart(TmpTCMs: TTimeCodeMs);
begin
  Word_uHour1.Valeur := TmpTCMs.Hour;
  Word_uMin1.Valeur := TmpTCMs.Min;
  Word_uSec1.Valeur := TmpTCMs.Sec;
  Word_uMSec1.Valeur := TmpTCMs.Ms;
end;

function TForm17.GetTimeStart: TTimeCodeMs;
begin
  Result.Hour := Word_uHour1.Valeur;
  Result.Min := Word_uMin1.Valeur;
  Result.Sec := Word_uSec1.Valeur;
  Result.Ms := Word_uMSec1.Valeur;
end;

procedure TForm17.SetTimeStop(TmpTCMs: TTimeCodeMs);
begin
  Word_uHour2.Valeur := TmpTCMs.Hour;
  Word_uMin2.Valeur := TmpTCMs.Min;
  Word_uSec2.Valeur := TmpTCMs.Sec;
  Word_uMSec2.Valeur := TmpTCMs.Ms;
end;

function TForm17.GetTimeStop: TTimeCodeMs;
begin
  Result.Hour := Word_uHour2.Valeur;
  Result.Min := Word_uMin2.Valeur;
  Result.Sec := Word_uSec2.Valeur;
  Result.Ms := Word_uMSec2.Valeur;
end;

procedure TForm17.SpeedButtonCopyStopToStartClick(Sender: TObject);
begin
  SetTimeStart(GetTimeStop);
end;

procedure TForm17.ButtonResetStartSplitClick(Sender: TObject);
begin
  SetTimeStart(NulTimeCodeMs);
end;

procedure TForm17.ButtonEndOfFileClick(Sender: TObject);
begin
  SetTimeStop(EndOfFileTC);
end;

procedure TForm17.RefreshShape(TmpTimeStart, TmpTimeStop, TmpEndOfFile: TTimeCodeMs);
var
  CStart, CStop, CEndOfFile: Integer;
  CCoef: Integer;
begin
  CStart := Unit07.TCMsToMsec(TmpTimeStart) div 1000;
  CStop := Unit07.TCMsToMsec(TmpTimeStop) div 1000;
  CEndOfFile := Unit07.TCMsToMsec(TmpEndOfFile) div 1000;
  if CEndOfFile = 0 then begin CEndOfFile := 1; CStop := 1; end;
  if CStart > CEndOfFile then CStart := CEndOfFile;
  if CStop > CEndOfFile then CStop := CEndOfFile;
  if CStop < CStart then CStop := CStart;

  CCoef := (ShapeFullFile.Width * 1000000) div CEndOfFile;
  ShapeSplitFill.Left := ShapeFullFile.Left + ((CCoef * CStart) div 1000000);
  ShapeSplitFill.Width := (CCoef * (CStop - CStart)) div 1000000;

  LabelBarStart.Left := ShapeSplitFill.Left;
  LabelBarStop.Left := ShapeSplitFill.Left + ShapeSplitFill.Width;

  LabelEndOfFile.Caption := Unit07.TCMsToStr(TmpEndOfFile);
  LabelStartSplit.Caption := Unit07.TCMsToStr(TmpTimeStart);
  LabelStopSplit.Caption := Unit07.TCMsToStr(TmpTimeStop);

  LabelStartSplit.Left := ShapeSplitFill.Left - (LabelStartSplit.Width div 2);
  LabelStopSplit.Left := ShapeSplitFill.Left + ShapeSplitFill.Width - (LabelStopSplit.Width div 2);
end;

procedure TForm17.Word_uHour1Change(Sender: TObject);
begin
  RefreshShape(GetTimeStart, GetTimeStop, EndOfFileTC);
end;

//Added by MJQ (subrip@divx.pl)

procedure TForm17.ButtonOpenAVIClick(Sender: TObject);
var
  AVIFile: file of Byte;
  Scale, Rate, Pom, Avi: Integer;
  Frames, kfps: Integer;
  S, FileName, FileName2, FileNamePart01, FileNamePart02: Widestring;
  //----------
  procedure ResetDefault;
  begin
    Form3.TxtFile.Split := False;
    Form3.AddAllSubTitles;
    Form3.SetFileName(FileName);
    Form3.TxtFile.SplitStart := NulTimeCodeMs;
    Form3.TxtFile.SplitStop := NulTimeCodeMs;
    SetTimeStart(NulTimeCodeMs);
    SetTimeStop(NulTimeCodeMs);
    CheckBoxSplit.Checked := False;
  end;
  //----------
begin
  //Store original file name
  FileName := Form3.TxtFile.FileName;
  FileName := ExtractFileName(FileName);
  FileName := Copy(FileName, 1, Length(FileName) - Length(ExtractFileExt(FileName)));

  SetTimeStart(NulTimeCodeMs);
  SetTimeStop(NulTimeCodeMs);
  Form3.TxtFile.SplitStart := NulTimeCodeMs;
  Form3.TxtFile.SplitStop := NulTimeCodeMs;

  if OpenAvi.Execute then
  begin
    if FileExists(OpenAvi.FileName) then
    try
      OpenAvi.InitialDir := WideExtractFilePath(OpenAvi.FileName);
      Frames := 0;
      Scale := 0;
      Rate := 0;
      FileMode := 0;
{$I-}
      AssignFile(AVIFile, OpenAvi.FileName);
      Reset(AVIFile);
      if IOResult = 0 then
      begin
        Seek(AviFile, 8);
        BlockRead(AviFile, Avi, 3);
        //Check Avi File
        if Avi <> 4806209 then begin
          CloseFile(AVIFile); //must be, otherwise stay AVI opened
          ResetDefault;
//          MessageBox(Handle, PChar(MsgStr[61]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
          WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[61], mtWarning, [mbOk], 0);
          Exit;
        end;
        //Read info from AVI file
        Seek(AVIFile, 48);
        BlockRead(AVIFile, Frames, 4);
        Seek(AVIFile, 128);
        BlockRead(AVIFile, Scale, 4);
        BlockRead(AVIFile, Rate, 4);
        CloseFile(AVIFile);
      end;
{$I+}
      Str((Rate / Scale): 0: 4, S);
      while (S[Length(S)] = '0') and (Length(S) > 1) and (S[Length(S) - 1] <> '.') do
        Delete(S, Length(S), 1);
      Pom := 0;
      if Pos('.', s) > 0 then pom := Pos('.', s);
      if Pos(',', s) > 0 then pom := Pos(',', s);
      if pom > 0
        then kFPS := StrToInt(Copy(s, 1, pom - 1)) * 1000 +
        StrToInt(Copy(s, pom + 1, Length(s) - pom))
      else kFPS := 1000 * StrToInt(s);
      SetTimeStop(Unit07.FrameToTCMs(IntToStr(Frames), kFps));
    except
      ResetDefault;
//      MessageBox(Handle, PChar(MsgStr[61]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
      WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[61], mtWarning, [mbOk], 0);
      Exit;
    end;
  end
  else begin
    ResetDefault;
    Exit;
  end;

  if Form1.SubTitles.NbSub > 0 then begin
    if Unit07.TCMsToMSec(GetTimeStop) > Unit07.TCMsToMSec(Form1.SubTitles.Sub[Form1.SubTitles.NbSub].StartTC) then
    begin
      ResetDefault;
//      MessageBox(Handle, PChar(MsgStr[62]), PChar(MsgStr[71]), MB_OK or MB_ICONWARNING);
      WideMessageDlg(MsgStr[71] + #13#10 + MsgStr[62], mtWarning, [mbOk], 0);
      Exit;
    end;

    BitBtn1.Enabled:=false;
    ButtonOpenAvi.Enabled:=false;

    //First part
    Form3.TxtFile.Split := True;
    Form3.TxtFile.SplitStart := GetTimeStart;
    Form3.TxtFile.SplitStop := GetTimeStop;
    Form3.AddAllSubTitles;

    FileName2:=OpenAvi.FileName;
    FileName2 := Copy(FileName2, 1, Length(FileName2) - Length(ExtractFileExt(FileName2)));
    //Add to file name " Part01"
    Form3.SetFileName(FileName2 + ' Part01.'+Form3.SaveDialogText.DefaultExt);
    Form3.SaveDialogText.Tag:=1;//prevent automatic renaming

    //Save first part
    Form3.SaveAsClick(Sender);
    if Form3.SaveDialogText.FileName = '' then begin
      ResetDefault;
      BitBtn1.Enabled:=true;
      ButtonOpenAVI.Enabled := CheckBoxSplit.Checked;
      Exit;
    end
    //Store first part name
    else FileNamePart01 := Form3.SaveDialogText.FileName;

    //Second part
    Form3.TxtFile.SplitStart := GetTimeStop;
    Form3.TxtFile.SplitStop := EndOfFileTC;
    Form3.AddAllSubTitles;

    //Add to file name " Part02"
    Form3.SetFileName(FileName2 + ' Part02.'+Form3.SaveDialogText.DefaultExt);
    Form3.SaveDialogText.Tag:=1;//prevent automatic renaming

    //Save second part
    Form3.Show;
    Form3.SaveAsClick(Sender);
    if Form3.SaveDialogText.FileName = '' then begin
      ResetDefault;
      BitBtn1.Enabled:=true;
      ButtonOpenAVI.Enabled := CheckBoxSplit.Checked;
      Exit;
    end

    //Store second part name
    else FileNamePart02 := Form3.SaveDialogText.FileName;

    //Save ok
//    MessageBox(Handle, PChar(MsgStr[63] + #13 + '"' + FileNamePart01 + '", "' +
//      FileNamePart02 + '"'), PChar(MsgStr[73]), MB_OK or MB_ICONINFORMATION);
    WideMessageDlg(MsgStr[73] + #13#10 + MsgStr[63] + #13 + '"' + FileNamePart01 + '", "' +
      FileNamePart02 + '"', mtInformation, [mbOk], 0);
    ResetDefault;
    BitBtn1.Enabled:=true;
    ButtonOpenAVI.Enabled := CheckBoxSplit.Checked;
    Close;
  end
  else ResetDefault;
  BitBtn1.Enabled:=true;
  ButtonOpenAVI.Enabled := CheckBoxSplit.Checked;
end;

end.
