{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit18;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, ComCtrls, Unit01, Mask, Spin,
  TntDialogs, TntButtons, TntExtCtrls, TntStdCtrls, TntComCtrls, TntForms;

type
  TForm18 = class(TTntForm)
    PageControlBmpAdjustment: TTntPageControl;
    TabSheetProfiles: TTntTabSheet;
    TabSheetCropping: TTntTabSheet;
    Timer1: TTimer;
    ColorDialogBmp: TColorDialog;
    TabSheetPositioning: TTntTabSheet;
    CheckBoxAllowBmpCropping: TTntCheckBox;
    GroupBoxSizeConstraints: TTntGroupBox;
    Label9: TTntLabel;
    Label10: TTntLabel;
    Label11: TTntLabel;
    Label12: TTntLabel;
    SpinEditMinX: TSpinEdit;
    SpinEditMinY: TSpinEdit;
    SpinEditDivX: TSpinEdit;
    SpinEditDivY: TSpinEdit;
    TabSheetColor: TTntTabSheet;
    ButtonSaveBMP: TTntButton;
    GroupBoxProfile: TTntGroupBox;
    Label18: TTntLabel;
    ButtonSaveProfile: TTntButton;
    ButtonLoadProfile: TTntButton;
    LabelCurrentProfile: TTntLabel;
    OpenDialogBMPProfiles: TTntOpenDialog;
    SaveDialogBMPProfiles: TTntSaveDialog;
    GroupBoxCropPosition: TTntGroupBox;
    Label13: TTntLabel;
    Label14: TTntLabel;
    RadioGroupHAlignment: TTntRadioGroup;
    RadioGroupVAlignment: TTntRadioGroup;
    SpinEditXShift: TSpinEdit;
    SpinEditYShift: TSpinEdit;
    RadioGroupPresetPaletteIndex: TTntRadioGroup;
    ComboBoxBitPerPixel: TTntComboBox;
    GroupBoxClrCtr: TTntGroupBox;
    LabelClr1: TTntLabel;
    LabelClr2: TTntLabel;
    LabelClr3: TTntLabel;
    LabelClr4: TTntLabel;
    CheckBoxCustom: TTntCheckBox;
    JvSpinEdit1: TSpinEdit;
    ShapeColor1: TTntShape;
    ShapeColor2: TTntShape;
    ShapeColor3: TTntShape;
    ShapeColor4: TTntShape;
    JvSpinEdit2: TSpinEdit;
    JvSpinEdit3: TSpinEdit;
    JvSpinEdit4: TSpinEdit;
    CheckBoxAllowPositionChange: TTntCheckBox;
    GroupBoxTopPosition: TTntGroupBox;
    Label16: TTntLabel;
    SpinEditTopPosition: TSpinEdit;
    SpinEditAddTopPos: TSpinEdit;
    RadioButtonCenterTopPos: TTntRadioButton;
    RadioButtonOriginalTopPos: TTntRadioButton;
    RadioButtonSetTopPos: TTntRadioButton;
    RadioButtonBottomTopPos: TTntRadioButton;
    GroupBoxLeftPosition: TTntGroupBox;
    Label17: TTntLabel;
    SpinEditLeftPosition: TSpinEdit;
    SpinEditAddLeftPos: TSpinEdit;
    RadioButtonCenterLeftPos: TTntRadioButton;
    RadioButtonOriginalLeftPos: TTntRadioButton;
    RadioButtonSetLeftPos: TTntRadioButton;
    RadioButtonRightLeftPos: TTntRadioButton;
    PanelBottom: TTntPanel;
    ButtonReduceWindow: TTntButton;
    BitBtn1: TTntBitBtn;
    ButtonSkipPict: TTntButton;
    GroupBoxSizeDivPos: TTntGroupBox;
    SpinEditDivL: TSpinEdit;
    SpinEditDivT: TSpinEdit;
    LabelDivT: TTntLabel;
    LabelDivL: TTntLabel;
    CheckBoxCompress: TTntCheckBox;
    procedure ButtonReduceWindowClick(Sender: TObject);
    procedure CheckBoxAllowBmpCroppingClick(Sender: TObject);
    procedure CheckBoxAllowPositionChangeClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioGroupPresetPaletteIndexClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonSaveBMPClick(Sender: TObject);
    procedure ButtonSaveProfileClick(Sender: TObject);
    procedure ButtonLoadProfileClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ButtonSkipPictClick(Sender: TObject);
    procedure CheckBoxCustomClick(Sender: TObject);
    procedure ShapeColor1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    FullRgn, TabRgn: THandle;
    AllowRefresh: Boolean;
    CanSavePicture: Boolean;
    ShowSettings: Boolean;
    Form3State: Boolean;

    procedure SetAllValues;
    procedure StoreAllValues;
    procedure UpdateOutBmpPalette;
    procedure RefreshBMP;
    procedure StoreCroppingValues;
    procedure StoreColorValues;    
    procedure StorePositionValues;
  end;

var
  Form18: TForm18;

implementation

uses Unit03, Unit06, Unit07, Unit08, Unit13, UGraph, UConfig;

{$R *.DFM}

//------------------------------------------------------------------------------

procedure TForm18.CheckBoxAllowBmpCroppingClick(Sender: TObject);
begin
  GroupBoxSizeConstraints.Visible := CheckBoxAllowBmpCropping.Checked;
  GroupBoxCropPosition.Visible := CheckBoxAllowBmpCropping.Checked;
  GroupBoxSizeDivPos.Visible := CheckBoxAllowBmpCropping.Checked;
  if AllowRefresh then
  begin
    StoreCroppingValues;
    RefreshBMP;
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.CheckBoxCustomClick(Sender: TObject);
begin
  GroupBoxClrCtr.Visible := CheckBoxCustom.Checked;
  if AllowRefresh then
  begin
    StoreColorValues;
    UpdateOutBmpPalette; RefreshBMP;
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.CheckBoxAllowPositionChangeClick(Sender: TObject);
begin
  GroupBoxTopPosition.Visible := CheckBoxAllowPositionChange.Checked;
  GroupBoxLeftPosition.Visible := CheckBoxAllowPositionChange.Checked;
  if AllowRefresh then
  begin
    StorePositionValues;
    RefreshBMP;
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.StoreCroppingValues; //11 values
begin
  with Form1.BMPOut do
  begin
    CropBMP.Enabled := CheckBoxAllowBmpCropping.Checked; //1 (CheckBox)

    CropBMP.MinX := SpinEditMinX.Value; //2-5 (GroupBox1)
    CropBMP.MinY := SpinEditMinY.Value;
    CropBMP.DivX := SpinEditDivX.Value;
    CropBMP.DivY := SpinEditDivY.Value;

    CropBMP.XPosMode := RadioGroupHAlignment.ItemIndex; //6-9 (GroupBox2)
    CropBMP.YPosMode := RadioGroupVAlignment.ItemIndex;
    CropBMP.PosShift.X := SpinEditXShift.Value;
    CropBMP.PosShift.Y := SpinEditYShift.Value;

    CropBMP.DivL := SpinEditDivL.Value; //10-11 (GroupBox3)
    CropBMP.DivT := SpinEditDivT.Value;
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.StoreColorValues; //11 values
begin
  with Form1.BMPOut do
  begin
    Color.Custom := CheckBoxCustom.Checked; //1 (CheckBox)

    Color.CustColors[0] := ShapeColor1.Brush.Color; //4
    Color.CustColors[1] := ShapeColor2.Brush.Color;
    Color.CustColors[2] := ShapeColor3.Brush.Color;
    Color.CustColors[3] := ShapeColor4.Brush.Color;

    Color.CustContrast[0] := JvSpinEdit1.Value; //4
    Color.CustContrast[1] := JvSpinEdit2.Value;
    Color.CustContrast[2] := JvSpinEdit3.Value;
    Color.CustContrast[3] := JvSpinEdit4.Value;

    if ComboBoxBitPerPixel.ItemIndex = 1 then //1
      Color.BitPerPixel := pf8bit
    else Color.BitPerPixel := pf4bit;
    Color.Compress := CheckBoxCompress.Checked; //1
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.StorePositionValues; //15 values
begin
  with Form1.BMPOut do
  begin
    Position.Enabled := CheckBoxAllowPositionChange.Checked; //1 (CheckBox)

    if RadioButtonOriginalLeftPos.Checked then Position.XPosMode := 0; //5 RadioButtons Left
    if RadioButtonCenterLeftPos.Checked then Position.XPosMode := 1;
    if RadioButtonRightLeftPos.Checked then Position.XPosMode := 2;
    if RadioButtonSetLeftPos.Checked then Position.XPosMode := 3;

    if RadioButtonOriginalTopPos.Checked then Position.YPosMode := 0; //5 RadioButtons Top
    if RadioButtonCenterTopPos.Checked then Position.YPosMode := 1;
    if RadioButtonBottomTopPos.Checked then Position.YPosMode := 2;
    if RadioButtonSetTopPos.Checked then Position.YPosMode := 3;

    Position.SetTo.X := SpinEditLeftPosition.Value; //4 SpinEdits - Position
    Position.SetTo.Y := SpinEditTopPosition.Value;
    Position.PosShift.X := SpinEditAddLeftPos.Value;
    Position.PosShift.Y := SpinEditAddTopPos.Value;
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.RefreshBMP;
var
  TmpCoord: TRect;
begin
  TmpCoord := UGraph.AdjustBMP(Unit08.DCSQTArr.SP_DCSQT[1].PicCoord);
  Form1.ShowPicture(Form1.OutBmp, TmpCoord, True);
end;

//------------------------------------------------------------------------------

procedure TForm18.FormShow(Sender: TObject);
begin
  AllowRefresh := False; //Avoid refreshing BMP after each value change
  CanSavePicture := True;
  Form3State := Form3.Visible; Form3.Hide;
  Timer1.Enabled := True;

  //change settings according to output format
  case Form3.TxtFile.OutputFormat of
    OFIAuthor: RadioGroupPresetPaletteIndex.ItemIndex := 0;
    OFPhilips: RadioGroupPresetPaletteIndex.ItemIndex := 1;
    OFSonic: RadioGroupPresetPaletteIndex.ItemIndex := 2;
    OFDVDMaestro: RadioGroupPresetPaletteIndex.ItemIndex := 4;
    OFImpre: RadioGroupPresetPaletteIndex.ItemIndex := 5;
  else RadioGroupPresetPaletteIndex.ItemIndex := 3; //default + OFSST
  end;
  Form1.BMPOutLast := RadioGroupPresetPaletteIndex.ItemIndex;

  SetAllValues;
  CheckBoxAllowBmpCroppingClick(Sender);
  CheckBoxCustomClick(Sender);
  CheckBoxAllowPositionChangeClick(Sender);
  if Form1.BMPOutLast in [1, 3, 4] then
    ComboBoxBitPerPixel.Enabled := True //Philips, SST, Mae
  else ComboBoxBitPerPixel.Enabled := False;
  AllowRefresh := True;
end;

//------------------------------------------------------------------------------

procedure TForm18.FormDestroy(Sender: TObject);
begin
  //Clean up the regions we created
  DeleteObject(FullRgn);
  DeleteObject(TabRgn);
end;

//------------------------------------------------------------------------------

procedure TForm18.Timer1Timer(Sender: TObject);
var
  W1: Word;
begin
  Timer1.Enabled := False;
  for W1 := PageControlBmpAdjustment.Width - 1 downto 0 do
    if PageControlBmpAdjustment.Canvas.Pixels[W1, 10] = 0 then Break;
  if (W1 < 150) or (W1 > ClientWidth) then W1 := ClientWidth; //avoid bugging if Black pixel not found
  FullRgn := CreateRectRgn(0, 20, ClientWidth, ClientHeight);
  TabRgn := CreateRoundRectRgn(0, 1, W1 + 4, 22, 5, 5);
  CombineRgn(FullRgn, FullRgn, TabRgn, RGN_OR);
  SetWindowRgn(Handle, FullRgn, TRUE);
end;

//------------------------------------------------------------------------------
//store all values from controls to BMPOut + BMPOutPreset

procedure TForm18.StoreAllValues;
begin
  StoreCroppingValues; //cropping part
  StoreColorValues; //color part
  StorePositionValues; //position part

  Form1.BMPOutPreset[Form1.BMPOutLast] := Form1.BMPOut;
  Form1.BMPOutLast := RadioGroupPresetPaletteIndex.ItemIndex;
end;

//------------------------------------------------------------------------------
//write all values from BMPOut + BMPOutPreset to controls + update Picture

procedure TForm18.SetAllValues;
begin
  Form1.BMPOut := Form1.BMPOutPreset[RadioGroupPresetPaletteIndex.ItemIndex];
  AllowRefresh := False;

  with Form1.BMPOut do
  begin
    //cropping part
    CheckBoxAllowBmpCropping.Checked := CropBMP.Enabled;
    SpinEditMinX.Value := CropBMP.MinX;
    SpinEditMinY.Value := CropBMP.MinY;
    SpinEditDivX.Value := CropBMP.DivX;
    SpinEditDivY.Value := CropBMP.DivY;
    RadioGroupHAlignment.ItemIndex := CropBMP.XPosMode;
    RadioGroupVAlignment.ItemIndex := CropBMP.YPosMode;
    SpinEditXShift.Value := CropBMP.PosShift.X;
    SpinEditYShift.Value := CropBMP.PosShift.Y;
    SpinEditDivL.Value := CropBMP.DivL;
    SpinEditDivT.Value := CropBMP.DivT;

    //color part
    CheckBoxCustom.Checked := Color.Custom;
    ShapeColor1.Brush.Color := Color.CustColors[0];
    ShapeColor2.Brush.Color := Color.CustColors[1];
    ShapeColor3.Brush.Color := Color.CustColors[2];
    ShapeColor4.Brush.Color := Color.CustColors[3];
    JvSpinEdit1.Value := Color.CustContrast[0];
    JvSpinEdit2.Value := Color.CustContrast[1];
    JvSpinEdit3.Value := Color.CustContrast[2];
    JvSpinEdit4.Value := Color.CustContrast[3];
    case Color.BitPerPixel of
      pf4bit: ComboBoxBitPerPixel.ItemIndex := 0;
      pf8bit: ComboBoxBitPerPixel.ItemIndex := 1;
    end;
    CheckBoxCompress.Checked := Color.Compress;

    //position part
    CheckBoxAllowPositionChange.Checked := Position.Enabled;
    case Position.XPosMode of
      0: RadioButtonOriginalLeftPos.Checked := True;
      1: RadioButtonCenterLeftPos.Checked := True;
      2: RadioButtonRightLeftPos.Checked := True;
      3: RadioButtonSetLeftPos.Checked := True;
    end;
    case Position.YPosMode of
      0: RadioButtonOriginalTopPos.Checked := True;
      1: RadioButtonCenterTopPos.Checked := True;
      2: RadioButtonBottomTopPos.Checked := True;
      3: RadioButtonSetTopPos.Checked := True;
    end;
    SpinEditLeftPosition.Value := Position.SetTo.X;
    SpinEditTopPosition.Value := Position.SetTo.Y;
    SpinEditAddLeftPos.Value := Position.PosShift.X;
    SpinEditAddTopPos.Value := Position.PosShift.Y;
  end;

  case RadioGroupPresetPaletteIndex.ItemIndex of
    0: Form3.TxtFile.OutputFormat := OFIAuthor;
    1: Form3.TxtFile.OutputFormat := OFPhilips;
    2: Form3.TxtFile.OutputFormat := OFSonic;
    3: Form3.TxtFile.OutputFormat := OFSST;
    4: Form3.TxtFile.OutputFormat := OFDVDMaestro;
    5: Form3.TxtFile.OutputFormat := OFImpre;
  end;
  Form13.FormShow(nil);
  Form13.BitBtnConvertClick(nil);

  AllowRefresh := True;
  UpdateOutBmpPalette; RefreshBMP;
end;

//------------------------------------------------------------------------------

procedure TForm18.RadioGroupPresetPaletteIndexClick(Sender: TObject);
begin
  if AllowRefresh then
  begin
    StoreAllValues; //from controls to BMPOut + BMPOutPreset
    SetAllValues; //write all values from BMPOutPreset[selected] to controls
  end;
  if Form1.BMPOutLast in [1, 3, 4] then
    ComboBoxBitPerPixel.Enabled := True //Philips, SST, Mae
  else ComboBoxBitPerPixel.Enabled := False;
end;

//------------------------------------------------------------------------------

procedure TForm18.FormCreate(Sender: TObject);
begin
  PageControlBmpAdjustment.ActivePage := TabSheetColor;
end;

//------------------------------------------------------------------------------

procedure TForm18.UpdateOutBmpPalette;
var
  NewPal: TMaxLogPalette;
  pfc: Byte;
  I, ClearFrom: Byte;
begin
  Form1.OutBmp.PixelFormat := Form1.BMPOut.Color.BitPerPixel;
  if Form1.OutBmp.PixelFormat = pf4bit then pfc := 15 else pfc := 255;
  //update OutBmp palette
  NewPal.palNumEntries := pfc + 1;
  NewPal.palVersion := $0300;

  if Form1.BMPOutLast in [3, 4] then //SST, Mae (RKBW)
  begin
    NewPal.palpalEntry[0].peRed := $FF; //b commonly (but p in SST, Mae)
    NewPal.palpalEntry[0].peGreen := $00;
    NewPal.palpalEntry[0].peBlue := $00;
    NewPal.palpalEntry[0].peFlags := PC_RESERVED;
    NewPal.palpalEntry[1].peRed := $00; //p (but e1)
    NewPal.palpalEntry[1].peGreen := $00;
    NewPal.palpalEntry[1].peBlue := $00;
    NewPal.palpalEntry[1].peFlags := PC_RESERVED;
    NewPal.palpalEntry[2].peRed := $00; //e1 (but e2)
    NewPal.palpalEntry[2].peGreen := $00;
    NewPal.palpalEntry[2].peBlue := $FF;
    NewPal.palpalEntry[2].peFlags := PC_RESERVED;
    NewPal.palpalEntry[3].peRed := $FF; //e2 (but b)
    NewPal.palpalEntry[3].peGreen := $FF;
    NewPal.palpalEntry[3].peBlue := $FF;
    NewPal.palpalEntry[3].peFlags := PC_RESERVED;
    ClearFrom := 4;
  end
  else
    if Form1.BMPOut.Color.Custom then
    begin
      for I := 0  to 3 do
      begin
        NewPal.palpalEntry[I].peRed := GetRValue(Form1.BMPOut.Color.CustColors[I]); //b
        NewPal.palpalEntry[I].peGreen := GetGValue(Form1.BMPOut.Color.CustColors[I]);
        NewPal.palpalEntry[I].peBlue := GetBValue(Form1.BMPOut.Color.CustColors[I]);
        NewPal.palpalEntry[I].peFlags := PC_RESERVED;
      end;
      ClearFrom := 4;
    end
    else //not custom = original colors
    begin
      for I := 0 to 15 do
      begin
        NewPal.palpalEntry[I].peRed := GetRValue(Form1.Process.Palette[I]);
        NewPal.palpalEntry[I].peGreen := GetGValue(Form1.Process.Palette[I]);
        NewPal.palpalEntry[I].peBlue := GetBValue(Form1.Process.Palette[I]);
        NewPal.palpalEntry[I].peFlags := PC_RESERVED;
      end;
      ClearFrom := 16;
    end;

  for I := ClearFrom to pfc do //why? Look the jungle that D produces
  begin
    NewPal.palpalEntry[I].peRed := 0;
    NewPal.palpalEntry[I].peGreen := 0;
    NewPal.palpalEntry[I].peBlue := 0;
    NewPal.palpalEntry[I].peFlags := PC_RESERVED;
  end;
  Form1.OutBmp.Palette := CreatePalette(pLogPalette(@NewPal)^);
end;

//------------------------------------------------------------------------------

procedure TForm18.ButtonSaveBMPClick(Sender: TObject);
begin
  SaveDialogBMPProfiles.Title := MsgStr[43];
  SaveDialogBMPProfiles.Filter := 'Bitmap File (*.bmp)|*.bmp|All|*.*';
  SaveDialogBMPProfiles.DefaultExt := 'bmp';
  SaveDialogBMPProfiles.FileName := '';
  if SaveDialogBMPProfiles.Execute then
    Unit07.SaveBmp(Form1.OutBmp, SaveDialogBMPProfiles.FileName);
end;

//------------------------------------------------------------------------------

procedure TForm18.ButtonSaveProfileClick(Sender: TObject);
begin
  SaveDialogBMPProfiles.Title := MsgStr[44];
  SaveDialogBMPProfiles.Filter := 'SubRip BMP Settings File (*.ini)|*.ini|All|*.*';
  SaveDialogBMPProfiles.DefaultExt := 'ini';
  SaveDialogBMPProfiles.InitialDir := AppzDir;
  SaveDialogBMPProfiles.FileName := '';
  if SaveDialogBMPProfiles.Execute then
  begin
    StoreAllValues; //update active settings to BMPOutPreset[active]
    LabelCurrentProfile.Caption := ExtractFileName(SaveDialogBMPProfiles.FileName);
    UConfig.SaveBMPProfile(SaveDialogBMPProfiles.FileName); //save current BMP settings under a profile file
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.ButtonLoadProfileClick(Sender: TObject);
begin
  OpenDialogBMPProfiles.Title := MsgStr[45];
  OpenDialogBMPProfiles.Filter := 'SubRip BMP Settings File (*.ini)|*.ini|All|*.*';
  OpenDialogBMPProfiles.DefaultExt := 'ini';
  OpenDialogBMPProfiles.InitialDir := AppzDir;
  if OpenDialogBMPProfiles.Execute then
  begin
    LabelCurrentProfile.Caption := ExtractFileName(OpenDialogBMPProfiles.FileName);
    UConfig.LoadBMPProfile(OpenDialogBMPProfiles.FileName); //load BMP settings from a profile file

    AllowRefresh := False; //Avoid refreshing BMP for each values change
    SetAllValues; //Write all values in controls from the settings
    CheckBoxAllowBmpCroppingClick(Sender);
    CheckBoxAllowPositionChangeClick(Sender);
    AllowRefresh := True;
    UpdateOutBmpPalette; RefreshBMP;
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.BitBtn1Click(Sender: TObject);
begin
  ShowSettings := False;
  StoreAllValues;
  if Form3State and not Form1.CLI.Wanted then Form3.Show; //restore the form3 (text) State
end;

//------------------------------------------------------------------------------

procedure TForm18.ButtonSkipPictClick(Sender: TObject);
begin
  CanSavePicture := False;
  StoreAllValues;
  Close;
end;

//------------------------------------------------------------------------------

procedure TForm18.ButtonReduceWindowClick(Sender: TObject);
begin
  PanelBottom.SetFocus;
  if ClientWidth < PageControlBmpAdjustment.Width then
  begin
    ClientWidth := PageControlBmpAdjustment.Width;
    ClientHeight := PageControlBmpAdjustment.Height + PanelBottom.Height;
    PageControlBmpAdjustment.Visible := True;
    ButtonReduceWindow.Caption := ''; //Double upper arrows
  end
  else
  begin
    PageControlBmpAdjustment.Visible := False;
    ClientWidth := PanelBottom.Height;
    ClientHeight := PanelBottom.Height + 2;
    ButtonReduceWindow.Caption := ''; //Double lower arrows
  end;
end;

//------------------------------------------------------------------------------

procedure TForm18.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    ReleaseCapture;
    TWinControl(Self).Perform(WM_SysCommand, $F012, 0);
  end;
end;

procedure TForm18.ShapeColor1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  With Sender as TTntShape Do
    Begin
      ColorDialogBmp.Color:= Brush.Color;
      If ColorDialogBmp.Execute Then Brush.Color:= ColorDialogBmp.Color;
    End;
  CheckBoxCustomClick(Sender);
end;

end.
