{  ----------------- SubRip 1.17 source -------------------
                  Copyright (C) 2002 Brain

                  www.subrip.fr.st
                  submagic@netcourrier.com

          See Unit01.pas for licence information.
}
unit Unit19;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons, ComCtrls, Gauges, TntButtons, TntStdCtrls, TntForms,
  TntSysUtils, TntClasses;

const
  UM_VERIFY = WM_USER + $1002;

type
  TForm19 = class(TTntForm)
    BitBtnCancel: TTntBitBtn;
    GaugeVerify: TGauge;
    LabelCurrentFile: TTntLabel;
    procedure FormShow(Sender: TObject);
    procedure BitBtnCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure VerifyStreams(var Message: TMessage); message UM_VERIFY;
  public
    { Public declarations }
  end;

var
  Form19: TForm19;
  AbortVerify: Boolean;

implementation

uses Unit01, Unit06;

{$R *.dfm}

procedure TForm19.FormShow(Sender: TObject);
begin
  Caption := '';
  PostMessage(Handle, UM_VERIFY, 0, 0);
end;

procedure TForm19.VerifyStreams(var Message: TMessage);
var
  I: Integer;
  J, dummy: Byte;
  F: TFileStream;
  Buf: array[0..279] of Byte;
  LngYes: array[0..31] of Boolean;
  VerifyStL: TTntStringList;
  VerifySearch: TSearchRecW;
  VerifySize, VerifySize1prc, VerifyProgress: Int64;
  //----------
  function Get4Bytes(WOffset: Word): Integer;
  var
    Bcode: array[0..3] of Byte absolute Result;
  begin
    Bcode[3] := Buf[WOffset];
    Bcode[2] := Buf[WOffset + 1];
    Bcode[1] := Buf[WOffset + 2];
    Bcode[0] := Buf[WOffset + 3];
  end;
  //----------
begin
  AbortVerify := False;
  for I := 0 to 31 do LngYes[I] := False;
  VerifySize := 0; VerifyProgress := 0; GaugeVerify.Progress := 0;
  VerifyStL := TTntStringList.Create;

  try
    for I := 0 to Form6.StL.Count - 1 do
      if Form6.CheckListBoxVob.Checked[I] then
        if WideFindFirst(Form6.StL[I], faAnyFile, VerifySearch) = 0 then
          repeat
            //files > 4 GB
            Inc(VerifySize, Int64(VerifySearch.FindData.nFileSizeHigh) shl 32 +
              Int64(VerifySearch.FindData.nFileSizeLow));
            VerifyStL.Add(Form6.StL[I]);
          until WideFindNext(VerifySearch) <> 0;
    VerifySize1prc := 2048 * (VerifySize div (2048 * 100));
    //hoax: needid only in case of .sub filesize < 204800 B
    if VerifySize1prc = 0 then VerifySize1prc := 2048;
  finally
    WideFindClose(VerifySearch);
  end;

  for I := 0 to VerifyStL.Count - 1 do
  begin
    F := TFileStream.Create(VerifyStL[I], fmOpenRead or fmShareDenyWrite);
    try
      F.Position := 0;
      LabelCurrentFile.Caption := ExtractFileName(VerifyStL[I]);
      while (F.Read(Buf, 280) = 280) and not AbortVerify do
      begin
        if (Get4Bytes(0) = $000001BA) and
          (Get4Bytes(14) = $000001BD) and
          (Buf[23 + Buf[22]] < $40) then
          LngYes[Buf[23 + Buf[22]] - $20] := True; //$20 ~ 0-31
        F.Seek(2048 - 280, soCurrent);
        if ((F.Position + VerifyProgress) mod VerifySize1prc
          = 0) then
        begin
          GaugeVerify.Progress := GaugeVerify.Progress + 1;
          dummy := 0;
          for J := 0 to 31 do
            if LngYes[J] then Inc(dummy);
          Caption := IntToStr(dummy) + ' ' + MsgStr[12];
          Application.ProcessMessages;
        end;
      end;
      Inc(VerifyProgress, F.Position);
    finally
      F.Free;
    end //try
  end;

  //hoax: needid only in case of .sub filesize < 204800 B
  GaugeVerify.Progress := 100;

  VerifyStL.Free;
  for I := 0 to 31 do if LngYes[I]
    then
    begin
      if Form6.SubLanguage[I] = ''
        then Form6.SubLanguage[I] := '???'
      else
        if not (Form6.SubLanguage[I][1] in [WideChar('~'), WideChar('?')])
          then Insert('~', Form6.SubLanguage[I], 1);
    end
    else Form6.SubLanguage[I] := '';
  Close;
  Form6.RefreshLanguageList;
end;

procedure TForm19.BitBtnCancelClick(Sender: TObject);
begin
  AbortVerify := True;
end;

procedure TForm19.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  AbortVerify := True;
end;

end.
